# =========================================================================
#
# Error handling
#

proc do_stop {} {
	global maininfo
	set maininfo(stopnow) 1
}
proc do_cleanup {} {
	global iutinfo specinfo sidinfo pcoinfo
	catch {send_error "Cleaning up in do_cleanup\n"}
#	exp_internal 1
	uttrace_file_close
	foreach i $pcoinfo(pcos) {
		if {[info exists sidinfo(iut,$i)]} {
			set sid $sidinfo(iut,$i)
			catch {unset sidinfo(iut,$i)}
			catch {send_error "Closing PCO $i\n"}
			if {![catch {set pid [exp_pid -i $sid]} foo]} {
				catch {
					close -i $sid
					# wait -i $sid
				}
			} else {
				catch {send_error "oops: $foo\n"}
 			}
		}
	}
#	exp_internal 1
	if {[info exists sidinfo(iut,stderr)]} {
		set timeout 2
		expect {
			-i $sidinfo(iut,stderr) eof {
				send_error "IUT stderr eof\n"
				send_error "IUT stderr buffer: $expect_out(buffer)\n"
			}
		}	
	}
}
proc clean_exit { {r 0} } {
	do_cleanup
	exit $r
}
proc to_user { prefix s } {
	# send_user "to_user: $prefix $s\n"
	set buf $s
	while {[regexp -- "^(\[^\n\r\]*)\r*\n(.*)$" $buf match line rest ]} {
		send_error "$prefix$line\n"
		set buf $rest
	}
	if {![string match $buf ""]} {
		send_error "$prefix$buf\n"
	}
}
proc do_output { prefix s } {
	set l [string length $s]
	if {$l != 0} {
		if {[string compare [string index $s [expr $l - 1]] "\n"] == 0} {
			send_error "$prefix$s"
		} else {
			send_error "$prefix$s\n"
		}
	}
}
proc fatal { {s ""} } {
	do_output "Fatal: " $s
	set timeout 1
	catch { expect } ;# HACK to get rid of errors 'spawn id ... not open'
	clean_exit 1
}
### WARNING: 'error' is a Tcl command, so we don't
### use that; instead we use 'nonfatal'!!
proc nonfatal { {s ""} } {
	do_output "Error: " $s
}
proc warning { {s ""} } {
	do_output "Warning: " $s
}
proc debug { lvl {s ""} } {
	global maininfo
	if {$maininfo(debug) > $lvl} {
		do_output "DEBUG: " $s
	}
}

# =========================================================================
