# Based on:
# B. Welch "Practical Programming in Tcl and Tk", 3rd edition, page 175

proc mstimer_calibrate {delay} {
	global mstimer
	set mstimer(init,clicks) [clock clicks]
	set mstimer(init,seconds) [clock seconds]
	set t1 $mstimer(init,clicks)
	after [expr $delay]
	set t2 [clock clicks]
	set clicks_per_millisecond [expr ($t2 - $t1) / $delay]
	set mstimer(factor) $clicks_per_millisecond
	return $mstimer(factor)
}

proc mstimer_start {} {
	global mstimer
	set mstimer(start,clicks) [clock clicks]
	set mstimer(start,seconds) [clock seconds]
	return [list $mstimer(start,seconds) $mstimer(start,clicks)]
}
proc mstimer_stop {} {
	global mstimer
	set mstimer(stop,clicks) [clock clicks]
	set mstimer(stop,seconds) [clock seconds]
	set sec [expr ($mstimer(stop,seconds) - $mstimer(start,seconds))]
	set ms [expr ($mstimer(stop,clicks) - $mstimer(start,clicks)) / $mstimer(factor)]
	return [list $sec $ms]
}
proc mstimer_cur {} {
	global mstimer
	set curms [clock clicks]
	set msall [expr ($curms - $mstimer(init,clicks)) / $mstimer(factor) ]
	set ms [expr $msall % 1000 ]
	set cursec [clock seconds]
	set secall [expr $cursec - $mstimer(init,seconds) ]
	set fsec [clock format $cursec]
	return [list $fsec $ms $secall $msall]
}
