#
# jararaca.pm - mkprimer module for the aut explorer, with the generic primer
# will be ``required'' by the mkprimer program
#
# $Id: jararaca.pm,v 1.1.2.2 2006/01/24 22:01:43 belinfan Exp $
# <Axel.Belinfante@cs.utwente.nl>, 1999
#
#
# ======================================
package jararaca;

%suffix = (
			".tp"     =>   "TP",
			".jrrc"     =>   "JARARACA",
	     );

%lang = (
	"TP" =>
	 sub  {
		my($specfile, $target, $prefix, $libdir,
		   $specpath, $specname, $specsuffix, $exesuffix, $paramsref) = @_;
		my(%params) = %$paramsref;
		my($flag) = "-f $params{config}" if $params{config} ne "";
		my(@cmds) = (
			"echo '#!/bin/sh' > $target",
			"echo exec primer $flag \\\"\\\$@\\\" jararaca -s -e -l EPSILON $specfile >> $target",
			"chmod 755 $target",
		          );
		::Exec(@cmds);
	},
	"JARARACA" =>
	 sub  {
		my($specfile, $target, $prefix, $libdir,
		   $specpath, $specname, $specsuffix, $exesuffix, $paramsref) = @_;
		my(%params) = %$paramsref;
		my($flag) = "-f $params{config}" if $params{config} ne "";
		my(@cmds) = (
			"echo '#!/bin/sh' > $target",
			"echo exec primer $flag \\\"\\\$@\\\" jararaca -s -e $specfile >> $target",
			"chmod 755 $target",
		          );
		::Exec(@cmds);
	},
);

::Register(\%lang, \%suffix);

1;
