#
# ltsa.pm - mkprimer module for the ltsa psf explorer, with the generic primer
# will be ``required'' by the mkprimer program
#
# $Id: ltsa.pm,v 1.1.2.2 2003/03/26 13:18:27 belinfan Exp $
# <Axel.Belinfante@cs.utwente.nl>, 1999
#
#
# ======================================
package ltsa;

%suffix = (
			".lts"     =>   "FSP",
	     );

%lang = (
	"FSP" =>
	 sub  {
		my($specfile, $target, $prefix, $libdir,
		   $specpath, $specname, $specsuffix, $exesuffix, $paramsref) = @_;
		my(%params) = %$paramsref;
		my($flag) = "-f $params{config}" if $params{config} ne "";
		my(@cmds) = (
			"echo '#!/bin/sh' > $target",
			"echo exec primer $flag \\\"\\\$@\\\" ltsaexp $specfile >> $target",
			"chmod 755 $target",
		          );
		::Exec(@cmds);
	},
);

::Register(\%lang, \%suffix);

1;
