import java.io.*;
import java.util.*;

public class TorxTransition {
	int number;
	TorxState src;
	TorxState dst;
	String label;

	public TorxTransition(TorxState s, TorxState d, String l, int nr) {
		number = nr;
		src = s;
		dst = d;
		label = l;
		d.incoming(this);
	}
	
	public int number() {
		return number;
	}
	public String label() {
		return label;
	}
	public TorxState src() {
		return src;
	}
	public TorxState dst() {
		return dst;
	}
	public String nr() {
		return "e" + number();
	}


	public String unparse() {
		String res = "Ee";
		res += "\t";
		res += dst().nr() + "_" + nr() + "." + number;  // id
		res += "\t";
		res += (label == "tau" ? 0 : 1);	// visible
		res += "\t";
		res += 1;							//  preds_solved
		res += "\t";
		res += replaceDots(label); 			//label
		res += "\t";
		/*EMPTY*/							// predicates
		res += "\t";
		/*EMPTY*/							// free variables
		res += "\t";
		if (dst.incoming() != this)
			res += dst().nr() + "_" + nr() + "." + dst.incoming().number();
		return res;
	}
	
	private String replaceDots(String s) {
		StringTokenizer st = new StringTokenizer(s, ".");
		String res = "";
		if (st.hasMoreTokens())
		   	res += st.nextToken();
		while (st.hasMoreTokens()) {
			res += "!";
		   	res += st.nextToken();
		}
		return res;
	}

}
