#
# mcrl2.pm - mkprimer module for the mcrl2 explorer, with the generic primer
# will be ``required'' by the mkprimer program
#
# $Id: mcrl2.pm,v 1.1.2.1 2006/01/14 21:50:54 belinfan Exp $
# <Axel.Belinfante@cs.utwente.nl>, 2006
#
#
# ======================================
package aut;

%suffix = (
			".mcrl2"     =>   "MCRL2",
	     );

%lang = (
	"MCRL2" =>
	 sub  {
		my($specfile, $target, $prefix, $libdir,
		   $specpath, $specname, $specsuffix, $exesuffix, $paramsref) = @_;
		my(%params) = %$paramsref;
		my($flag) = "-f $params{config}" if $params{config} ne "";
		my(@cmds) = (
			"mcrl22lpe < $specfile > $specpath$specname.lpe",
			"echo '#!/bin/sh' > $target",
			"echo exec primer $flag \\\"\\\$@\\\" lpe2torx $specpath$specname.lpe >> $target",
			"chmod 755 $target",
		          );
		::Exec(@cmds);
	},
);

::Register(\%lang, \%suffix);

1;
