#! @PERL@
#
# $Id: log2jararacy.pl,v 1.1.2.8 2004/05/28 20:38:40 belinfan Exp $
#
# usage: log2jararacy [ -p pattern ] [-p pattern] ... [ files ]
#

require 5.002;
use Getopt::Long;

$debug = 0;
$| = 1; # do not buffer!

%optcl = ();
$result = GetOptions(
			\%optcl,
			"p=s@",
		);

$patlistref = $optcl{"p"} if (defined $optcl{"p"});
@pat = @{$patlistref};

# ======================================

loop:
while(<>) {
	chomp;
	if (/^STATEID/) {
		foreach $pat (@pat) {
			# print STDERR "trying: ($pat)($_)\n";
			if (! /$pat/) {
				print STDERR "no match: ($pat)($_)\n" if $debug;;
				next loop;
			}
		}
		handle($_);
	}
}

sub handle {
	my($line) = @_;
	print STDERR "line: ($line) " if $debug;
	my(@words) = split(/ /, $line);
	my($word, $init, $trans, @init, @trans, $result);
	print STDERR "words: (@words) " if $debug;
	while(@words > 0) {
		$word = shift(@words);
		if ($word eq "init") {
			$init = shift(@words);
		} elsif ($word eq "trans") {
			$trans = shift(@words);
		}
	}
	print STDERR "init: ($init) " if $debug;
	print STDERR "trans: ($trans) " if $debug;
	print STDERR "\n" if $debug;
	$result = '';
	$result .= output('init', $init);
	$result .= output('trans', $trans);
	$result .= "\n";
	print $result;
}

sub output {
	my($name, $statelist) = @_;
	my(@states) = split(',', $statelist);
	my(@words);
	print STDERR "($name, $statelist,(@states))\n" if $debug;
	my($result) = '';
	if (@states > 0) {
		$result .= "$name ";
		foreach $s (@states) {
			if ($s =~ /^s?(S[0-9]+)_([^\.]+)/i) {
				$result .= "node $1 edge $2 ";
			} elsif ($s =~ /^s?(S[0-9]+)/) {
				$result .= "node $1 ";
			} elsif ($s =~ /^(s[0-9]+)/) {
				$result .= "node $1 ";
			} elsif ($s =~ /^(s([c0-9_]+))/) {
				@words = split('_', $2);
				foreach $w (@words) {
					$result .= "$w ";
				}
			}
		}
	}
	return $result;
}
