/*LINTLIBRARY*/
/* translation of file(s)
	"tracer.k"
	"pfunctions.k"
	"krfsm.k"
	"map.k"
	"expand.k"
	"expui.k"
	"intarray.k"
 */
/* generated by:
 *	@(#)$Author: Kimwitu version: V4_5P3 (c) 1990-1996 University of Twente $
 */
#define KC_TYPES
#define KIMW_TYPES /* for backwards compatibility */
/* define our own macro if we have a 'standard' (ansi) C(++) compiler */
#ifndef KC_NO_STDC
# if defined(__STDC__) || defined(__cplusplus) || defined(_WIN32)
#  define KC_STDC
# endif
#endif
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#if ((! defined(KC_STDC) ) && defined(sun))
   extern char *sprintf();
#endif
#include <sys/types.h>
#ifdef KC_STDC
# include <stdlib.h>
#else
#  include <memory.h> /*for memset*/
#endif
typedef size_t kc_memset_size_t; /* needed for sun */

#include "k.h"
#ifndef KC_STDC
  extern void exit KC__P((int));
#endif

#if ((! defined(KC_STDC) ) && defined(sun))
  /* kc_memset_firstarg_t should be void* kc_voidptr_t, but sun's include files are dumb */
# ifndef KC_MEMSET_FIRSTARG_T
  typedef char *kc_memset_firstarg_t;
# else
  typedef KC_MEMSET_FIRSTARG_T kc_memset_firstarg_t;
# endif
#else
  typedef kc_voidptr_t kc_memset_firstarg_t;
#endif

static kc_voidfnptr_t kc_out_of_storage_handler = 0;
kc_voidfnptr_t kc_set_out_of_storage_handler
#ifdef KC_USE_PROTOTYPES
( kc_voidfnptr_t kc_handler )
#else
(kc_handler) kc_voidfnptr_t kc_handler;
#endif
{	kc_voidfnptr_t kc_tmp_handler = kc_out_of_storage_handler;
	kc_out_of_storage_handler = kc_handler;
	return kc_tmp_handler;
}

kc_voidptr_t emalloc	/* check return from malloc */
#ifdef KC_USE_PROTOTYPES
(kc_size_t kc_n)
#else
(kc_n) kc_size_t kc_n;
#endif
{	kc_voidptr_t kc_p;
	while ((kc_p = (kc_voidptr_t)malloc((kc_size_t)kc_n)) == 0) {
		if (kc_out_of_storage_handler) {
			(*kc_out_of_storage_handler)();
		} else {
			(void)fflush(stdout);
			(void)fprintf(stderr,"out of memory in emalloc\n");
			exit( 1 ); /*NOTREACHED*/
	}	}
	return kc_p;
}

kc_voidptr_t ecalloc	/* check return from calloc */
#ifdef KC_USE_PROTOTYPES
(kc_size_t kc_n, kc_size_t kc_s)
#else
(kc_n,kc_s) kc_size_t kc_n, kc_s;
#endif
{	kc_voidptr_t kc_p;
	while ((kc_p = (kc_voidptr_t)calloc((kc_size_t)kc_n,(kc_size_t)kc_s)) == 0) {
		if (kc_out_of_storage_handler) {
			(*kc_out_of_storage_handler)();
		} else {
			(void)fflush(stdout);
			(void)fprintf(stderr,"out of memory in ecalloc\n");
			exit( 1 ); /*NOTREACHED*/
	}	}
	return kc_p;
}

kc_voidptr_t erealloc	/* check return from realloc */
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_r, kc_size_t kc_s)
#else
(kc_r,kc_s) kc_voidptr_t kc_r; kc_size_t kc_s;
#endif
{	kc_voidptr_t kc_p;
	while ((kc_p = (kc_voidptr_t)realloc((kc_realloc_arg_t)kc_r,(kc_size_t)kc_s)) == 0) {
		if (kc_out_of_storage_handler) {
			(*kc_out_of_storage_handler)();
		} else {
			(void)fflush(stdout);
			(void)fprintf(stderr,"out of memory in erealloc\n");
			exit( 1 ); /*NOTREACHED*/
	}	}
	return kc_p;
}

void kc_bzero
#ifdef KC_USE_PROTOTYPES
(register char *kc_p, register int kc_s)
#else
(kc_p,kc_s) register char *kc_p; register int kc_s;
#endif
{	while (kc_s--) {
		*kc_p++ = '\0';
	}
}

static void kc_copy_attributes_decl
#ifdef KC_USE_PROTOTYPES
(decl kc_p1, decl kc_p2)
#else
(kc_p1, kc_p2) decl kc_p1, kc_p2;
#endif
{
	kc_p2->set = kc_p1->set;
	kc_p2->eventidx = kc_p1->eventidx;
}
static void kc_copy_attributes_expr
#ifdef KC_USE_PROTOTYPES
(expr kc_p1, expr kc_p2)
#else
(kc_p1, kc_p2) expr kc_p1, kc_p2;
#endif
{
	kc_p2->parent = kc_p1->parent;
}
static void kc_copy_attributes_id
#ifdef KC_USE_PROTOTYPES
(id kc_p1, id kc_p2)
#else
(kc_p1, kc_p2) id kc_p1, kc_p2;
#endif
{
	kc_p2->lineno = kc_p1->lineno;
	kc_p2->column = kc_p1->column;
}
static void kc_copy_attributes_uid
#ifdef KC_USE_PROTOTYPES
(uid kc_p1, uid kc_p2)
#else
(kc_p1, kc_p2) uid kc_p1, kc_p2;
#endif
{
	kc_p2->ast = kc_p1->ast;
	kc_p2->lineno = kc_p1->lineno;
	kc_p2->column = kc_p1->column;
}
static void kc_copy_attributes_idx2event
#ifdef KC_USE_PROTOTYPES
(idx2event kc_p1, idx2event kc_p2)
#else
(kc_p1, kc_p2) idx2event kc_p1, kc_p2;
#endif
{
	kc_p2->ast = kc_p1->ast;
}
static void kc_copy_attributes_location
#ifdef KC_USE_PROTOTYPES
(location kc_p1, location kc_p2)
#else
(kc_p1, kc_p2) location kc_p1, kc_p2;
#endif
{
	kc_p2->t = kc_p1->t;
	kc_p2->f = kc_p1->f;
}
static void kc_copy_attributes_transition
#ifdef KC_USE_PROTOTYPES
(transition kc_p1, transition kc_p2)
#else
(kc_p1, kc_p2) transition kc_p1, kc_p2;
#endif
{
	kc_p2->id = kc_p1->id;
	kc_p2->src = kc_p1->src;
	kc_p2->dst = kc_p1->dst;
	kc_p2->E = kc_p1->E;
}
static void kc_copy_attributes_map
#ifdef KC_USE_PROTOTYPES
(map kc_p1, map kc_p2)
#else
(kc_p1, kc_p2) map kc_p1, kc_p2;
#endif
{
	kc_p2->p = kc_p1->p;
}
static void kc_copy_attributes_event
#ifdef KC_USE_PROTOTYPES
(event kc_p1, event kc_p2)
#else
(kc_p1, kc_p2) event kc_p1, kc_p2;
#endif
{
	kc_p2->id = kc_p1->id;
	kc_p2->from = kc_p1->from;
	kc_p2->succ = kc_p1->succ;
	kc_p2->t = kc_p1->t;
}
static void kc_copy_attributes_state
#ifdef KC_USE_PROTOTYPES
(state kc_p1, state kc_p2)
#else
(kc_p1, kc_p2) state kc_p1, kc_p2;
#endif
{
	kc_p2->id = kc_p1->id;
}
KC_PHYLUM_INFO kc_PhylumInfo[] = {
	{ "", 0, kc_one_before_first_operator, kc_one_before_first_operator, (kc_storageclass_t)0, 0 }, /* dummy element */
	{ "nocasestring", sizeof(struct kc_tag_nocasestring), sel_NoCaseStr, sel_NoCaseStr, uniq, 0 },
	{ "casestring", sizeof(struct kc_tag_casestring), sel__Str, sel__Str, uniq, 0 },
	{ "float", sizeof(float), sel__Real, sel__Real, uniq, 0 },
	{ "int", sizeof(int), sel__Int, sel__Int, uniq, 0 },
	{ "voidptr", sizeof(voidptr), sel__VoidPtr, sel__VoidPtr, uniq, 0 },
	{ "spec", sizeof(struct kc_tag_spec), sel_Spec, sel_Spec, kc_not_uniq, 0 },
	{ "decllist", sizeof(struct kc_tag_decllist), sel_Nildecllist, sel_Consdecllist, kc_not_uniq, 0 },
	{ "decl", sizeof(struct kc_tag_decl), sel_ASet, sel_Action, kc_not_uniq, KC__C((void(*)(kc_voidptr_t, kc_voidptr_t)))kc_copy_attributes_decl },
	{ "asslist", sizeof(struct kc_tag_asslist), sel_Nilasslist, sel_Consasslist, kc_not_uniq, 0 },
	{ "assign", sizeof(struct kc_tag_assign), sel_Assign, sel_Assign, kc_not_uniq, 0 },
	{ "expr", sizeof(struct kc_tag_expr), sel_Dconcat, sel_Const, kc_not_uniq, KC__C((void(*)(kc_voidptr_t, kc_voidptr_t)))kc_copy_attributes_expr },
	{ "freq", sizeof(struct kc_tag_freq), sel_LFreq, sel_IFreq, kc_not_uniq, 0 },
	{ "id", sizeof(struct kc_tag_id), sel_Id, sel_Id, kc_not_uniq, KC__C((void(*)(kc_voidptr_t, kc_voidptr_t)))kc_copy_attributes_id },
	{ "idtype", sizeof(struct kc_tag_idtype), sel_IdTypeAssign, sel_IdTypeDecl, kc_not_uniq, 0 },
	{ "uid", sizeof(struct kc_tag_uid), sel_Uid, sel_Uid, uniq, KC__C((void(*)(kc_voidptr_t, kc_voidptr_t)))kc_copy_attributes_uid },
	{ "idx2event", sizeof(struct kc_tag_idx2event), sel_IndexMap, sel_IndexMap, uniq, KC__C((void(*)(kc_voidptr_t, kc_voidptr_t)))kc_copy_attributes_idx2event },
	{ "transitions", sizeof(struct kc_tag_transitions), sel_Niltransitions, sel_Constransitions, kc_not_uniq, 0 },
	{ "locations", sizeof(struct kc_tag_locations), sel_Nillocations, sel_Conslocations, kc_not_uniq, 0 },
	{ "location", sizeof(struct kc_tag_location), sel_Location, sel_Location, uniq, KC__C((void(*)(kc_voidptr_t, kc_voidptr_t)))kc_copy_attributes_location },
	{ "transition", sizeof(struct kc_tag_transition), sel_TrExternal, sel_TrInternal, kc_not_uniq, KC__C((void(*)(kc_voidptr_t, kc_voidptr_t)))kc_copy_attributes_transition },
	{ "action", sizeof(struct kc_tag_action), sel_GreaterEqual, sel_Reset, kc_not_uniq, 0 },
	{ "map", sizeof(struct kc_tag_map), sel_MapTransition, sel_MapEvent, uniq, KC__C((void(*)(kc_voidptr_t, kc_voidptr_t)))kc_copy_attributes_map },
	{ "event", sizeof(struct kc_tag_event), sel_Event, sel_RootEvent, kc_not_uniq, KC__C((void(*)(kc_voidptr_t, kc_voidptr_t)))kc_copy_attributes_event },
	{ "visibility", sizeof(struct kc_tag_visibility), sel_Internal, sel_External, kc_not_uniq, 0 },
	{ "events", sizeof(struct kc_tag_events), sel_Nilevents, sel_Consevents, kc_not_uniq, 0 },
	{ "state", sizeof(struct kc_tag_state), sel_State, sel_State, uniq, KC__C((void(*)(kc_voidptr_t, kc_voidptr_t)))kc_copy_attributes_state },
	{ "label", sizeof(struct kc_tag_label), sel_Label, sel_DeclLabel, kc_not_uniq, 0 },
	{ "intarray", sizeof(struct kc_tag_intarray), sel_Nilintarray, sel_Consintarray, uniq, 0 },
	{ "", 0, kc_one_before_first_operator, kc_one_before_first_operator, (kc_storageclass_t)0, 0 } /* last element */
};

static spec kc_opfn_Spec
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, decllist decllist_1, asslist asslist_1, expr expr_1)
#else
(kc_prod_sel, decllist_1, asslist_1, expr_1)kc_enum_operators kc_prod_sel;  decllist decllist_1;  asslist asslist_1;  expr expr_1; 
#endif
{ return Spec(decllist_1, asslist_1, expr_1); }
static decllist kc_opfn_Nildecllist
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel)
#else
(kc_prod_sel)kc_enum_operators kc_prod_sel;
#endif
{ return Nildecllist(); }
static decllist kc_opfn_Consdecllist
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, decl decl_1, decllist decllist_1)
#else
(kc_prod_sel, decl_1, decllist_1)kc_enum_operators kc_prod_sel;  decl decl_1;  decllist decllist_1; 
#endif
{ return Consdecllist(decl_1, decllist_1); }
static decl kc_opfn_ASet
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, id id_1, decllist decllist_1)
#else
(kc_prod_sel, id_1, decllist_1)kc_enum_operators kc_prod_sel;  id id_1;  decllist decllist_1; 
#endif
{ return ASet(id_1, decllist_1); }
static decl kc_opfn_Action
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, id id_1, casestring casestring_1)
#else
(kc_prod_sel, id_1, casestring_1)kc_enum_operators kc_prod_sel;  id id_1;  casestring casestring_1; 
#endif
{ return Action(id_1, casestring_1); }
static asslist kc_opfn_Nilasslist
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel)
#else
(kc_prod_sel)kc_enum_operators kc_prod_sel;
#endif
{ return Nilasslist(); }
static asslist kc_opfn_Consasslist
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, assign assign_1, asslist asslist_1)
#else
(kc_prod_sel, assign_1, asslist_1)kc_enum_operators kc_prod_sel;  assign assign_1;  asslist asslist_1; 
#endif
{ return Consasslist(assign_1, asslist_1); }
static assign kc_opfn_Assign
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, id id_1, expr expr_1)
#else
(kc_prod_sel, id_1, expr_1)kc_enum_operators kc_prod_sel;  id id_1;  expr expr_1; 
#endif
{ return Assign(id_1, expr_1); }
static expr kc_opfn_Dconcat
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, expr expr_1, expr expr_2)
#else
(kc_prod_sel, expr_1, expr_2)kc_enum_operators kc_prod_sel;  expr expr_1;  expr expr_2; 
#endif
{ return Dconcat(expr_1, expr_2); }
static expr kc_opfn_Nconcat
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, expr expr_1, expr expr_2)
#else
(kc_prod_sel, expr_1, expr_2)kc_enum_operators kc_prod_sel;  expr expr_1;  expr expr_2; 
#endif
{ return Nconcat(expr_1, expr_2); }
static expr kc_opfn_Repl
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, expr expr_1, freq freq_1)
#else
(kc_prod_sel, expr_1, freq_1)kc_enum_operators kc_prod_sel;  expr expr_1;  freq freq_1; 
#endif
{ return Repl(expr_1, freq_1); }
static expr kc_opfn_Choice
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, expr expr_1, expr expr_2)
#else
(kc_prod_sel, expr_1, expr_2)kc_enum_operators kc_prod_sel;  expr expr_1;  expr expr_2; 
#endif
{ return Choice(expr_1, expr_2); }
static expr kc_opfn_Const
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, id id_1)
#else
(kc_prod_sel, id_1)kc_enum_operators kc_prod_sel;  id id_1; 
#endif
{ return Const(id_1); }
static freq kc_opfn_LFreq
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, int int_1)
#else
(kc_prod_sel, int_1)kc_enum_operators kc_prod_sel;  int int_1; 
#endif
{ return LFreq(int_1); }
static freq kc_opfn_UFreq
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, int int_1)
#else
(kc_prod_sel, int_1)kc_enum_operators kc_prod_sel;  int int_1; 
#endif
{ return UFreq(int_1); }
static freq kc_opfn_Freq
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, int int_1, int int_2)
#else
(kc_prod_sel, int_1, int_2)kc_enum_operators kc_prod_sel;  int int_1;  int int_2; 
#endif
{ return Freq(int_1, int_2); }
static freq kc_opfn_IFreq
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel)
#else
(kc_prod_sel)kc_enum_operators kc_prod_sel;
#endif
{ return IFreq(); }
static id kc_opfn_Id
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, uid uid_1)
#else
(kc_prod_sel, uid_1)kc_enum_operators kc_prod_sel;  uid uid_1; 
#endif
{ return Id(uid_1); }
static idtype kc_opfn_IdTypeAssign
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, assign assign_1)
#else
(kc_prod_sel, assign_1)kc_enum_operators kc_prod_sel;  assign assign_1; 
#endif
{ return IdTypeAssign(assign_1); }
static idtype kc_opfn_IdTypeDecl
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, decl decl_1)
#else
(kc_prod_sel, decl_1)kc_enum_operators kc_prod_sel;  decl decl_1; 
#endif
{ return IdTypeDecl(decl_1); }
static uid kc_opfn_Uid
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, casestring casestring_1)
#else
(kc_prod_sel, casestring_1)kc_enum_operators kc_prod_sel;  casestring casestring_1; 
#endif
{ return Uid(casestring_1); }
static idx2event kc_opfn_IndexMap
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, int int_1)
#else
(kc_prod_sel, int_1)kc_enum_operators kc_prod_sel;  int int_1; 
#endif
{ return IndexMap(int_1); }
static transitions kc_opfn_Niltransitions
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel)
#else
(kc_prod_sel)kc_enum_operators kc_prod_sel;
#endif
{ return Niltransitions(); }
static transitions kc_opfn_Constransitions
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, transition transition_1, transitions transitions_1)
#else
(kc_prod_sel, transition_1, transitions_1)kc_enum_operators kc_prod_sel;  transition transition_1;  transitions transitions_1; 
#endif
{ return Constransitions(transition_1, transitions_1); }
static locations kc_opfn_Nillocations
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel)
#else
(kc_prod_sel)kc_enum_operators kc_prod_sel;
#endif
{ return Nillocations(); }
static locations kc_opfn_Conslocations
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, location location_1, locations locations_1)
#else
(kc_prod_sel, location_1, locations_1)kc_enum_operators kc_prod_sel;  location location_1;  locations locations_1; 
#endif
{ return Conslocations(location_1, locations_1); }
static location kc_opfn_Location
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, int int_1)
#else
(kc_prod_sel, int_1)kc_enum_operators kc_prod_sel;  int int_1; 
#endif
{ return Location(int_1); }
static transition kc_opfn_TrExternal
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel)
#else
(kc_prod_sel)kc_enum_operators kc_prod_sel;
#endif
{ return TrExternal(); }
static transition kc_opfn_TrInternal
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, action action_1)
#else
(kc_prod_sel, action_1)kc_enum_operators kc_prod_sel;  action action_1; 
#endif
{ return TrInternal(action_1); }
static action kc_opfn_GreaterEqual
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, int int_1, int int_2)
#else
(kc_prod_sel, int_1, int_2)kc_enum_operators kc_prod_sel;  int int_1;  int int_2; 
#endif
{ return GreaterEqual(int_1, int_2); }
static action kc_opfn_Epsilon
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel)
#else
(kc_prod_sel)kc_enum_operators kc_prod_sel;
#endif
{ return Epsilon(); }
static action kc_opfn_Incr
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, int int_1)
#else
(kc_prod_sel, int_1)kc_enum_operators kc_prod_sel;  int int_1; 
#endif
{ return Incr(int_1); }
static action kc_opfn_LessThan
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, int int_1, int int_2)
#else
(kc_prod_sel, int_1, int_2)kc_enum_operators kc_prod_sel;  int int_1;  int int_2; 
#endif
{ return LessThan(int_1, int_2); }
static action kc_opfn_Reset
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, int int_1)
#else
(kc_prod_sel, int_1)kc_enum_operators kc_prod_sel;  int int_1; 
#endif
{ return Reset(int_1); }
static map kc_opfn_MapTransition
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, int int_1)
#else
(kc_prod_sel, int_1)kc_enum_operators kc_prod_sel;  int int_1; 
#endif
{ return MapTransition(int_1); }
static map kc_opfn_MapEvent
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, int int_1)
#else
(kc_prod_sel, int_1)kc_enum_operators kc_prod_sel;  int int_1; 
#endif
{ return MapEvent(int_1); }
static event kc_opfn_Event
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, label label_1, visibility visibility_1, state state_1)
#else
(kc_prod_sel, label_1, visibility_1, state_1)kc_enum_operators kc_prod_sel;  label label_1;  visibility visibility_1;  state state_1; 
#endif
{ return Event(label_1, visibility_1, state_1); }
static event kc_opfn_RootEvent
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, state state_1)
#else
(kc_prod_sel, state_1)kc_enum_operators kc_prod_sel;  state state_1; 
#endif
{ return RootEvent(state_1); }
static visibility kc_opfn_Internal
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel)
#else
(kc_prod_sel)kc_enum_operators kc_prod_sel;
#endif
{ return Internal(); }
static visibility kc_opfn_External
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel)
#else
(kc_prod_sel)kc_enum_operators kc_prod_sel;
#endif
{ return External(); }
static events kc_opfn_Nilevents
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel)
#else
(kc_prod_sel)kc_enum_operators kc_prod_sel;
#endif
{ return Nilevents(); }
static events kc_opfn_Consevents
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, event event_1, events events_1)
#else
(kc_prod_sel, event_1, events_1)kc_enum_operators kc_prod_sel;  event event_1;  events events_1; 
#endif
{ return Consevents(event_1, events_1); }
static state kc_opfn_State
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, location location_1, intarray intarray_1)
#else
(kc_prod_sel, location_1, intarray_1)kc_enum_operators kc_prod_sel;  location location_1;  intarray intarray_1; 
#endif
{ return State(location_1, intarray_1); }
static label kc_opfn_Label
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, action action_1)
#else
(kc_prod_sel, action_1)kc_enum_operators kc_prod_sel;  action action_1; 
#endif
{ return Label(action_1); }
static label kc_opfn_CounterLabel
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, int int_1, action action_1)
#else
(kc_prod_sel, int_1, action_1)kc_enum_operators kc_prod_sel;  int int_1;  action action_1; 
#endif
{ return CounterLabel(int_1, action_1); }
static label kc_opfn_DeclLabel
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, decl decl_1)
#else
(kc_prod_sel, decl_1)kc_enum_operators kc_prod_sel;  decl decl_1; 
#endif
{ return DeclLabel(decl_1); }
static intarray kc_opfn_Nilintarray
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel)
#else
(kc_prod_sel)kc_enum_operators kc_prod_sel;
#endif
{ return Nilintarray(); }
static intarray kc_opfn_Consintarray
#ifdef KC_USE_PROTOTYPES
(kc_enum_operators kc_prod_sel, int int_1, intarray intarray_1)
#else
(kc_prod_sel, int_1, intarray_1)kc_enum_operators kc_prod_sel;  int int_1;  intarray intarray_1; 
#endif
{ return Consintarray(int_1, intarray_1); }

static kc_enum_phyla kc_subphyla_Spec[] = { kc_phylum_decllist, kc_phylum_asslist, kc_phylum_expr };
static kc_enum_phyla kc_subphyla_Consdecllist[] = { kc_phylum_decl, kc_phylum_decllist };
static kc_enum_phyla kc_subphyla_ASet[] = { kc_phylum_id, kc_phylum_decllist };
static kc_enum_phyla kc_subphyla_Action[] = { kc_phylum_id, kc_phylum_casestring };
static kc_enum_phyla kc_subphyla_Consasslist[] = { kc_phylum_assign, kc_phylum_asslist };
static kc_enum_phyla kc_subphyla_Assign[] = { kc_phylum_id, kc_phylum_expr };
static kc_enum_phyla kc_subphyla_Dconcat[] = { kc_phylum_expr, kc_phylum_expr };
static kc_enum_phyla kc_subphyla_Nconcat[] = { kc_phylum_expr, kc_phylum_expr };
static kc_enum_phyla kc_subphyla_Repl[] = { kc_phylum_expr, kc_phylum_freq };
static kc_enum_phyla kc_subphyla_Choice[] = { kc_phylum_expr, kc_phylum_expr };
static kc_enum_phyla kc_subphyla_Const[] = { kc_phylum_id };
static kc_enum_phyla kc_subphyla_LFreq[] = { kc_phylum_int };
static kc_enum_phyla kc_subphyla_UFreq[] = { kc_phylum_int };
static kc_enum_phyla kc_subphyla_Freq[] = { kc_phylum_int, kc_phylum_int };
static kc_enum_phyla kc_subphyla_Id[] = { kc_phylum_uid };
static kc_enum_phyla kc_subphyla_IdTypeAssign[] = { kc_phylum_assign };
static kc_enum_phyla kc_subphyla_IdTypeDecl[] = { kc_phylum_decl };
static kc_enum_phyla kc_subphyla_Uid[] = { kc_phylum_casestring };
static kc_enum_phyla kc_subphyla_IndexMap[] = { kc_phylum_int };
static kc_enum_phyla kc_subphyla_Constransitions[] = { kc_phylum_transition, kc_phylum_transitions };
static kc_enum_phyla kc_subphyla_Conslocations[] = { kc_phylum_location, kc_phylum_locations };
static kc_enum_phyla kc_subphyla_Location[] = { kc_phylum_int };
static kc_enum_phyla kc_subphyla_TrInternal[] = { kc_phylum_action };
static kc_enum_phyla kc_subphyla_GreaterEqual[] = { kc_phylum_int, kc_phylum_int };
static kc_enum_phyla kc_subphyla_Incr[] = { kc_phylum_int };
static kc_enum_phyla kc_subphyla_LessThan[] = { kc_phylum_int, kc_phylum_int };
static kc_enum_phyla kc_subphyla_Reset[] = { kc_phylum_int };
static kc_enum_phyla kc_subphyla_MapTransition[] = { kc_phylum_int };
static kc_enum_phyla kc_subphyla_MapEvent[] = { kc_phylum_int };
static kc_enum_phyla kc_subphyla_Event[] = { kc_phylum_label, kc_phylum_visibility, kc_phylum_state };
static kc_enum_phyla kc_subphyla_RootEvent[] = { kc_phylum_state };
static kc_enum_phyla kc_subphyla_Consevents[] = { kc_phylum_event, kc_phylum_events };
static kc_enum_phyla kc_subphyla_State[] = { kc_phylum_location, kc_phylum_intarray };
static kc_enum_phyla kc_subphyla_Label[] = { kc_phylum_action };
static kc_enum_phyla kc_subphyla_CounterLabel[] = { kc_phylum_int, kc_phylum_action };
static kc_enum_phyla kc_subphyla_DeclLabel[] = { kc_phylum_decl };
static kc_enum_phyla kc_subphyla_Consintarray[] = { kc_phylum_int, kc_phylum_intarray };


#ifndef KC_OFFSETOF
#  define KC_OFFSETOF(kc_record, kc_operator, kc_subphylum) ((kc_size_t) \
   ((char*)(&((kc_record *)0)->u.kc_operator.kc_subphylum) - (char*)((kc_record *)0)))
#endif
static kc_size_t kc_suboffsets_Spec[] = { KC_OFFSETOF( struct kc_tag_spec, Spec, decllist_1 ), KC_OFFSETOF( struct kc_tag_spec, Spec, asslist_1 ), KC_OFFSETOF( struct kc_tag_spec, Spec, expr_1 ) };
static kc_size_t kc_suboffsets_Consdecllist[] = { KC_OFFSETOF( struct kc_tag_decllist, Consdecllist, decl_1 ), KC_OFFSETOF( struct kc_tag_decllist, Consdecllist, decllist_1 ) };
static kc_size_t kc_suboffsets_ASet[] = { KC_OFFSETOF( struct kc_tag_decl, ASet, id_1 ), KC_OFFSETOF( struct kc_tag_decl, ASet, decllist_1 ) };
static kc_size_t kc_suboffsets_Action[] = { KC_OFFSETOF( struct kc_tag_decl, Action, id_1 ), KC_OFFSETOF( struct kc_tag_decl, Action, casestring_1 ) };
static kc_size_t kc_suboffsets_Consasslist[] = { KC_OFFSETOF( struct kc_tag_asslist, Consasslist, assign_1 ), KC_OFFSETOF( struct kc_tag_asslist, Consasslist, asslist_1 ) };
static kc_size_t kc_suboffsets_Assign[] = { KC_OFFSETOF( struct kc_tag_assign, Assign, id_1 ), KC_OFFSETOF( struct kc_tag_assign, Assign, expr_1 ) };
static kc_size_t kc_suboffsets_Dconcat[] = { KC_OFFSETOF( struct kc_tag_expr, Dconcat, expr_1 ), KC_OFFSETOF( struct kc_tag_expr, Dconcat, expr_2 ) };
static kc_size_t kc_suboffsets_Nconcat[] = { KC_OFFSETOF( struct kc_tag_expr, Nconcat, expr_1 ), KC_OFFSETOF( struct kc_tag_expr, Nconcat, expr_2 ) };
static kc_size_t kc_suboffsets_Repl[] = { KC_OFFSETOF( struct kc_tag_expr, Repl, expr_1 ), KC_OFFSETOF( struct kc_tag_expr, Repl, freq_1 ) };
static kc_size_t kc_suboffsets_Choice[] = { KC_OFFSETOF( struct kc_tag_expr, Choice, expr_1 ), KC_OFFSETOF( struct kc_tag_expr, Choice, expr_2 ) };
static kc_size_t kc_suboffsets_Const[] = { KC_OFFSETOF( struct kc_tag_expr, Const, id_1 ) };
static kc_size_t kc_suboffsets_LFreq[] = { KC_OFFSETOF( struct kc_tag_freq, LFreq, int_1 ) };
static kc_size_t kc_suboffsets_UFreq[] = { KC_OFFSETOF( struct kc_tag_freq, UFreq, int_1 ) };
static kc_size_t kc_suboffsets_Freq[] = { KC_OFFSETOF( struct kc_tag_freq, Freq, int_1 ), KC_OFFSETOF( struct kc_tag_freq, Freq, int_2 ) };
static kc_size_t kc_suboffsets_Id[] = { KC_OFFSETOF( struct kc_tag_id, Id, uid_1 ) };
static kc_size_t kc_suboffsets_IdTypeAssign[] = { KC_OFFSETOF( struct kc_tag_idtype, IdTypeAssign, assign_1 ) };
static kc_size_t kc_suboffsets_IdTypeDecl[] = { KC_OFFSETOF( struct kc_tag_idtype, IdTypeDecl, decl_1 ) };
static kc_size_t kc_suboffsets_Uid[] = { KC_OFFSETOF( struct kc_tag_uid, Uid, casestring_1 ) };
static kc_size_t kc_suboffsets_IndexMap[] = { KC_OFFSETOF( struct kc_tag_idx2event, IndexMap, int_1 ) };
static kc_size_t kc_suboffsets_Constransitions[] = { KC_OFFSETOF( struct kc_tag_transitions, Constransitions, transition_1 ), KC_OFFSETOF( struct kc_tag_transitions, Constransitions, transitions_1 ) };
static kc_size_t kc_suboffsets_Conslocations[] = { KC_OFFSETOF( struct kc_tag_locations, Conslocations, location_1 ), KC_OFFSETOF( struct kc_tag_locations, Conslocations, locations_1 ) };
static kc_size_t kc_suboffsets_Location[] = { KC_OFFSETOF( struct kc_tag_location, Location, int_1 ) };
static kc_size_t kc_suboffsets_TrInternal[] = { KC_OFFSETOF( struct kc_tag_transition, TrInternal, action_1 ) };
static kc_size_t kc_suboffsets_GreaterEqual[] = { KC_OFFSETOF( struct kc_tag_action, GreaterEqual, int_1 ), KC_OFFSETOF( struct kc_tag_action, GreaterEqual, int_2 ) };
static kc_size_t kc_suboffsets_Incr[] = { KC_OFFSETOF( struct kc_tag_action, Incr, int_1 ) };
static kc_size_t kc_suboffsets_LessThan[] = { KC_OFFSETOF( struct kc_tag_action, LessThan, int_1 ), KC_OFFSETOF( struct kc_tag_action, LessThan, int_2 ) };
static kc_size_t kc_suboffsets_Reset[] = { KC_OFFSETOF( struct kc_tag_action, Reset, int_1 ) };
static kc_size_t kc_suboffsets_MapTransition[] = { KC_OFFSETOF( struct kc_tag_map, MapTransition, int_1 ) };
static kc_size_t kc_suboffsets_MapEvent[] = { KC_OFFSETOF( struct kc_tag_map, MapEvent, int_1 ) };
static kc_size_t kc_suboffsets_Event[] = { KC_OFFSETOF( struct kc_tag_event, Event, label_1 ), KC_OFFSETOF( struct kc_tag_event, Event, visibility_1 ), KC_OFFSETOF( struct kc_tag_event, Event, state_1 ) };
static kc_size_t kc_suboffsets_RootEvent[] = { KC_OFFSETOF( struct kc_tag_event, RootEvent, state_1 ) };
static kc_size_t kc_suboffsets_Consevents[] = { KC_OFFSETOF( struct kc_tag_events, Consevents, event_1 ), KC_OFFSETOF( struct kc_tag_events, Consevents, events_1 ) };
static kc_size_t kc_suboffsets_State[] = { KC_OFFSETOF( struct kc_tag_state, State, location_1 ), KC_OFFSETOF( struct kc_tag_state, State, intarray_1 ) };
static kc_size_t kc_suboffsets_Label[] = { KC_OFFSETOF( struct kc_tag_label, Label, action_1 ) };
static kc_size_t kc_suboffsets_CounterLabel[] = { KC_OFFSETOF( struct kc_tag_label, CounterLabel, int_1 ), KC_OFFSETOF( struct kc_tag_label, CounterLabel, action_1 ) };
static kc_size_t kc_suboffsets_DeclLabel[] = { KC_OFFSETOF( struct kc_tag_label, DeclLabel, decl_1 ) };
static kc_size_t kc_suboffsets_Consintarray[] = { KC_OFFSETOF( struct kc_tag_intarray, Consintarray, int_1 ), KC_OFFSETOF( struct kc_tag_intarray, Consintarray, intarray_1 ) };


KC_OPERATOR_INFO kc_OperatorInfo[] = {
	{ "", 0, 0, kc_one_before_first_phylum, (kc_enum_phyla_list)0, (kc_size_t_list)0, (kc_storageclass_t)0, 0 }, /* dummy element */
	{ "NoCaseStr", 0, 1, kc_phylum_nocasestring, (kc_enum_phyla_list)0, (kc_size_t_list)0, kc_uniq_nullary_operator, 0 },
	{ "_Str", 0, 1, kc_phylum_casestring, (kc_enum_phyla_list)0, (kc_size_t_list)0, kc_uniq_nullary_operator, 0 },
	{ "_Real", 0, 1, kc_phylum_float, (kc_enum_phyla_list)0, (kc_size_t_list)0, kc_uniq_nullary_operator, 0 },
	{ "_Int", 0, 1, kc_phylum_int, (kc_enum_phyla_list)0, (kc_size_t_list)0, kc_uniq_nullary_operator, 0 },
	{ "_VoidPtr", 0, 1, kc_phylum_voidptr, (kc_enum_phyla_list)0, (kc_size_t_list)0, kc_uniq_nullary_operator, 0 },
	{ "Spec", 3, 0, kc_phylum_spec, kc_subphyla_Spec, kc_suboffsets_Spec, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Spec },
	{ "Nildecllist", 0, 0, kc_phylum_decllist, (kc_enum_phyla_list)0, (kc_size_t_list)0, kc_uniq_nullary_operator, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Nildecllist },
	{ "Consdecllist", 2, 0, kc_phylum_decllist, kc_subphyla_Consdecllist, kc_suboffsets_Consdecllist, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Consdecllist },
	{ "ASet", 2, 0, kc_phylum_decl, kc_subphyla_ASet, kc_suboffsets_ASet, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_ASet },
	{ "Action", 2, 0, kc_phylum_decl, kc_subphyla_Action, kc_suboffsets_Action, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Action },
	{ "Nilasslist", 0, 0, kc_phylum_asslist, (kc_enum_phyla_list)0, (kc_size_t_list)0, kc_uniq_nullary_operator, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Nilasslist },
	{ "Consasslist", 2, 0, kc_phylum_asslist, kc_subphyla_Consasslist, kc_suboffsets_Consasslist, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Consasslist },
	{ "Assign", 2, 0, kc_phylum_assign, kc_subphyla_Assign, kc_suboffsets_Assign, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Assign },
	{ "Dconcat", 2, 0, kc_phylum_expr, kc_subphyla_Dconcat, kc_suboffsets_Dconcat, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Dconcat },
	{ "Nconcat", 2, 0, kc_phylum_expr, kc_subphyla_Nconcat, kc_suboffsets_Nconcat, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Nconcat },
	{ "Repl", 2, 0, kc_phylum_expr, kc_subphyla_Repl, kc_suboffsets_Repl, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Repl },
	{ "Choice", 2, 0, kc_phylum_expr, kc_subphyla_Choice, kc_suboffsets_Choice, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Choice },
	{ "Const", 1, 0, kc_phylum_expr, kc_subphyla_Const, kc_suboffsets_Const, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Const },
	{ "LFreq", 1, 0, kc_phylum_freq, kc_subphyla_LFreq, kc_suboffsets_LFreq, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_LFreq },
	{ "UFreq", 1, 0, kc_phylum_freq, kc_subphyla_UFreq, kc_suboffsets_UFreq, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_UFreq },
	{ "Freq", 2, 0, kc_phylum_freq, kc_subphyla_Freq, kc_suboffsets_Freq, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Freq },
	{ "IFreq", 0, 0, kc_phylum_freq, (kc_enum_phyla_list)0, (kc_size_t_list)0, kc_uniq_nullary_operator, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_IFreq },
	{ "Id", 1, 0, kc_phylum_id, kc_subphyla_Id, kc_suboffsets_Id, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Id },
	{ "IdTypeAssign", 1, 0, kc_phylum_idtype, kc_subphyla_IdTypeAssign, kc_suboffsets_IdTypeAssign, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_IdTypeAssign },
	{ "IdTypeDecl", 1, 0, kc_phylum_idtype, kc_subphyla_IdTypeDecl, kc_suboffsets_IdTypeDecl, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_IdTypeDecl },
	{ "Uid", 1, 0, kc_phylum_uid, kc_subphyla_Uid, kc_suboffsets_Uid, uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Uid },
	{ "IndexMap", 1, 0, kc_phylum_idx2event, kc_subphyla_IndexMap, kc_suboffsets_IndexMap, uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_IndexMap },
	{ "Niltransitions", 0, 0, kc_phylum_transitions, (kc_enum_phyla_list)0, (kc_size_t_list)0, kc_uniq_nullary_operator, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Niltransitions },
	{ "Constransitions", 2, 0, kc_phylum_transitions, kc_subphyla_Constransitions, kc_suboffsets_Constransitions, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Constransitions },
	{ "Nillocations", 0, 0, kc_phylum_locations, (kc_enum_phyla_list)0, (kc_size_t_list)0, kc_uniq_nullary_operator, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Nillocations },
	{ "Conslocations", 2, 0, kc_phylum_locations, kc_subphyla_Conslocations, kc_suboffsets_Conslocations, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Conslocations },
	{ "Location", 1, 0, kc_phylum_location, kc_subphyla_Location, kc_suboffsets_Location, uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Location },
	{ "TrExternal", 0, 0, kc_phylum_transition, (kc_enum_phyla_list)0, (kc_size_t_list)0, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_TrExternal },
	{ "TrInternal", 1, 0, kc_phylum_transition, kc_subphyla_TrInternal, kc_suboffsets_TrInternal, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_TrInternal },
	{ "GreaterEqual", 2, 0, kc_phylum_action, kc_subphyla_GreaterEqual, kc_suboffsets_GreaterEqual, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_GreaterEqual },
	{ "Epsilon", 0, 0, kc_phylum_action, (kc_enum_phyla_list)0, (kc_size_t_list)0, kc_uniq_nullary_operator, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Epsilon },
	{ "Incr", 1, 0, kc_phylum_action, kc_subphyla_Incr, kc_suboffsets_Incr, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Incr },
	{ "LessThan", 2, 0, kc_phylum_action, kc_subphyla_LessThan, kc_suboffsets_LessThan, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_LessThan },
	{ "Reset", 1, 0, kc_phylum_action, kc_subphyla_Reset, kc_suboffsets_Reset, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Reset },
	{ "MapTransition", 1, 0, kc_phylum_map, kc_subphyla_MapTransition, kc_suboffsets_MapTransition, uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_MapTransition },
	{ "MapEvent", 1, 0, kc_phylum_map, kc_subphyla_MapEvent, kc_suboffsets_MapEvent, uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_MapEvent },
	{ "Event", 3, 0, kc_phylum_event, kc_subphyla_Event, kc_suboffsets_Event, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Event },
	{ "RootEvent", 1, 0, kc_phylum_event, kc_subphyla_RootEvent, kc_suboffsets_RootEvent, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_RootEvent },
	{ "Internal", 0, 0, kc_phylum_visibility, (kc_enum_phyla_list)0, (kc_size_t_list)0, kc_uniq_nullary_operator, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Internal },
	{ "External", 0, 0, kc_phylum_visibility, (kc_enum_phyla_list)0, (kc_size_t_list)0, kc_uniq_nullary_operator, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_External },
	{ "Nilevents", 0, 0, kc_phylum_events, (kc_enum_phyla_list)0, (kc_size_t_list)0, kc_uniq_nullary_operator, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Nilevents },
	{ "Consevents", 2, 0, kc_phylum_events, kc_subphyla_Consevents, kc_suboffsets_Consevents, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Consevents },
	{ "State", 2, 0, kc_phylum_state, kc_subphyla_State, kc_suboffsets_State, uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_State },
	{ "Label", 1, 0, kc_phylum_label, kc_subphyla_Label, kc_suboffsets_Label, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Label },
	{ "CounterLabel", 2, 0, kc_phylum_label, kc_subphyla_CounterLabel, kc_suboffsets_CounterLabel, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_CounterLabel },
	{ "DeclLabel", 1, 0, kc_phylum_label, kc_subphyla_DeclLabel, kc_suboffsets_DeclLabel, kc_not_uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_DeclLabel },
	{ "Nilintarray", 0, 0, kc_phylum_intarray, (kc_enum_phyla_list)0, (kc_size_t_list)0, kc_uniq_nullary_operator, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Nilintarray },
	{ "Consintarray", 2, 0, kc_phylum_intarray, kc_subphyla_Consintarray, kc_suboffsets_Consintarray, uniq, (kc_voidptr_t(*) KC__P((KC_DOTDOTDOT)))kc_opfn_Consintarray },
	{ (char*)0, 0, 0, kc_one_before_first_phylum, (kc_enum_phyla_list)0, (kc_size_t_list)0, (kc_storageclass_t)0, 0 } /* last element */
};

static kc_enum_phyla kc_phylumstorageclass_uniq[] = { kc_one_before_first_phylum, kc_phylum_nocasestring, kc_phylum_casestring, kc_phylum_float, kc_phylum_int, kc_phylum_voidptr, kc_phylum_uid, kc_phylum_idx2event, kc_phylum_location, kc_phylum_map, kc_phylum_state, kc_phylum_intarray, kc_last_phylum };

KC_UNIQ_INFO kc_UniqInfo[] = {
	(KC_UNIQ_INFO)0,
	(KC_UNIQ_INFO)0,
	kc_phylumstorageclass_uniq
};
/* included stuff */
#line 24 "pfunctions.k"
#include "unpk.h" /* needed by include "pfuctions.h" */
#include "pfunctions.h"

#line 753 "k.c"
#line 11 "krfsm.k"
static int transnr = 0;
/* list of all locations for cycle detection */
static locations alllocptr = 0;

locations
allloc(void)
{
	return (alllocptr ? alllocptr : Nillocations());
}

#line 765 "k.c"
#line 16 "expand.k"
#include "expand.h"
#include "intarray.h"
static int eventnr = 0;

#line 771 "k.c"
/* end included stuff */

#if defined(lint)
   int kc_zero_constant = 0;
#endif

void kc_no_default_in_with
#ifdef KC_USE_PROTOTYPES
( char *kc_func, int kc_line, char *kc_file )
#else
( kc_func, kc_line, kc_file ) char *kc_func; int kc_line; char *kc_file;
#endif
{	(void)fflush(stdout);
	(void)fprintf( stderr, KC_NO_DEFAULT_IN_WITH, kc_func, kc_file, kc_line );
#ifndef KC_NODEFAULT_NO_ABORT
	abort();
#else
	exit( 1 );
#endif
}

void kc_returnless_function
#ifdef KC_USE_PROTOTYPES
( char *kc_func, int kc_line, char *kc_file )
#else
( kc_func, kc_line, kc_file ) char *kc_func; int kc_line; char *kc_file;
#endif
{	(void)fflush(stdout);
	(void)fprintf( stderr, "Internal Error: function %s does not return a value, at %s:%d", kc_func, kc_file, kc_line );
#ifndef KC_NODEFAULT_NO_ABORT
	abort();
#else
	exit( 1 );
#endif
}

void kc_assertionFailed
#ifdef KC_USE_PROTOTYPES
(char *kc_fn, int kc_l)
#else
(kc_fn, kc_l) char *kc_fn; int kc_l;
#endif
{	(void)fflush(stdout);
	(void)fprintf( stderr, "Internal Error: Assertion failed at %s:%d\n", kc_fn, kc_l );
#ifndef KC_ASSERT_NO_ABORT
	abort();
#else
	exit( 1 );
#endif
}

void kc_assertionReasonFailed
#ifdef KC_USE_PROTOTYPES
(char *kc_fn, int kc_l, char *kc_s)
#else
(kc_fn, kc_l, kc_s) char *kc_fn; int kc_l; char *kc_s;
#endif
{	(void)fflush(stdout);
	(void)fprintf( stderr, "Internal Error: Assertion failed at file %s:%d: %s\n", kc_fn, kc_l, kc_s );
#ifndef KC_ASSERT_NO_ABORT
	abort();
#else
	exit( 1 );
#endif
}

void kc_assertionNonNullFailed
#ifdef KC_USE_PROTOTYPES
(char *kc_str, char *kc_fn, int kc_l)
#else
(kc_str, kc_fn, kc_l) char *kc_str; char *kc_fn; int kc_l;
#endif
{	(void)fflush(stdout);
	(void)fprintf( stderr, "Internal Error: Assertion failed at %s:%d: pointer %s is NULL\n", kc_fn, kc_l, kc_str );
#ifndef KC_ASSERT_NO_ABORT
	abort();
#else
	exit( 1 );
#endif
}

void kc_assertionOperatorInPhylumFailed
#ifdef KC_USE_PROTOTYPES
(int kc_op, char *kc_str1, char *kc_str2, int kc_phy, char *kc_fn, int kc_l)
#else
(kc_op, kc_str1, kc_str2, kc_phy, kc_fn, kc_l) int kc_op; char *kc_str1; char *kc_str2; int kc_phy; char *kc_fn; int kc_l;
#endif
{	(void)fflush(stdout);
	if ((kc_op <= (int)kc_one_before_first_operator) || (kc_op >= (int)kc_last_operator)) {
		(void)fprintf( stderr, "Internal Error: Assertion failed at %s:%d: illegal value for (%s) %s%s: %d not a valid operator\n", kc_fn, kc_l, kc_PhylumInfo[(int)kc_phy].name, kc_str1, kc_str2, kc_op );
	} else {
		(void)fprintf( stderr, "Internal Error: Assertion failed at %s:%d: illegal value for (%s) %s%s: %s (%d) is a value of %s\n", kc_fn, kc_l, kc_PhylumInfo[(int)kc_phy].name, kc_str1, kc_str2, kc_OperatorInfo[kc_op].name, kc_op, kc_PhylumInfo[(int)kc_OperatorInfo[kc_op].phylum].name );
	}
#ifndef KC_ASSERT_NO_ABORT
	abort();
#else
	exit( 1 );
#endif
}

static void kc_invalid_operator
#ifdef KC_USE_PROTOTYPES
( char *kc_func_prefix, kc_enum_phyla kc_phy, int kc_line, char *kc_file, int kc_oper )
#else
( kc_func_prefix, kc_phy, kc_line, kc_file, kc_oper ) char *kc_func_prefix; kc_enum_phyla kc_phy; int kc_line; char *kc_file; int kc_oper;
#endif
{	(void)fflush(stdout);
	(void)fprintf( stderr, "Internal Error: invalid operator code in %s%s at %s:%d: %s\n", kc_func_prefix, kc_phylumname_or_error( (int)kc_phy ), kc_file, kc_line, kc_operatorname_or_error( kc_oper ));
#ifndef KC_INVALID_OPERATOR_NO_ABORT
	abort();
#else
	exit( 1 );
#endif
}

/* macro's that do the string concatenation */
#define KC_MIdStr(s) s
#ifdef KC_STDC
#  define KC_MStrConc(s1,s2) s1 ## s2
#else
#  define KC_MStrConc(s1,s2) KC_MIdStr(s1)s2
#endif

#ifndef KC_MEMORY_BLOCKSIZE
#  define KC_MEMORY_BLOCKSIZE 20000
#endif
#ifndef LARGEPRIME
#  define LARGEPRIME 80021
#endif
#if LARGEPRIME < 0
#  define LARGEPRIME 0
#endif
#ifndef KC_BUCKET_INC
#  define KC_BUCKET_INC 8
#endif
#ifndef HASH
#  define HASH(x) kc_hashval = ((kc_hashval<<3) + (((unsigned)x)>>2))
#endif
#ifndef INTHASH
#  define INTHASH(x) kc_hashval = ((kc_hashval<<10) + (unsigned)x)
#endif
#ifndef FLOATHASH
#  define FLOATHASH(x) kc_hashval = ((kc_hashval<<10) + (unsigned)x)
#endif
#ifndef VOIDPTRHASH
#  define VOIDPTRHASH(x) HASH(x)
#endif
#ifndef OPERATORHASH
#  define OPERATORHASH(x) kc_hashval = (kc_hashval + (unsigned)x * 73)
#endif
#ifndef CASESTRHASH
#  define CASESTRHASH(x) kc_hashval = ((kc_hashval<<3) + (unsigned)kc_casestrhash(x))
#endif
#ifndef NOCASESTRHASH
#  define NOCASESTRHASH(x) kc_hashval = ((kc_hashval<<3) + (unsigned)kc_nocasestrhash(x))
#endif
#ifndef MALLOC
#  define MALLOC emalloc
#endif
#ifndef CALLOC
#  define CALLOC ecalloc
#endif
#ifndef REALLOC
/*
 * # ifdef lint
 * #  define REALLOC(kc_p,kc_s) (kc_p,kc_s,0)
 * # else
 */
#  define REALLOC erealloc
/*
 * # endif
 */
#endif
#ifndef FREE
#  define FREE efree
#endif
#ifndef efree
/*
 * # ifdef lint
 * #  define efree(kc_p) 
 * # else
 */
#  define efree(kc_p) free((kc_malloc_t)(kc_p))
/*
 * # endif
 */
#endif
#ifndef KC_ALIGN
typedef union kc_Align_tag { long l; int i; } kc_Align;
#else
typedef KC_ALIGN kc_Align;
#endif
#ifndef UNIQMALLOCINIT
#  define UNIQMALLOCINIT uniqmallocinit
#  ifndef UNIQMALLOC2
#    define UNIQMALLOC2 uniqmalloc
#  endif
#  ifndef UNIQFREEELEMENT
#    define UNIQFREEELEMENT uniqfreeelement
#  endif
#  ifndef UNIQFREEALL
#    define UNIQFREEALL uniqfreeall
#  endif
#  ifndef INUNIQBLOCK
#    define INUNIQBLOCK isinuniqmalloccedblock
#  endif
#  ifndef UNIQMEMORYINFO
#    define UNIQMEMORYINFO kc_print_memory_info_statistics
#  endif
#else
#  ifndef UNIQFREEELEMENT
#    define UNIQFREEELEMENT 0
#  endif
#  ifndef UNIQFREEALL
#    define UNIQFREEALL 0
#  endif
#  ifndef INUNIQBLOCK
#    define INUNIQBLOCK 0
#  endif
#  ifndef UNIQMEMORYINFO
#    define UNIQMEMORYINFO 0
#  endif
#endif
#ifndef BUCKETALLOCINIT
#  define BUCKETALLOCINIT 0
#  ifndef BUCKETCALLOC
#    define BUCKETCALLOC kc_wrap_bucket_malloc
#  endif
#  ifndef BUCKETREALLOC
#    define BUCKETREALLOC kc_wrap_bucket_realloc
#  endif
#  ifndef BUCKETFREE
#    define BUCKETFREE kc_wrap_bucket_free
#  endif
#  ifndef BUCKETSFREE
#    define BUCKETSFREE 0
#  endif
#  ifndef BUCKETMEMORYINFO
#    define BUCKETMEMORYINFO 0
#  endif
#else
#  ifndef BUCKETFREE
#    define BUCKETFREE 0
#  endif
#  ifndef BUCKETSFREE
#    define BUCKETSFREE 0
#  endif
#  ifndef BUCKETMEMORYINFO
#    define BUCKETMEMORYINFO 0
#  endif
#endif
#ifndef BUCKETINC
#  define BUCKETINC KC_BUCKET_INC
#endif
#ifndef NONUNIQMALLOC
#  define NONUNIQMALLOC emalloc
#endif
#ifndef NONUNIQFREE
#  define NONUNIQFREE efree
#endif
#ifndef KC_BZERO
#  define KC_BZERO(kc_p, kc_s) (void)memset((kc_memset_firstarg_t)kc_p, 0, (kc_memset_size_t)kc_s)
#endif

typedef struct kc_tag_kc_memory_blockinfo_t *kc_memory_blocksinfo_t;
typedef struct kc_tag_kc_memory_blockinfo_t kc_memory_blockinfo_t;
typedef struct kc_tag_kc_memory_info_t kc_memory_info_t;

static kc_memory_blocksinfo_t kc_mainmemory_freelist = 0;

struct kc_tag_kc_memory_blockinfo_t {
	kc_voidptr_t block; /* pointer to the allocated structure */
	kc_size_t size; /* size of allocated structure */
	kc_memory_blocksinfo_t next; /* next block in list */
	kc_memory_blocksinfo_t prev; /* prev block in list */
};

struct kc_tag_kc_memory_info_t {
	kc_memory_blocksinfo_t kc_memory_blocklist; /* points to block currently in use */
	int kc_memory_left; /* remaining bytes in current block */
	kc_voidptr_t kc_memory_ptr; /* address of first free byte in current block */
	kc_memory_blocksinfo_t *kc_memory_freelist; /* pointer to variable that holds freelist */
	int kc_to_be_freed; /* should be 0 for statically created nodes, and 1 for dynamically created ones */
	kc_size_t kc_wanted_blocksize; /* prefered size of chunks */
};

static kc_memory_blocksinfo_t kc_memory_createblock
#ifdef KC_USE_PROTOTYPES
(kc_size_t kc_n, kc_memory_info_t *kc_malloc_private_info)
#else
(kc_n, kc_malloc_private_info) kc_size_t kc_n; kc_memory_info_t *kc_malloc_private_info;
#endif
{	kc_voidptr_t kc_p;
	kc_memory_blocksinfo_t kc_l;
	kc_size_t kc_size;

	/* we use plain malloc for adminstrative things, and test for the return status */
	kc_l = (kc_memory_blocksinfo_t)MALLOC((kc_size_t)sizeof(kc_memory_blockinfo_t));
	kc_size = (kc_malloc_private_info->kc_wanted_blocksize > kc_n) ?  kc_malloc_private_info->kc_wanted_blocksize : kc_n;
	kc_p = (kc_voidptr_t)MALLOC((kc_size_t)kc_size);
	kc_l->block = kc_p;
	kc_l->size = kc_size;
	return kc_l;
}

/*
 * we use first fit when reusing a block
 */
static kc_memory_blocksinfo_t kc_memory_reuseblock
#ifdef KC_USE_PROTOTYPES
(kc_size_t kc_n, kc_memory_info_t *kc_malloc_private_info)
#else
(kc_n, kc_malloc_private_info) kc_size_t kc_n; kc_memory_info_t *kc_malloc_private_info;
#endif
{	kc_memory_blocksinfo_t kc_l;
	if (*kc_malloc_private_info->kc_memory_freelist == 0) { /* no elements in freelist */
		return (kc_memory_blocksinfo_t)0;
	}
	kc_l = *kc_malloc_private_info->kc_memory_freelist;
	do { /* at least one time, because we have at least one element */
		if (kc_l->size >= kc_n) {
			if (kc_l->next != kc_l) { /* the list contains > 1 elements */
				kc_l->prev->next = kc_l->next;
				kc_l->next->prev = kc_l->prev;
				/* make sure that we don't loose the handle to the list */
				if (kc_l ==  *kc_malloc_private_info->kc_memory_freelist) {
					*kc_malloc_private_info->kc_memory_freelist = kc_l->next;
				}
			} else { /* we release the last free element */
				*kc_malloc_private_info->kc_memory_freelist = 0;
			}
			return kc_l;
		}
		kc_l = kc_l->next;
	} while(kc_l != *kc_malloc_private_info->kc_memory_freelist);
	return (kc_memory_blocksinfo_t)0;
}

static void kc_memory_newblock
#ifdef KC_USE_PROTOTYPES
(kc_size_t kc_n, kc_memory_info_t *kc_malloc_private_info)
#else
(kc_n, kc_malloc_private_info) kc_size_t kc_n; kc_memory_info_t *kc_malloc_private_info;
#endif
{	kc_memory_blocksinfo_t kc_l;
	if ((kc_l = kc_memory_reuseblock(kc_n, kc_malloc_private_info)) == 0) {
		kc_l = kc_memory_createblock(kc_n, kc_malloc_private_info);
	}
	if (kc_malloc_private_info->kc_memory_blocklist != 0) {
		kc_l->next = kc_malloc_private_info->kc_memory_blocklist;
		kc_malloc_private_info->kc_memory_blocklist->prev->next = kc_l;
		kc_l->prev = kc_malloc_private_info->kc_memory_blocklist->prev;
		kc_malloc_private_info->kc_memory_blocklist->prev = kc_l;
	} else {
		kc_l->next = kc_l;
		kc_l->prev = kc_l;
	}
	kc_malloc_private_info->kc_memory_blocklist = kc_l;
	kc_malloc_private_info->kc_memory_left = kc_l->size;
	kc_malloc_private_info->kc_memory_ptr = kc_l->block;
}

static void kc_print_memory_blocks_info_statistics
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, kc_memory_blocksinfo_t kc_a_memory_blocksinfo_t)
#else
(kc_f, kc_a_memory_blocksinfo_t) FILE *kc_f; kc_memory_blocksinfo_t kc_a_memory_blocksinfo_t;
#endif
{	kc_memory_blocksinfo_t kc_tmp = kc_a_memory_blocksinfo_t;
	if (kc_tmp) {
		/* at least one block? */
		do {
			fprintf(kc_f, "		block-size (at %p): %d\n", kc_tmp->block, kc_tmp->size);
			kc_tmp = kc_tmp->next;
		} while(kc_tmp && (kc_tmp != kc_a_memory_blocksinfo_t));
	} else {
		fprintf(kc_f, "		no blocks allocated\n");
	}
}

void kc_print_memory_info_statistics
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, kc_voidptr_t kc_malloc_private_info)
#else
(kc_f, kc_malloc_private_info) FILE *kc_f; kc_voidptr_t kc_malloc_private_info;
#endif
{
	kc_memory_info_t *kc_a_memory_info_t = (kc_memory_info_t *)kc_malloc_private_info;
	fprintf(kc_f, "	to-be-freed: %s\n", (kc_a_memory_info_t->kc_to_be_freed ? "yes" : "no"));
	fprintf(kc_f, "	wanted block-size: %d\n", kc_a_memory_info_t->kc_wanted_blocksize);
	fprintf(kc_f, "	remaining in current block: %d\n", kc_a_memory_info_t->kc_memory_left);
	fprintf(kc_f, "	blocks-info (at %p):\n", kc_a_memory_info_t->kc_memory_blocklist);
	kc_print_memory_blocks_info_statistics(kc_f, kc_a_memory_info_t->kc_memory_blocklist);
	fprintf(kc_f, "	freelist-info (at %p):\n", *kc_a_memory_info_t->kc_memory_freelist);
	kc_print_memory_blocks_info_statistics(kc_f, *kc_a_memory_info_t->kc_memory_freelist);
}	

/*
 * the %p in the routine below is ANSI-C standard (but implementation dependent)
 * for void*; instead we could use %p
 */
void kc_print_hashtable_memory_statistics
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, kc_hashtable_t kc_a_hashtable_t)
#else
(kc_f, kc_a_hashtable_t) FILE *kc_f; kc_hashtable_t kc_a_hashtable_t;
#endif
{	kc_private_malloc_t kc_tmp;
	int kc_i;
	fprintf(kc_f, "current allocation scheme: %s\n",
		((kc_a_hashtable_t->mode == kc_ht_store_static) ? "static" : "dynamic"));
	if (kc_a_hashtable_t->malloc_info) {
		fprintf(kc_f, "static allocation info (info ptr: %p):\n", kc_a_hashtable_t->static_malloc_private_data);
		(*kc_a_hashtable_t->malloc_info)(kc_f, kc_a_hashtable_t->static_malloc_private_data);
		kc_tmp = kc_a_hashtable_t->dynamic_malloc_private_data;
		kc_i = 0;
		fprintf(kc_f, "dynamic allocation info: counting from top (level 0) of level stack\n");
		while(kc_tmp) {
			fprintf(kc_f, "dynamic allocation info for level %d,(info ptr: %p):\n", kc_i, kc_tmp->malloc_private_data);
			(*kc_a_hashtable_t->malloc_info)(kc_f, kc_tmp->malloc_private_data);
			kc_i++;
			kc_tmp = kc_tmp->next;
		}
		kc_tmp = kc_a_hashtable_t->dec_dynamic_malloc_private_data;
		kc_i = 0;
		fprintf(kc_f, "dynamic allocation info: levels to be freed, counting from bottom\n");
		while(kc_tmp) {
			fprintf(kc_f, "dynamic allocation info for level %d,(info ptr: %p):\n", kc_i, kc_tmp->malloc_private_data);
			(*kc_a_hashtable_t->malloc_info)(kc_f, kc_tmp->malloc_private_data);
			kc_i++;
			kc_tmp = kc_tmp->prev;
		}
	}
}


kc_voidptr_t uniqmalloc	/* check return from malloc */
#ifdef KC_USE_PROTOTYPES
(kc_size_t kc_n, kc_voidptr_t kc_malloc_private_info)
#else
(kc_n, kc_malloc_private_info) kc_size_t kc_n; kc_voidptr_t kc_malloc_private_info;
#endif
{	kc_voidptr_t kc_p;
	kc_memory_info_t *kc_a_memory_info_t = (kc_memory_info_t *)kc_malloc_private_info;	
	/* all blocks should be a multiple of the alignment requirement */
	kc_n += sizeof(kc_Align) - 1 - ((kc_n - 1) % sizeof(kc_Align));
	if ( kc_a_memory_info_t->kc_memory_left < (int)kc_n ) kc_memory_newblock(kc_n, kc_a_memory_info_t);
	kc_a_memory_info_t->kc_memory_left -= kc_n;
	kc_p = kc_a_memory_info_t->kc_memory_ptr;
	kc_a_memory_info_t->kc_memory_ptr = (kc_voidptr_t)((char*)(kc_a_memory_info_t->kc_memory_ptr) + kc_n);
	return kc_p;
}

kc_memory_info_t *uniqmallocinit
#ifdef KC_USE_PROTOTYPES
( /*kc_size_t kc_n*/ )
#else
( /*kc_n*/ ) /*kc_size_t kc_n;*/
#endif
{	kc_memory_info_t *kc_p;
	kc_p = (kc_memory_info_t*)MALLOC((kc_size_t)sizeof(kc_memory_info_t));
	kc_p->kc_memory_blocklist = 0;
	kc_p->kc_memory_left = 0;
	kc_p->kc_memory_ptr = 0;
	kc_p->kc_memory_freelist = &kc_mainmemory_freelist;
	kc_p->kc_to_be_freed = 1;
	kc_p->kc_wanted_blocksize = /*(kc_n <= 0) ?*/ KC_MEMORY_BLOCKSIZE /*: kc_n*/;
	return kc_p;
}

boolean isinuniqmalloccedblock
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_p, kc_voidptr_t kc_malloc_private_info)
#else
(kc_p, kc_malloc_private_info) kc_voidptr_t kc_p; kc_voidptr_t kc_malloc_private_info;
#endif
{	kc_memory_blocksinfo_t kc_l;
	kc_memory_info_t *kc_a_memory_info_t = (kc_memory_info_t *)kc_malloc_private_info;
	if (kc_a_memory_info_t->kc_memory_blocklist == 0) {
		return False;
	}
	kc_l = kc_a_memory_info_t->kc_memory_blocklist;
	do {
		if (((char*)kc_p >= (char*)kc_l->block) && ((char*)kc_p < (char*)((char*)kc_l->block + kc_l->size))) {
			return True;
		}
		kc_l = kc_l->next;
	} while(kc_l != kc_a_memory_info_t->kc_memory_blocklist);
	return False;
}

/*ARGSUSED*/
void uniqfreeelement	/* free (prepare for reuse of) one element in private info */
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_ptr, kc_voidptr_t kc_malloc_private_info)
#else
(kc_ptr, kc_malloc_private_info) kc_voidptr_t kc_ptr; kc_voidptr_t kc_malloc_private_info;
#endif
{
}

void uniqfreeall	/* free (prepare for reuse of) everything in private info */
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_malloc_private_info)
#else
(kc_malloc_private_info) kc_voidptr_t kc_malloc_private_info;
#endif
{
	kc_memory_info_t *kc_a_memory_info_t = (kc_memory_info_t *)kc_malloc_private_info;
	if (kc_a_memory_info_t->kc_memory_blocklist != 0) {
		kc_memory_blocksinfo_t kc_a_memory_blocklist = kc_a_memory_info_t->kc_memory_blocklist;
		kc_memory_blocksinfo_t kc_blockptr = kc_a_memory_blocklist;
		do {
			KC_BZERO(kc_blockptr->block, kc_blockptr->size);
			kc_blockptr = kc_blockptr->next;
		} while (kc_blockptr != kc_a_memory_blocklist);
		if (*kc_a_memory_info_t->kc_memory_freelist == 0) {
			*kc_a_memory_info_t->kc_memory_freelist = kc_a_memory_info_t->kc_memory_blocklist;
		} else {
			kc_a_memory_info_t->kc_memory_blocklist->prev->next = (*kc_a_memory_info_t->kc_memory_freelist);
			(*kc_a_memory_info_t->kc_memory_freelist)->prev->next = kc_a_memory_info_t->kc_memory_blocklist;
			kc_blockptr = kc_a_memory_info_t->kc_memory_blocklist->prev;
			kc_a_memory_info_t->kc_memory_blocklist->prev = (*kc_a_memory_info_t->kc_memory_freelist)->prev;
			(*kc_a_memory_info_t->kc_memory_freelist)->prev = kc_blockptr;;
	}	}
	/* just to be sure, this is NECESSARY in case kc_a_memory_info_t->kc_to_be_freed holds */
	kc_a_memory_info_t->kc_memory_blocklist = 0;
	kc_a_memory_info_t->kc_memory_left = 0;
	kc_a_memory_info_t->kc_memory_ptr = 0;
	kc_a_memory_info_t->kc_memory_left = 0;
	if (kc_a_memory_info_t->kc_to_be_freed) { /* we must be sure that it wasn't dynamically allocated */
		KC_BZERO(kc_a_memory_info_t, sizeof(kc_memory_info_t));
		FREE((kc_voidptr_t)kc_a_memory_info_t);
}	}

/*ARGSUSED*/
kc_voidptr_t kc_wrap_bucket_malloc
#ifdef KC_USE_PROTOTYPES
(kc_size_t kc_a_size, kc_size_t kc_a_number, kc_voidptr_t kc_a_private_malloc_info)
#else
(kc_a_size, kc_a_number, kc_a_private_malloc_info)
kc_size_t kc_a_size; kc_size_t kc_a_number; kc_voidptr_t kc_a_private_malloc_info;
#endif
{	return MALLOC((kc_size_t)kc_a_size*kc_a_number);
}

/*ARGSUSED*/
kc_voidptr_t kc_wrap_bucket_realloc
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_ptr, kc_size_t kc_a_oldsize, kc_size_t kc_a_newsize, kc_voidptr_t kc_a_private_malloc_info)
#else
(kc_ptr, kc_a_oldsize, kc_a_newsize, kc_a_private_malloc_info)
kc_voidptr_t kc_ptr; kc_size_t kc_a_oldsize; kc_size_t kc_a_newsize; kc_voidptr_t kc_a_private_malloc_info;
#endif
{	return REALLOC(kc_ptr, kc_a_newsize);
}

/*ARGSUSED*/
void kc_wrap_bucket_free
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_ptr, kc_size_t kc_a_size, kc_voidptr_t kc_a_private_malloc_info)
#else
(kc_ptr, kc_a_size, kc_a_private_malloc_info)
kc_voidptr_t kc_ptr; kc_size_t kc_a_size; kc_voidptr_t kc_a_private_malloc_info;
#endif
{	(void)FREE(kc_ptr);
}

#ifdef KC_STATISTICS
   KC_OPERATOR_STATISTICS kc_OperatorStatistics[KC_NO_OF_OPERATORS];
#  define KC_COLLECT_STATS0(v) v
#else
#  define KC_COLLECT_STATS0(v) 
#endif

#ifndef KC_CREATE_STATS
#  define KC_CREATE_STATS(oper) kc_OperatorStatistics[(int)oper].create++;
#endif
#ifndef KC_EXISTINGNOTFOUND_STATS
#  define KC_EXISTINGNOTFOUND_STATS(oper) kc_OperatorStatistics[(int)oper].existing_not_found++;
#endif

#ifndef KC_FREE_CALLED_STATS
#  define KC_FREE_CALLED_STATS(oper,rec) kc_OperatorStatistics[(int)oper].free_called[(int)(rec?True:False)]++;
#endif

#ifndef KC_FREED_STATS
#  define KC_FREED_STATS(oper,rec) kc_OperatorStatistics[(int)oper].freed[(int)(rec?True:False)]++;
#endif


static kc_hashtableentry_t kc_mainhasharray_kc_not_uniq[1][(int)kc_last_storage_mode];
static kc_hashtableentry_t kc_mainhasharray_kc_uniq_nullary_operator[1][(int)kc_last_storage_mode];
static kc_hashtableentry_t kc_mainhasharray_uniq[LARGEPRIME+1][(int)kc_last_storage_mode]; /* +1 because LARGEPRIME can be 0 */


static boolean kc_storageclass_still_uniq[] = {
True, True, True };

static kc_memory_info_t kc_memory_info_kc_not_uniq = { 0, 0, 0, &kc_mainmemory_freelist, 0, KC_MEMORY_BLOCKSIZE };
static kc_memory_info_t kc_memory_info_kc_uniq_nullary_operator = { 0, 0, 0, &kc_mainmemory_freelist, 0, KC_MEMORY_BLOCKSIZE };
static kc_memory_info_t kc_memory_info_uniq = { 0, 0, 0, &kc_mainmemory_freelist, 0, KC_MEMORY_BLOCKSIZE };


#if 0 /* ! (defined(lint) || defined(SABER) || defined(CODECENTER)) */ /* currently not used */
static kc_memory_info_t *kc_memory_info[] = { &kc_memory_info_kc_not_uniq, &kc_memory_info_kc_uniq_nullary_operator, &kc_memory_info_uniq };
#endif

static kc_hashtable_struct_t kc_static_hashtables[] = {
{ kc_mainhasharray_kc_not_uniq,
 0 /*size*/,
 0 /*kc_to_be_freed*/,
 &kc_static_hashtables[1],
 &kc_static_hashtables[2],
 /* node allocation*/
 (kc_voidptr_t(*)())UNIQMALLOCINIT,
 UNIQMALLOC2,
 0 /*UNIQFREEELEMENT*/,
 UNIQFREEALL,
 INUNIQBLOCK,
 (kc_voidptr_t)&kc_memory_info_kc_not_uniq /*malloc_private_data*/,
 (kc_voidptr_t)&kc_memory_info_kc_not_uniq /*static_malloc_private_data*/,
 0 /*dynamic_malloc_private_data*/,
 0 /*dec_dynamic_malloc_private_data*/,
 kc_ht_store_static,
 UNIQMEMORYINFO,
 /* bucket allocation */
 BUCKETALLOCINIT,
 BUCKETCALLOC,
 BUCKETREALLOC,
 0 /*bucket_alloc_private_data*/,
 BUCKETFREE,
 BUCKETSFREE,
 BUCKETINC,
 BUCKETMEMORYINFO
 },
{ kc_mainhasharray_kc_uniq_nullary_operator,
 0 /*size*/,
 0 /*kc_to_be_freed*/,
 &kc_static_hashtables[2],
 &kc_static_hashtables[0],
 /* node allocation*/
 (kc_voidptr_t(*)())UNIQMALLOCINIT,
 UNIQMALLOC2,
 0 /*UNIQFREEELEMENT*/,
 UNIQFREEALL,
 INUNIQBLOCK,
 (kc_voidptr_t)&kc_memory_info_kc_uniq_nullary_operator /*malloc_private_data*/,
 (kc_voidptr_t)&kc_memory_info_kc_uniq_nullary_operator /*static_malloc_private_data*/,
 0 /*dynamic_malloc_private_data*/,
 0 /*dec_dynamic_malloc_private_data*/,
 kc_ht_store_static,
 UNIQMEMORYINFO,
 /* bucket allocation */
 BUCKETALLOCINIT,
 BUCKETCALLOC,
 BUCKETREALLOC,
 0 /*bucket_alloc_private_data*/,
 BUCKETFREE,
 BUCKETSFREE,
 BUCKETINC,
 BUCKETMEMORYINFO
 },
{ kc_mainhasharray_uniq,
 LARGEPRIME /*size*/,
 0 /*kc_to_be_freed*/,
 &kc_static_hashtables[0],
 &kc_static_hashtables[1],
 /* node allocation*/
 (kc_voidptr_t(*)())UNIQMALLOCINIT,
 UNIQMALLOC2,
 0 /*UNIQFREEELEMENT*/,
 UNIQFREEALL,
 INUNIQBLOCK,
 (kc_voidptr_t)&kc_memory_info_uniq,
 (kc_voidptr_t)&kc_memory_info_uniq,
 0 /*dynamic_malloc_private_data*/,
 0 /*dec_dynamic_malloc_private_data*/,
 kc_ht_store_static,
 UNIQMEMORYINFO,
 /* bucket allocation */
 BUCKETALLOCINIT,
 BUCKETCALLOC,
 BUCKETREALLOC,
 0 /*bucket_alloc_private_data*/,
 BUCKETFREE,
 BUCKETSFREE,
 BUCKETINC,
 BUCKETMEMORYINFO
 }};

static kc_hashtable_t kc_hashtables[] = {
&kc_static_hashtables[(int)kc_not_uniq], &kc_static_hashtables[(int)kc_uniq_nullary_operator], &kc_static_hashtables[(int)uniq]};

static char* kc_storageclassnames[] = { "kc_not_uniq", "kc_uniq_nullary_operator", "uniq" };

static kc_hashtable_t kc_all_hashtables = &kc_static_hashtables[0];

static int kc_primes[] = {
	1009,
	1091,
	1193,
	1297,
	1423,
	1543,
	1693,
	1847,
	2003,
	2203,
	2381,
	2609,
	2833,
	3089,
	3371,
	3673,
	4007,
	4373,
	4783,
	5209,
	5683,
	6197,
	6761,
	7369,
	8039,
	8761,
	9587,
	10427,
	11383,
	12409,
	13537,
	14767,
	16111,
	17569,
	19181,
	20921,
	22807,
	24889,
	27143,
	29611,
	32299,
	35251,
	38447,
	41941,
	45751,
	49919,
	54443,
	59387,
	64793,
	70687,
	77101,
	80021,
	84121,
	91753,
	100103,
	109199,
	119129,
	129953,
	141761,
	154643,
	168713,
	184039,
	200771,
	219017,
	238939,
	260647,
	284357,
	310223,
	338407,
	369169,
	402739,
	439339,
	479263,
	522829,
	570359,
	622241,
	678773,
	740477,
	807797,
	881233,
	961339,
	1048759,
	1144081,
	1248083,
	1361573,
	1485347,
	1620347,
	1767679,
	1928351,
	2103653,
	2294891,
	2503511,
	2731103,
	2979391,
	3250243,
	3545719,
	3868057,
	4219687,
	4603297,
	5021773,
	5478299,
	5976329,
	6519647,
	7112351,
	7758899,
	8464273,
	9233729,
	10073153,
	10988893,
	11987891,
	13077707,
	14266573,
	15563531,
	16978399,
	18521897,
	20205697,
	22042607,
	24046487,
	26232491,
	28617269,
	31218823,
	34056907,
	37152979,
	40530541,
	44215117,
	48234733,
	52619639,
	57403277,
	62621729,
	68314613,
	74525021,
	81300017,
	88690949,
	96753739,
	105549557,
	115144957,
	125612671,
	137032001,
	149489477,
	163079431,
	177904801,
	194077981,
	211721429,
	230968853,
	251966009,
	274871969,
	299860369,
	327120389,
	356858597,
	389300293,
	424691207,
	463299493,
	505417691,
	551364677,
	601488779,
	656169539,
	715821317,
	780896041,
	851886569,
	929330767,
	1013815373,
	1105980433,
	1206524183,
	1316208139,
	1435863449,
	1566396463,
	1708796171,
	1864141193,
	2033608601,
0, 0 /* last two elements should ALWAYS be 0 */ };

#ifdef KC_STATISTICS
static int kc_casestring_strlen =0;
static int kc_nocasestring_strlen =0;

void kc_do_print_operator_statistics
#ifdef KC_USE_PROTOTYPES
(FILE * kc_f)
#else
(kc_f) FILE *kc_f;
#endif
{	unsigned int kc_i;
	/*SUPPRESS 622*/
	assertNonNull( kc_f,"kc_f" );
	(void)fprintf(kc_f, "%-*s| %-*s| %-*s| %-*s| %-*s| %-*s| %-*s| %-*s| %-*s| %-*s\n", 38 , "Operator", 3, "Sz", 8, "#oper", 8, "#new", 8, "#exist", 8, "#frnrec", 8, "#frrec", 8, "#freed", 8, "#rem", 9, "total (bytes)");
	(void)fprintf(kc_f, "%-*s|%*s |%*d |%*d |%*d |%*d |%*d |%*d |%*d |%*d\n", 38, "case sensitive strings", 3, "-", 8, kc_OperatorStatistics[(int)sel__Str].create, 8, kc_OperatorStatistics[(int)sel__Str].existing_not_found, 8, kc_OperatorStatistics[(int)sel__Str].create-kc_OperatorStatistics[(int)sel__Str].existing_not_found, 8, 0, 8, 0, 8, 0, 8, 0, 9, kc_casestring_strlen);
	(void)fprintf(kc_f, "%-*s|%*s |%*d |%*d |%*d |%*d |%*d |%*d |%*d |%*d\n", 38, "case insensitive strings", 3, "-", 8, kc_OperatorStatistics[(int)sel_NoCaseStr].create, 8, kc_OperatorStatistics[(int)sel_NoCaseStr].existing_not_found, 8, kc_OperatorStatistics[(int)sel_NoCaseStr].create-kc_OperatorStatistics[(int)sel_NoCaseStr].existing_not_found, 8, 0, 8, 0, 8, 0, 8, 0, 9, kc_nocasestring_strlen);
	for (kc_i = (int)kc_one_before_first_operator+1; kc_i < (int)kc_last_operator; kc_i++) {
		(void)fprintf(kc_f, "%-*s|%*d |%*d |%*d |%*d |%*d |%*d |%*d |%*d |%*d\n", 38, kc_OperatorInfo[kc_i].name, 3, kc_PhylumInfo[(int)kc_OperatorInfo[kc_i].phylum].size, 8, kc_OperatorStatistics[kc_i].create, 8, kc_OperatorStatistics[kc_i].existing_not_found, 8, kc_OperatorStatistics[kc_i].create-kc_OperatorStatistics[kc_i].existing_not_found, 8, kc_OperatorStatistics[kc_i].free_called[(int)False], 8, kc_OperatorStatistics[kc_i].free_called[(int)True], 8, kc_OperatorStatistics[kc_i].freed[(int)False]+kc_OperatorStatistics[kc_i].freed[(int)True], 8, kc_OperatorStatistics[kc_i].existing_not_found-(kc_OperatorStatistics[kc_i].freed[(int)False]+kc_OperatorStatistics[kc_i].freed[(int)True]), 9, (kc_PhylumInfo[(int)kc_OperatorInfo[(int)kc_i].phylum].size)*(kc_OperatorStatistics[kc_i].existing_not_found-(kc_OperatorStatistics[kc_i].freed[(int)False]+kc_OperatorStatistics[kc_i].freed[(int)True])));
	}
}
#endif /* KC_STATISTICS */

void kc_print_hash_statistics
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f)
#else
(kc_f) FILE *kc_f;
#endif
{	unsigned int kc_k;
	/*SUPPRESS 622*/
	/*assertNonNull(kc_f,"kc_f");*/ if (kc_f == NULL) kc_f = stdout;
	for (kc_k=0; kc_k < (int)kc_last_storageclass; kc_k++) {
		(void)fprintf(kc_f, "Information for storage class %s: \n", kc_storageclassnames[kc_k]);
		kc_print_hashtable_statistics(kc_f, kc_hashtables[kc_k]);
}	}

void kc_print_all_hashtable_statistics
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f)
#else
(kc_f) FILE *kc_f;
#endif
{	kc_hashtable_t kc_a_hashtable_t = kc_all_hashtables;
	unsigned int kc_k;
	boolean kc_st_found;
	/*SUPPRESS 622*/
	/*assertNonNull(kc_f,"kc_f");*/ if (kc_f == NULL) kc_f = stdout;
	do { /* at least one time, because we have at least one element */
		kc_st_found = False;
		for (kc_k=0; kc_k < (int)kc_last_storageclass; kc_k++) {
			if (kc_hashtables[kc_k] == kc_a_hashtable_t) {
				kc_st_found = True;
				(void)fprintf(kc_f, "Information for storage class %s: \n", kc_storageclassnames[kc_k]);
		}	}
		if (! kc_st_found) {
			(void)fprintf(kc_f, "Information for unknown storage class: \n");
		}
		kc_print_hashtable_statistics(kc_f, kc_a_hashtable_t);
		kc_print_hashtable_memory_statistics(kc_f, kc_a_hashtable_t);
		kc_a_hashtable_t = kc_a_hashtable_t->next;
	} while(kc_a_hashtable_t != kc_all_hashtables);
}

void kc_print_hashtable_statistics
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, kc_hashtable_t kc_a_hashtable_t)
#else
(kc_f, kc_a_hashtable_t) FILE *kc_f; kc_hashtable_t kc_a_hashtable_t;
#endif
{
	boolean kc_goon;
	int kc_entries[9];
	int kc_o_8 = 0;
	int kc_o_20 = 0;
	int kc_o_100 = 0;
	int kc_total = 0;
	int kc_i, kc_j;

	/*SUPPRESS 622*/
	/*(kc_f,"kc_f");*/ if (kc_f == NULL) kc_f = stdout;
	(void)fprintf(kc_f, "\tsize:\t%d\n",kc_a_hashtable_t->size);
	for (kc_i=0; kc_i < 9; kc_i++) kc_entries[kc_i]=0;
	for (kc_i=0;kc_i<kc_a_hashtable_t->size;kc_i++) {
		int kc_m=0, kc_n;
		for (kc_n=0;kc_n<(int)kc_last_storage_mode;kc_n++) {
			kc_m += kc_a_hashtable_t->hashtable[kc_i][kc_n].nr;
		}
		kc_total += kc_m;
		if (kc_m >100) {kc_o_100 ++; (void)fprintf(kc_f, ">100: key %d (%d elts)\n",kc_i,kc_m); }
		else if (kc_m >20) {kc_o_20 ++; (void)fprintf(kc_f, ">20: key %d (%d elts)\n",kc_i,kc_m); }
		else if (kc_m > 8) kc_o_8 ++;
		else {
			kc_j =0; kc_goon = True;
			while ( kc_goon && (kc_j < 9)) {
				if (kc_m == kc_j) { kc_entries[kc_j]++; kc_goon = False; }
				else kc_j++;
	}	}	}
	(void)fprintf(kc_f, "The spreading is: \n");
	for (kc_j=0; kc_j < 9; kc_j++) {
		(void)fprintf(kc_f, "\t%d elts:\t%d\n",kc_j, kc_entries[kc_j]);
	}
	(void)fprintf(kc_f, "\tOver 8 elts:\t%d\n",kc_o_8);
	(void)fprintf(kc_f, "\tOver 20 elts:\t%d\n",kc_o_20);
	(void)fprintf(kc_f, "\tOver 100 elts:\t%d\n",kc_o_100);
	(void)fprintf(kc_f, " Total number of cells: %d\n",kc_total);
	(void)fprintf(kc_f, " Number of buckets: %d\n",kc_a_hashtable_t->size);
}

static void kc_growindex
#ifdef KC_USE_PROTOTYPES
(kc_hashtableentry_t *kc_hte, kc_hashtable_t kc_a_ht)
#else
(kc_hte, kc_a_ht) kc_hashtableentry_t *kc_hte; kc_hashtable_t kc_a_ht;
#endif
{	int kc_newsize = kc_hte->ibound + kc_a_ht->bucket_alloc_inc;
	if (kc_newsize == kc_a_ht->bucket_alloc_inc)
		kc_hte->index = (YYSTYPE *) (*kc_a_ht->bucket_calloc)((kc_size_t)kc_newsize, (kc_size_t)sizeof(YYSTYPE), kc_a_ht->bucket_alloc_private_data);
	else
		kc_hte->index = (YYSTYPE *) (*kc_a_ht->bucket_realloc)((kc_voidptr_t)kc_hte->index, (kc_size_t)kc_hte->ibound * sizeof(YYSTYPE), (kc_size_t)kc_newsize * sizeof(YYSTYPE), kc_a_ht->bucket_alloc_private_data);
	kc_hte->ibound = kc_newsize;
}

void kc_ht_static
#ifdef KC_USE_PROTOTYPES
(kc_storageclass_t kc_a_storageclass_t)
#else
(kc_a_storageclass_t) kc_storageclass_t kc_a_storageclass_t;
#endif
{
	kc_hashtables[(int)kc_a_storageclass_t]->mode = kc_ht_store_static;
	kc_hashtables[(int)kc_a_storageclass_t]->malloc_private_data = kc_hashtables[(int)kc_a_storageclass_t]->static_malloc_private_data;
}

void kc_ht_dynamic
#ifdef KC_USE_PROTOTYPES
(kc_storageclass_t kc_a_storageclass_t)
#else
(kc_a_storageclass_t) kc_storageclass_t kc_a_storageclass_t;
#endif
{
	kc_hashtables[(int)kc_a_storageclass_t]->mode = kc_ht_store_dynamic;
	if (kc_hashtables[(int)kc_a_storageclass_t]->dynamic_malloc_private_data != 0) {
		kc_ht_inc_level(kc_a_storageclass_t);
	}
	kc_hashtables[(int)kc_a_storageclass_t]->malloc_private_data = kc_hashtables[(int)kc_a_storageclass_t]->dynamic_malloc_private_data->malloc_private_data;
}

void kc_ht_inc_level
#ifdef KC_USE_PROTOTYPES
(kc_storageclass_t kc_a_storageclass_t)
#else
(kc_a_storageclass_t) kc_storageclass_t kc_a_storageclass_t;
#endif
{
	kc_private_malloc_t kc_a_private_malloc_t = (kc_private_malloc_t)MALLOC(sizeof(struct kc_tag_kc_private_malloc_t));
	kc_a_private_malloc_t->next = kc_hashtables[(int)kc_a_storageclass_t]->dynamic_malloc_private_data;
	if (kc_hashtables[(int)kc_a_storageclass_t]->dynamic_malloc_private_data != 0 ) {
		kc_hashtables[(int)kc_a_storageclass_t]->dynamic_malloc_private_data->prev = kc_a_private_malloc_t;
	}
	kc_a_private_malloc_t->prev = kc_hashtables[(int)kc_a_storageclass_t]->dec_dynamic_malloc_private_data;
	kc_a_private_malloc_t->malloc_private_data = (*kc_hashtables[(int)kc_a_storageclass_t]->malloc_initialise)();
	kc_hashtables[(int)kc_a_storageclass_t]->dynamic_malloc_private_data = kc_a_private_malloc_t;
}

void kc_ht_dec_level
#ifdef KC_USE_PROTOTYPES
(kc_storageclass_t kc_a_storageclass_t)
#else
(kc_a_storageclass_t) kc_storageclass_t kc_a_storageclass_t;
#endif
{
	int kc_i, kc_j, kc_m;
	kc_hashtableentry_t* kc_hte;

	kc_hashtable_t kc_a_hashtable_t = kc_hashtables[(int)kc_a_storageclass_t];
	if (kc_a_hashtable_t->dynamic_malloc_private_data != 0) {
		kc_a_hashtable_t->dec_dynamic_malloc_private_data = kc_a_hashtable_t->dynamic_malloc_private_data;
		kc_a_hashtable_t->dynamic_malloc_private_data = kc_a_hashtable_t->dynamic_malloc_private_data->next;
		for (kc_i=0; kc_i < kc_a_hashtable_t->size; kc_i++) {
			kc_m = (int)kc_ht_store_dynamic;
			kc_hte = &kc_a_hashtable_t->hashtable[kc_i][kc_m];
			for (kc_j=kc_hte->nr -1; kc_j >= 0; kc_j--) {
				kc_private_malloc_t kc_a_private_malloc_t = kc_a_hashtable_t->dec_dynamic_malloc_private_data;
				boolean kc_is_in_block = (*kc_a_hashtable_t->in_block)((kc_voidptr_t)kc_hte->index[kc_j].yt_casestring, kc_a_private_malloc_t->malloc_private_data);
#if 0 /* not necessary, because every kc_ht_dec_level call takes care of its own level */
				while ((!kc_is_in_block) && kc_a_private_malloc_t->prev) {
					kc_a_private_malloc_t = kc_a_private_malloc_t->prev;
					kc_is_in_block = (*kc_a_hashtable_t->in_block)((kc_voidptr_t)kc_hte->index[kc_j].yt_casestring, kc_a_private_malloc_t->malloc_private_data);
				}
#endif
				if (kc_is_in_block) {
					kc_hte->nr--;
					kc_hte->index[kc_j] = kc_hte->index[kc_hte->nr];
					kc_hte->index[kc_hte->nr].yt_casestring = 0;
				}
#ifdef KC_SEPARATE_HASH_LEVELS
				  else {
					break;
				}
#endif
		}	}
	} else {
		/* should be a better error message */
		/*SUPPRESS 622*/
		assert(kc_zero_constant); 
}	}

/* free the previous level(s) in the level-list, ie
 * the sublist that is reachable via dec_dynamic_malloc_private_data,
 * and via the prev field of the current dynamic node, if defined
 * follow prev's to the left start, freeing the blocks while moving
 * and freeing the administration nodes themselves
 */
static void kc_ht_do_free_level
#ifdef KC_USE_PROTOTYPES
(kc_hashtable_t kc_a_hashtable_t)
#else
(kc_a_hashtable_t) kc_hashtable_t kc_a_hashtable_t;
#endif
{	kc_private_malloc_t kc_a_private_malloc_t, kc_b_private_malloc_t;
	if (kc_a_hashtable_t->dec_dynamic_malloc_private_data != 0) {
		kc_a_private_malloc_t = kc_a_hashtable_t->dec_dynamic_malloc_private_data;
		while (kc_a_private_malloc_t != 0) {
			if (kc_a_hashtable_t->free_all_elements != 0) {
				(*kc_a_hashtable_t->free_all_elements)(kc_a_private_malloc_t->malloc_private_data);
			}
			kc_b_private_malloc_t = kc_a_private_malloc_t;
			kc_a_private_malloc_t = kc_a_private_malloc_t->prev;
			KC_BZERO(kc_b_private_malloc_t, sizeof(struct kc_tag_kc_private_malloc_t));
			FREE((kc_voidptr_t)kc_b_private_malloc_t);
		}
		kc_a_hashtable_t->dec_dynamic_malloc_private_data = 0;
		if (kc_a_hashtable_t->dynamic_malloc_private_data != 0) {
			kc_a_hashtable_t->dynamic_malloc_private_data->prev = 0;
}	}	}

void kc_ht_free_level
#ifdef KC_USE_PROTOTYPES
(kc_storageclass_t kc_a_storageclass_t)
#else
(kc_a_storageclass_t) kc_storageclass_t kc_a_storageclass_t;
#endif
{
	kc_ht_do_free_level(kc_hashtables[(int)kc_a_storageclass_t]);
}

static int kc_choose_prime
#ifdef KC_USE_PROTOTYPES
(int kc_a_size)
#else
(kc_a_size) int kc_a_size;
#endif
{	int kc_i =0;
	while((kc_primes[kc_i] < kc_a_size) && (kc_primes[kc_i+1] > 0)) {
		kc_i++;
	}
	return kc_primes[kc_i];
}

kc_hashtable_t kc_ht_create_bucketmanagement
#ifdef KC_USE_PROTOTYPES
(int kc_a_size,
 kc_voidptr_t (*kc_a_malloc_initialise)(),
 kc_voidptr_t (*kc_a_malloc)(kc_size_t, kc_voidptr_t),
 void (*kc_a_free_element)(kc_voidptr_t, kc_voidptr_t),
 void (*kc_a_free_all_elements)(kc_voidptr_t),
 boolean (*kc_a_in_block)(kc_voidptr_t, kc_voidptr_t),
 void (*kc_a_malloc_info)(FILE*, kc_voidptr_t),
 kc_voidptr_t (*kc_a_bucket_alloc_initialise)(),
 kc_voidptr_t (*kc_a_bucket_calloc)(kc_size_t, kc_size_t, kc_voidptr_t),
 kc_voidptr_t (*kc_a_bucket_realloc)( kc_voidptr_t, kc_size_t, kc_size_t, kc_voidptr_t),
 void (*kc_a_free_bucket)(kc_voidptr_t, kc_size_t, kc_voidptr_t),
 void (*kc_a_free_buckets)(kc_voidptr_t),
 int kc_a_bucket_alloc_inc,
 void (*kc_a_bucket_alloc_info)(FILE*, kc_voidptr_t)
)
#else
(kc_a_size,
 kc_a_malloc_initialise,
 kc_a_malloc,
 kc_a_free_element,
 kc_a_free_all_elements,
 kc_a_in_block,
 kc_a_malloc_info,
 kc_a_bucket_alloc_initialise,
 kc_a_bucket_calloc,
 kc_a_bucket_realloc,
 kc_a_free_bucket,
 kc_a_free_buckets,
 kc_a_bucket_alloc_inc,
 kc_a_bucket_alloc_info
)
 int kc_a_size;
 kc_voidptr_t (*kc_a_malloc_initialise)KC__P(());
 kc_voidptr_t (*kc_a_malloc)KC__P((kc_size_t, kc_voidptr_t));
 void (*kc_a_free_element)KC__P((kc_voidptr_t, kc_voidptr_t));
 void (*kc_a_free_all_elements)KC__P((kc_voidptr_t));
 boolean (*kc_a_in_block)KC__P((kc_voidptr_t, kc_voidptr_t));
 void (*kc_a_malloc_info)KC__P((FILE*, kc_voidptr_t));
 kc_voidptr_t (*kc_a_bucket_alloc_initialise)KC__P(());
 kc_voidptr_t (*kc_a_bucket_calloc)KC__P((kc_size_t, size_t, kc_voidptr_t));
 kc_voidptr_t (*kc_a_bucket_realloc)KC__P(( kc_voidptr_t, kc_size_t, kc_size_t, kc_voidptr_t));
 void (*kc_a_free_bucket)KC__P((kc_voidptr_t, kc_size_t, kc_voidptr_t));
 void (*kc_a_free_buckets)KC__P((kc_voidptr_t));
 int kc_a_bucket_alloc_inc;
 void (*kc_a_bucket_alloc_info)KC__P((FILE*, kc_voidptr_t));
#endif
{	kc_hashtable_t kc_a_hashtable_t = (kc_hashtable_t)MALLOC(sizeof(kc_hashtable_struct_t));
	kc_a_hashtable_t->size = kc_choose_prime(kc_a_size);
	kc_a_hashtable_t->hashtable = (kc_hashtableentry_t(*)[(int)kc_last_storage_mode])CALLOC((kc_size_t)kc_a_hashtable_t->size*((int)kc_last_storage_mode), (kc_size_t)sizeof(kc_hashtableentry_t));

	kc_a_hashtable_t->malloc_initialise = kc_a_malloc_initialise;
	kc_a_hashtable_t->malloc = kc_a_malloc;
	kc_a_hashtable_t->free_element = kc_a_free_element;
	kc_a_hashtable_t->free_all_elements = kc_a_free_all_elements;
	kc_a_hashtable_t->in_block = kc_a_in_block;
	kc_a_hashtable_t->static_malloc_private_data = (kc_voidptr_t)(*kc_a_hashtable_t->malloc_initialise)();
	kc_a_hashtable_t->malloc_private_data = kc_a_hashtable_t->static_malloc_private_data;
	kc_a_hashtable_t->dynamic_malloc_private_data = 0;
	kc_a_hashtable_t->dec_dynamic_malloc_private_data = 0;
	kc_a_hashtable_t->mode = kc_ht_store_static;
	kc_a_hashtable_t->malloc_info = kc_a_malloc_info;

	kc_a_hashtable_t->bucket_alloc_initialise = kc_a_bucket_alloc_initialise;
	kc_a_hashtable_t->bucket_calloc = kc_a_bucket_calloc;
	kc_a_hashtable_t->bucket_realloc = kc_a_bucket_realloc;
	kc_a_hashtable_t->free_bucket = kc_a_free_bucket;
	kc_a_hashtable_t->free_buckets = kc_a_free_buckets;
	kc_a_hashtable_t->bucket_alloc_info = kc_a_bucket_alloc_info;
	kc_a_hashtable_t->bucket_alloc_inc = (kc_a_bucket_alloc_inc ? kc_a_bucket_alloc_inc : KC_BUCKET_INC);
	kc_a_hashtable_t->bucket_alloc_private_data = (kc_a_hashtable_t->bucket_alloc_initialise)
						      ? (kc_voidptr_t)(*kc_a_hashtable_t->bucket_alloc_initialise)()
						      : 0;

	kc_a_hashtable_t->kc_to_be_freed = 1;
	kc_a_hashtable_t->next = kc_all_hashtables;
	kc_a_hashtable_t->prev = kc_all_hashtables->prev;
	kc_all_hashtables->prev->next = kc_a_hashtable_t;
	kc_all_hashtables->prev = kc_a_hashtable_t;
	kc_all_hashtables = kc_a_hashtable_t;
	return kc_a_hashtable_t;
}

kc_hashtable_t kc_ht_create
#ifdef KC_USE_PROTOTYPES
(int kc_a_size, kc_voidptr_t (*kc_a_malloc_initialise)(), kc_voidptr_t (*kc_a_malloc)(kc_size_t, kc_voidptr_t),
 void (*kc_a_free_element)(kc_voidptr_t, kc_voidptr_t), void (*kc_a_free_all_elements)(kc_voidptr_t),
 boolean (*kc_a_in_block)(kc_voidptr_t, kc_voidptr_t))
#else
(kc_a_size, kc_a_malloc_initialise, kc_a_malloc, kc_a_free_element, kc_a_free_all_elements, kc_a_in_block)
 int kc_a_size; kc_voidptr_t (*kc_a_malloc_initialise)KC__P(()); kc_voidptr_t (*kc_a_malloc)KC__P((kc_size_t, kc_voidptr_t));
 void (*kc_a_free_element)KC__P((kc_voidptr_t, kc_voidptr_t)); void (*kc_a_free_all_elements)KC__P((kc_voidptr_t));
 boolean (*kc_a_in_block)KC__P((kc_voidptr_t, kc_voidptr_t));
#endif
{
	kc_voidptr_t (*kc_tmp_malloc_initialise)KC__P(()) = (kc_voidptr_t(*)())UNIQMALLOCINIT;
	void (*kc_tmp_malloc_info)KC__P((FILE*, kc_voidptr_t)) = (kc_tmp_malloc_initialise == kc_a_malloc_initialise)
								? (void(*)KC__P((FILE*, kc_voidptr_t)))UNIQMEMORYINFO
								: (void(*)KC__P((FILE*, kc_voidptr_t)))0
								;
	/* do something special (wrt mallocinfo?) if we know that our malloc is being used */
	return kc_ht_create_bucketmanagement(kc_a_size, kc_a_malloc_initialise, kc_a_malloc, kc_a_free_element, kc_a_free_all_elements, kc_a_in_block, kc_tmp_malloc_info,
					    (kc_voidptr_t(*)())BUCKETALLOCINIT, BUCKETCALLOC, BUCKETREALLOC, BUCKETFREE, (void(*)KC__P((kc_voidptr_t)))BUCKETSFREE,
					     BUCKETINC, (void(*)KC__P((FILE*, kc_voidptr_t)))BUCKETMEMORYINFO);
}

kc_hashtable_t kc_ht_create_simple
#ifdef KC_USE_PROTOTYPES
(int kc_a_size)
#else
(kc_a_size) int kc_a_size;
#endif
{
	return kc_ht_create_bucketmanagement(kc_a_size, (kc_voidptr_t(*)())UNIQMALLOCINIT, UNIQMALLOC2, (void (*)KC__P((kc_voidptr_t, kc_voidptr_t)))0/*UNIQFREEELEMENT*/, UNIQFREEALL, INUNIQBLOCK,
			    UNIQMEMORYINFO, (kc_voidptr_t(*)())BUCKETALLOCINIT, BUCKETCALLOC, BUCKETREALLOC, BUCKETFREE, (void(*)KC__P((kc_voidptr_t)))BUCKETSFREE, BUCKETINC, (void(*)KC__P((FILE*, kc_voidptr_t)))BUCKETMEMORYINFO);
}

kc_hashtable_t kc_ht_assign
#ifdef KC_USE_PROTOTYPES
(kc_hashtable_t kc_a_hashtable_t, kc_storageclass_t kc_a_storageclass_t)
#else
(kc_a_hashtable_t, kc_a_storageclass_t) kc_hashtable_t kc_a_hashtable_t; kc_storageclass_t kc_a_storageclass_t;
#endif
{	kc_hashtable_t kc_tmp = kc_hashtables[(int)kc_a_storageclass_t];
	kc_hashtables[(int)kc_a_storageclass_t] = kc_a_hashtable_t;
	kc_storageclass_still_uniq[(int)kc_a_storageclass_t] = False;
	return kc_tmp;
}

kc_hashtable_t kc_ht_assigned
#ifdef KC_USE_PROTOTYPES
(kc_storageclass_t kc_a_storageclass_t)
#else
(kc_a_storageclass_t) kc_storageclass_t kc_a_storageclass_t;
#endif
{	return kc_hashtables[(int)kc_a_storageclass_t];
}

static void kc_ht_free_single_elements
#ifdef KC_USE_PROTOTYPES
(kc_hashtable_t kc_a_hashtable_t, int kc_i, int kc_m)
#else
(kc_a_hashtable_t, kc_i, kc_m) kc_hashtable_t kc_a_hashtable_t; int kc_i; int kc_m;
#endif
{	int kc_j;
	if ((int)kc_m == (int)kc_ht_store_static) {
		for (kc_j=0; kc_j < kc_a_hashtable_t->hashtable[kc_i][kc_m].nr; kc_j++) {
			(*kc_a_hashtable_t->free_element)((kc_voidptr_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].index[kc_j].yt_casestring, kc_a_hashtable_t->static_malloc_private_data);
		}
	} else {
		kc_voidptr_t kc_a_private_data = 0;
		if ((kc_a_hashtable_t->dynamic_malloc_private_data == 0) || (kc_a_hashtable_t->dynamic_malloc_private_data->malloc_private_data == 0)) {
			kc_a_private_data = 0;
		} else if (kc_a_hashtable_t->dynamic_malloc_private_data->next == 0) {
			kc_a_private_data = kc_a_hashtable_t->dynamic_malloc_private_data->malloc_private_data;
		}
		for (kc_j=0; kc_j < kc_a_hashtable_t->hashtable[kc_i][kc_m].nr; kc_j++) {
			(*kc_a_hashtable_t->free_element)((kc_voidptr_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].index[kc_j].yt_casestring, kc_a_private_data);
		}
	}
}

static void kc_ht_do_clear_all_elements
#ifdef KC_USE_PROTOTYPES
(kc_hashtable_t kc_a_hashtable_t, boolean kc_reuse, boolean kc_reinit)
#else
(kc_a_hashtable_t, kc_reuse, kc_reinit) kc_hashtable_t kc_a_hashtable_t; boolean kc_reuse; boolean kc_reinit;
#endif
{	int kc_i, kc_m;
	kc_private_malloc_t kc_a_private_malloc_t;
/* free all static stuff */
	(*kc_a_hashtable_t->free_all_elements)(kc_a_hashtable_t->static_malloc_private_data);
/* free all dynamic stuff */
	/* walk to end of list of levels, kc_ht_do_free_level will free last and all
	 * previous levels in the list
	 */
	if (kc_a_hashtable_t->dynamic_malloc_private_data != 0) {
		kc_a_private_malloc_t = kc_a_hashtable_t->dynamic_malloc_private_data;
		while(kc_a_private_malloc_t->next != 0) {
			kc_a_private_malloc_t = kc_a_private_malloc_t->next;
		}
		kc_a_hashtable_t->dec_dynamic_malloc_private_data = kc_a_private_malloc_t;
		kc_a_hashtable_t->dynamic_malloc_private_data = 0;
		kc_ht_do_free_level(kc_a_hashtable_t);
	}
/* free/reuse the buckets, and re-initialize the hashtable-entries */
	if (kc_reuse) { /* zero the buckets; reset nr field */
		for (kc_i=0; kc_i < kc_a_hashtable_t->size; kc_i++) {
			for (kc_m=0; kc_m < (int)kc_last_storage_mode; kc_m++) {
				/* we only do something if nr !=0, else there is nothing to do
				 * because of our 'invariant'
				 */
				if (kc_a_hashtable_t->hashtable[kc_i][kc_m].nr) {
					KC_BZERO((kc_voidptr_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].index,
					 	 (kc_size_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound * sizeof(YYSTYPE));
					kc_a_hashtable_t->hashtable[kc_i][kc_m].nr = 0;
		}	}	}
	} else if (kc_reinit) { /* zero & free the buckets; reset nr, index, ibound fields */
		if (kc_a_hashtable_t->free_buckets) {
			(*kc_a_hashtable_t->free_buckets)(kc_a_hashtable_t->bucket_alloc_private_data);
			KC_BZERO(kc_a_hashtable_t->hashtable, (kc_size_t)kc_a_hashtable_t->size*((int)kc_last_storage_mode)*sizeof(kc_hashtableentry_t));
#if 0
			for (kc_i=0; kc_i < kc_a_hashtable_t->size; kc_i++) {
				for (kc_m=0; kc_m < (int)kc_last_storage_mode; kc_m++) {
					/* we do something if ibound !=0, it is not suficient to
					 * look only at the nr field, because the nr field might be
					 * reset in a previous reuse operation.
					 * we could as well look for an non-null index field.
					 */
					if (kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound) {
						kc_a_hashtable_t->hashtable[kc_i][kc_m].index = 0;
						kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound = 0;
						kc_a_hashtable_t->hashtable[kc_i][kc_m].nr = 0;
			}	}	}
#endif
		} else if (kc_a_hashtable_t->free_bucket) {
			for (kc_i=0; kc_i < kc_a_hashtable_t->size; kc_i++) {
				for (kc_m=0; kc_m < (int)kc_last_storage_mode; kc_m++) {
					/* we do something if ibound !=0, it is not suficient to
					 * look only at the nr field, because the nr field might be
					 * reset in a previous reuse operation.
					 * we could as well look for an non-null index field.
					 */
					if (kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound) {
						KC_BZERO((kc_voidptr_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].index,
							  (kc_size_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound * sizeof(YYSTYPE));
						(*kc_a_hashtable_t->free_bucket)((kc_voidptr_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].index,
										 (kc_size_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound * sizeof(YYSTYPE),
										 kc_a_hashtable_t->bucket_alloc_private_data);
						kc_a_hashtable_t->hashtable[kc_i][kc_m].index = 0;
						kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound = 0;
						kc_a_hashtable_t->hashtable[kc_i][kc_m].nr = 0;
			}	}	}
		} else {
			/* should be a better error message */
			/*SUPPRESS 622*/
			assert(kc_zero_constant); 
		}
	} else { /* zero & free the buckets */
		if (kc_a_hashtable_t->free_buckets) {
			(*kc_a_hashtable_t->free_buckets)(kc_a_hashtable_t->bucket_alloc_private_data);
		} else if (kc_a_hashtable_t->free_bucket) {
			for (kc_i=0; kc_i < kc_a_hashtable_t->size; kc_i++) {
				for (kc_m=0; kc_m < (int)kc_last_storage_mode; kc_m++) {
					/* we do something if index !=0, it is not suficient to
					 * look only at the nr field, because the nr field might be
					 * reset in a previous reuse operation.
					 * we could as well look for an non-null ibound field.
					 */
					if (kc_a_hashtable_t->hashtable[kc_i][kc_m].index) {
						KC_BZERO((kc_voidptr_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].index,
							  (kc_size_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound * sizeof(YYSTYPE));
						(*kc_a_hashtable_t->free_bucket)((kc_voidptr_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].index,
										 (kc_size_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound * sizeof(YYSTYPE),
										 kc_a_hashtable_t->bucket_alloc_private_data);
			}	}	}
		} else {
			/* should be a better error message */
			/*SUPPRESS 622*/
			assert(kc_zero_constant); 
		}
	}
}

static void kc_ht_do_clear_no_all_elements
#ifdef KC_USE_PROTOTYPES
(kc_hashtable_t kc_a_hashtable_t, boolean kc_reuse, boolean kc_reinit)
#else
(kc_a_hashtable_t, kc_reuse, kc_reinit) kc_hashtable_t kc_a_hashtable_t; boolean kc_reuse; boolean kc_reinit;
#endif
{	int kc_i, kc_m;
/* free all static stuff */
	/* done on the fly, below */
/* free all dynamic stuff */
	/* done on the fly, below */
/* free/reuse the buckets, and re-initialize the hashtable-entries */
	if (kc_reuse) { /* zero the buckets; reset nr field */
		for (kc_i=0; kc_i < kc_a_hashtable_t->size; kc_i++) {
			for (kc_m=0; kc_m < (int)kc_last_storage_mode; kc_m++) {
				/* we only do something if nr !=0, else there is nothing to do
				 * because of our 'invariant'
				 */
				if (kc_a_hashtable_t->hashtable[kc_i][kc_m].nr) {
					kc_ht_free_single_elements(kc_a_hashtable_t, kc_i, kc_m);
					KC_BZERO((kc_voidptr_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].index,
					 	 (kc_size_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound * sizeof(YYSTYPE));
					kc_a_hashtable_t->hashtable[kc_i][kc_m].nr = 0;
		}	}	}
	} else if (kc_reinit) { /* zero & free the buckets; reset nr, index, ibound fields */
		if (kc_a_hashtable_t->free_buckets) {
			(*kc_a_hashtable_t->free_buckets)(kc_a_hashtable_t->bucket_alloc_private_data);
			KC_BZERO(kc_a_hashtable_t->hashtable, (kc_size_t)kc_a_hashtable_t->size*((int)kc_last_storage_mode)*sizeof(kc_hashtableentry_t));
#if 0
			for (kc_i=0; kc_i < kc_a_hashtable_t->size; kc_i++) {
				for (kc_m=0; kc_m < (int)kc_last_storage_mode; kc_m++) {
					/* we do something if ibound !=0, it is not suficient to
					 * look only at the nr field, because the nr field might be
					 * reset in a previous reuse operation.
					 * we could as well look for an non-null index field.
					 */
					if (kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound) {
						kc_ht_free_single_elements(kc_a_hashtable_t, kc_i, kc_m);
						kc_a_hashtable_t->hashtable[kc_i][kc_m].index = 0;
						kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound = 0;
						kc_a_hashtable_t->hashtable[kc_i][kc_m].nr = 0;
			}	}	}
#endif
		} else if (kc_a_hashtable_t->free_bucket) {
			for (kc_i=0; kc_i < kc_a_hashtable_t->size; kc_i++) {
				for (kc_m=0; kc_m < (int)kc_last_storage_mode; kc_m++) {
					/* we do something if ibound !=0, it is not suficient to
					 * look only at the nr field, because the nr field might be
					 * reset in a previous reuse operation.
					 * we could as well look for an non-null index field.
					 */
					if (kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound) {
						kc_ht_free_single_elements(kc_a_hashtable_t, kc_i, kc_m);
						KC_BZERO((kc_voidptr_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].index,
							  (kc_size_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound * sizeof(YYSTYPE));
						(*kc_a_hashtable_t->free_bucket)((kc_voidptr_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].index,
										 (kc_size_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound * sizeof(YYSTYPE),
										 kc_a_hashtable_t->bucket_alloc_private_data);
						kc_a_hashtable_t->hashtable[kc_i][kc_m].index = 0;
						kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound = 0;
						kc_a_hashtable_t->hashtable[kc_i][kc_m].nr = 0;
			}	}	}
		} else {
			/* should be a better error message */
			/*SUPPRESS 622*/
			assert(kc_zero_constant); 
		}
	} else { /* zero & free the buckets */
		if (kc_a_hashtable_t->free_buckets) {
			(*kc_a_hashtable_t->free_buckets)(kc_a_hashtable_t->bucket_alloc_private_data);
		} else if (kc_a_hashtable_t->free_bucket) {
			for (kc_i=0; kc_i < kc_a_hashtable_t->size; kc_i++) {
				for (kc_m=0; kc_m < (int)kc_last_storage_mode; kc_m++) {
					/* we do something if index !=0, it is not suficient to
					 * look only at the nr field, because the nr field might be
					 * reset in a previous reuse operation.
					 * we could as well look for an non-null ibound field.
					 */
					if (kc_a_hashtable_t->hashtable[kc_i][kc_m].index) {
						kc_ht_free_single_elements(kc_a_hashtable_t, kc_i, kc_m);
						KC_BZERO((kc_voidptr_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].index,
							  (kc_size_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound * sizeof(YYSTYPE));
						(*kc_a_hashtable_t->free_bucket)((kc_voidptr_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].index,
										 (kc_size_t)kc_a_hashtable_t->hashtable[kc_i][kc_m].ibound * sizeof(YYSTYPE),
										 kc_a_hashtable_t->bucket_alloc_private_data);
			}	}	}
		} else {
			/* should be a better error message */
			/*SUPPRESS 622*/
			assert(kc_zero_constant); 
		}
	}
}

static void kc_ht_do_clear
#ifdef KC_USE_PROTOTYPES
(kc_hashtable_t kc_a_hashtable_t, boolean kc_reuse, boolean kc_reinit)
#else
(kc_a_hashtable_t, kc_reuse, kc_reinit) kc_hashtable_t kc_a_hashtable_t; boolean kc_reuse; boolean kc_reinit;
#endif
{
	if (kc_a_hashtable_t->free_all_elements) {
		kc_ht_do_clear_all_elements(kc_a_hashtable_t, kc_reuse, kc_reinit);
	} else {
		kc_ht_do_clear_no_all_elements(kc_a_hashtable_t, kc_reuse, kc_reinit);
	}
}

void kc_ht_clear
#ifdef KC_USE_PROTOTYPES
(kc_hashtable_t kc_a_hashtable_t)
#else
(kc_a_hashtable_t) kc_hashtable_t kc_a_hashtable_t;
#endif
{
	kc_ht_do_clear(kc_a_hashtable_t, False, True );
	if (kc_a_hashtable_t->kc_to_be_freed) {
		kc_a_hashtable_t->static_malloc_private_data = (kc_voidptr_t)(*kc_a_hashtable_t->malloc_initialise)();
	} /* else: it is a statically allocated hashtable with a statically allocated
	   * static_malloc_private_data that will not be freed either... we have to
	   * trust that our free_all_elements routine (called via kc_ht_do_clear)
	   * prepares the static_malloc_private_data for reuse
	   */
	kc_a_hashtable_t->malloc_private_data = kc_a_hashtable_t->static_malloc_private_data;
	kc_a_hashtable_t->dynamic_malloc_private_data = 0;
	kc_a_hashtable_t->dec_dynamic_malloc_private_data = 0;
	kc_a_hashtable_t->mode = kc_ht_store_static;
	kc_a_hashtable_t->bucket_alloc_private_data = (kc_a_hashtable_t->bucket_alloc_initialise)
						      ? (kc_voidptr_t)(*kc_a_hashtable_t->bucket_alloc_initialise)()
						      : 0;
}

void kc_ht_reuse
#ifdef KC_USE_PROTOTYPES
(kc_hashtable_t kc_a_hashtable_t)
#else
(kc_a_hashtable_t) kc_hashtable_t kc_a_hashtable_t;
#endif
{
	kc_ht_do_clear(kc_a_hashtable_t, True, True );
	if (kc_a_hashtable_t->kc_to_be_freed) {
		kc_a_hashtable_t->static_malloc_private_data = (kc_voidptr_t)(*kc_a_hashtable_t->malloc_initialise)();
	} /* else: it is a statically allocated hashtable with a statically allocated
	   * static_malloc_private_data that will not be freed either... we have to
	   * trust that our free_all_elements routine (called via kc_ht_do_clear)
	   * prepares the static_malloc_private_data for reuse
	   */
	kc_a_hashtable_t->malloc_private_data = kc_a_hashtable_t->static_malloc_private_data;
	kc_a_hashtable_t->dynamic_malloc_private_data = 0;
	kc_a_hashtable_t->dec_dynamic_malloc_private_data = 0;
	kc_a_hashtable_t->mode = kc_ht_store_static;
	kc_a_hashtable_t->bucket_alloc_private_data = (kc_a_hashtable_t->bucket_alloc_initialise)
						      ? (kc_voidptr_t)(*kc_a_hashtable_t->bucket_alloc_initialise)()
						      : 0;
}

void kc_ht_delete
#ifdef KC_USE_PROTOTYPES
(kc_hashtable_t kc_a_hashtable_t)
#else
(kc_a_hashtable_t) kc_hashtable_t kc_a_hashtable_t;
#endif
{
	kc_ht_do_clear(kc_a_hashtable_t, False, False);
	if (kc_a_hashtable_t->kc_to_be_freed) {
		kc_a_hashtable_t->next->prev = kc_a_hashtable_t->prev;
		kc_a_hashtable_t->prev->next = kc_a_hashtable_t->next;
		if (kc_all_hashtables == kc_a_hashtable_t) {
			kc_all_hashtables = kc_a_hashtable_t->next;
		}
		KC_BZERO((kc_voidptr_t)kc_a_hashtable_t->hashtable,
			 (kc_size_t)sizeof(struct kc_tag_kc_hashtableentry_t) * kc_a_hashtable_t->size);
		FREE((kc_voidptr_t)kc_a_hashtable_t->hashtable);
		KC_BZERO((kc_voidptr_t)kc_a_hashtable_t, sizeof(struct kc_tag_kc_hashtable_struct_t));
		FREE((kc_voidptr_t)kc_a_hashtable_t);
}	}


/* atoms creation */
#ifdef KC_STDC
#  define kc_mylower(c) (isupper(c) ? tolower(c) : c)
#else
#  define kc_mylower(c) ((isascii(c) && isupper(c)) ? tolower(c) : c)
#endif
/* should be static, maybe? */
int kc_ci_strcmp
#ifdef KC_USE_PROTOTYPES
(char *kc_s1, char *kc_s2)
#else
(kc_s1, kc_s2) char *kc_s1, *kc_s2;
#endif
{	int tmp;
	while ((*kc_s1 != '\0') && (*kc_s2 != '\0')) {
		if ( (tmp = kc_mylower(*kc_s1) - kc_mylower(*kc_s2)) != 0 ) return tmp;
		kc_s1++;
		kc_s2++;
	}
	return( (*kc_s1 != '\0') - (*kc_s2 != '\0') );
}

static unsigned kc_casestrhash
#ifdef KC_USE_PROTOTYPES
(char *kc_s)
#else
(kc_s) char *kc_s;
#endif
{	register unsigned kc_i = 0;
	register char *kc_sp;

	for (kc_sp = kc_s; *kc_sp != '\0'; kc_sp++)
		kc_i = (unsigned)((kc_i * 75) + *kc_sp);
	return kc_i;
}

static unsigned kc_nocasestrhash
#ifdef KC_USE_PROTOTYPES
(char *kc_s)
#else
(kc_s) char *kc_s;
#endif
{	register unsigned kc_i = 0;
	register char *kc_sp;

	for (kc_sp = kc_s; *kc_sp != '\0'; kc_sp++)
		kc_i = (unsigned)((kc_i * 75) + kc_mylower(*kc_sp));
	return kc_i;
}

#undef kc_mylower

static decl kc_initialize_decl
#ifdef KC_USE_PROTOTYPES
(decl kc_x)
#else
(kc_x) decl kc_x;
#endif
{
#line 44 "pfunctions.k"

		{
#line 45 "pfunctions.k"
decl kc_selvar_0_1 = 
kc_x
;
#line 45 "pfunctions.k"
/*SUPPRESS 622*/
assert_decl(kc_selvar_0_1, "with_expression (1)");

#line 2414 "k.c"
		if (( kc_selvar_0_1->prod_sel == sel_Action)) {
#line 46 "pfunctions.k"

				kc_selvar_0_1->eventidx = mkeventidx();
			
#line 2420 "k.c"
		} else
{
#line 49 "pfunctions.k"
/*EMPTY*/
#line 2425 "k.c"
}
}
#line 51 "pfunctions.k"
	
#line 2430 "k.c"

#line 2432 "k.c"
	return kc_x;
}

static expr kc_initialize_expr
#ifdef KC_USE_PROTOTYPES
(expr kc_x)
#else
(kc_x) expr kc_x;
#endif
{
#line 52 "tracer.k"
	kc_x->parent =  0;

#line 2446 "k.c"
	return kc_x;
}

static id kc_initialize_id
#ifdef KC_USE_PROTOTYPES
(id kc_x)
#else
(kc_x) id kc_x;
#endif
{
#line 63 "tracer.k"
	kc_x->lineno =  0;
#line 64 "tracer.k"
	kc_x->column =  0;

#line 2462 "k.c"
	return kc_x;
}

static uid kc_initialize_uid
#ifdef KC_USE_PROTOTYPES
(uid kc_x)
#else
(kc_x) uid kc_x;
#endif
{
#line 73 "tracer.k"
	kc_x->ast =  0;
#line 74 "tracer.k"
	kc_x->lineno =  0;
#line 75 "tracer.k"
	kc_x->column =  0;

#line 2480 "k.c"
	return kc_x;
}

static idx2event kc_initialize_idx2event
#ifdef KC_USE_PROTOTYPES
(idx2event kc_x)
#else
(kc_x) idx2event kc_x;
#endif
{
#line 174 "pfunctions.k"
	kc_x->ast =  0;

#line 2494 "k.c"
	return kc_x;
}

static location kc_initialize_location
#ifdef KC_USE_PROTOTYPES
(location kc_x)
#else
(kc_x) location kc_x;
#endif
{
#line 66 "krfsm.k"
	kc_x->t =  Niltransitions();
#line 68 "krfsm.k"

		alllocptr = Conslocations(kc_x, allloc());
		kc_x->f.hit = 0;
		kc_x->f.accept = 0;
	
#line 2513 "k.c"

#line 2515 "k.c"
	return kc_x;
}

static transition kc_initialize_transition
#ifdef KC_USE_PROTOTYPES
(transition kc_x)
#else
(kc_x) transition kc_x;
#endif
{
#line 78 "krfsm.k"
	kc_x->id =  transnr++;
#line 79 "krfsm.k"
	kc_x->src =  0;
#line 80 "krfsm.k"
	kc_x->dst =  Nillocations();
#line 82 "krfsm.k"

		MapTransition(kc_x->id)->p = kc_x;
	
#line 2536 "k.c"

#line 2538 "k.c"
	return kc_x;
}

static map kc_initialize_map
#ifdef KC_USE_PROTOTYPES
(map kc_x)
#else
(kc_x) map kc_x;
#endif
{
#line 5 "map.k"
	kc_x->p =  0;

#line 2552 "k.c"
	return kc_x;
}

static event kc_initialize_event
#ifdef KC_USE_PROTOTYPES
(event kc_x)
#else
(kc_x) event kc_x;
#endif
{
#line 27 "expand.k"
	kc_x->id =   eventnr++;
#line 28 "expand.k"
	kc_x->from =  0;
#line 29 "expand.k"
	kc_x->succ =  0;
#line 30 "expand.k"
	kc_x->t =  0;
#line 31 "expand.k"

		MapEvent(kc_x->id)->p = kc_x;
	
#line 2575 "k.c"

#line 2577 "k.c"
	return kc_x;
}

static state kc_initialize_state
#ifdef KC_USE_PROTOTYPES
(state kc_x)
#else
(kc_x) state kc_x;
#endif
{
#line 44 "expand.k"
	kc_x->id =   -1;

#line 2591 "k.c"
	return kc_x;
}

casestring mkcasestring
#ifdef KC_USE_PROTOTYPES
(char *kc_s)
#else
(kc_s) char *kc_s;
#endif
{	register casestring kc_x;
	int kc_i;
	register kc_hashtableentry_t* kc_hte;
	unsigned kc_hashval = (unsigned)0;
	YYSTYPE *kc_ptr, *kc_beyond;
	kc_hashtable_t kc_a_ht = kc_hashtables[(int)uniq];

	KC_COLLECT_STATS0(KC_CREATE_STATS(sel__Str));
	OPERATORHASH((unsigned) sel__Str);
	CASESTRHASH(kc_s);
	kc_hashval = kc_hashval%kc_a_ht->size;
	for (kc_i=0; kc_i < (int)kc_last_storage_mode; kc_i++) {
		kc_hte = &(kc_a_ht->hashtable[kc_hashval][kc_i]);
		if (kc_hte->nr != 0) {
			kc_beyond = &kc_hte->index[kc_hte->nr];
			for (kc_ptr = &kc_hte->index[0]; kc_ptr < kc_beyond; kc_ptr++){
				kc_x= kc_ptr->yt_casestring;
				if ((kc_x->prod_sel == sel__Str) && (strcmp(kc_x->name, kc_s) == 0))
					return(kc_x);
	}	}	}
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel__Str));
	kc_hte = &(kc_a_ht->hashtable[kc_hashval][(int)kc_a_ht->mode]);
	if (kc_hte->nr >= kc_hte->ibound) kc_growindex(kc_hte, kc_a_ht);
	kc_x = (casestring)(*kc_a_ht->malloc)((kc_size_t)sizeof(struct kc_tag_casestring), kc_a_ht->malloc_private_data);
	kc_x->name = (char*)(*kc_a_ht->malloc)((kc_size_t)(strlen(kc_s))+1, kc_a_ht->malloc_private_data);
	kc_x->prod_sel = sel__Str;
	(void)strcpy(kc_x->name, kc_s);
	kc_hte->index[kc_hte->nr++].yt_casestring = kc_x;
	KC_COLLECT_STATS0(kc_casestring_strlen += strlen(kc_s)+1;);
	return kc_x;
}

nocasestring mknocasestring
#ifdef KC_USE_PROTOTYPES
(char *kc_s)
#else
(kc_s) char *kc_s;
#endif
{	register nocasestring kc_x;
	int kc_i;
	register kc_hashtableentry_t* kc_hte;
	unsigned kc_hashval = (unsigned)0;
	YYSTYPE *kc_ptr, *kc_beyond;
	kc_hashtable_t kc_a_ht = kc_hashtables[(int)uniq];

	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_NoCaseStr));
	OPERATORHASH((unsigned) sel_NoCaseStr);
	NOCASESTRHASH(kc_s);
	kc_hashval = kc_hashval%kc_a_ht->size;
	for (kc_i=0; kc_i < (int)kc_last_storage_mode; kc_i++) {
		kc_hte = &(kc_a_ht->hashtable[kc_hashval][kc_i]);
		if (kc_hte->nr != 0) {
			kc_beyond = &kc_hte->index[kc_hte->nr];
			for (kc_ptr = &kc_hte->index[0]; kc_ptr < kc_beyond; kc_ptr++){
				kc_x= kc_ptr->yt_nocasestring;
				if ((kc_x->prod_sel == sel_NoCaseStr) && (kc_ci_strcmp(kc_x->name, kc_s) == 0))
					return(kc_x);
	}	}	}
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_NoCaseStr));
	kc_hte = &(kc_a_ht->hashtable[kc_hashval][(int)kc_a_ht->mode]);
	if (kc_hte->nr >= kc_hte->ibound) kc_growindex(kc_hte, kc_a_ht);
	kc_x = (nocasestring)(*kc_a_ht->malloc)((kc_size_t)sizeof(struct kc_tag_nocasestring), kc_a_ht->malloc_private_data);
	kc_x->name = (char*)(*kc_a_ht->malloc)((kc_size_t)(strlen(kc_s))+1, kc_a_ht->malloc_private_data);
	kc_x->prod_sel = sel_NoCaseStr;
	(void)strcpy(kc_x->name, kc_s);
	kc_hte->index[kc_hte->nr++].yt_nocasestring = kc_x;
	KC_COLLECT_STATS0(kc_nocasestring_strlen += strlen(kc_s)+1;);
	return kc_x;
}

kc_hashnode_t kc_mksharinghashnode
#ifdef KC_USE_PROTOTYPES
(YYSTYPE kc_s, kc_hashtable_t kc_a_ht, kc_enum_phyla kc_phylum)
#else
(kc_s, kc_a_ht, kc_phylum) YYSTYPE kc_s; kc_hashtable_t kc_a_ht; kc_enum_phyla kc_phylum;
#endif
{
	register kc_hashnode_t kc_x;
	int kc_i;
	register kc_hashtableentry_t* kc_hte;
	unsigned kc_hashval = (unsigned)0;
	YYSTYPE *kc_ptr, *kc_beyond;

	switch(kc_phylum) {
	case (int)kc_phylum_int: INTHASH(kc_s.yt_int); break;
	case (int)kc_phylum_float: FLOATHASH(kc_s.yt_float); break;
	default: HASH(kc_s.yt_voidptr); break;
	}
	kc_hashval = kc_hashval%kc_a_ht->size;
	for (kc_i=0; kc_i < (int)kc_last_storage_mode; kc_i++) {
		kc_hte = &(kc_a_ht->hashtable[kc_hashval][kc_i]);
		if (kc_hte->nr != 0) {
			kc_beyond = &kc_hte->index[kc_hte->nr];
			for (kc_ptr = &kc_hte->index[0]; kc_ptr < kc_beyond; kc_ptr++){
				kc_x= kc_ptr->yt_kc_hashnode_t;
				if ((kc_x->prod_sel == (kc_enum_operators)0) &&
				    (((kc_phylum == kc_phylum_int) &&
				      (kc_x->ptr.yt_int == kc_s.yt_int)) ||
				     ((kc_phylum == kc_phylum_float) &&
				      (kc_x->ptr.yt_float == kc_s.yt_float)) ||
				     (kc_x->ptr.yt_voidptr == kc_s.yt_voidptr)))
					return(kc_x);
	}	}	}
	kc_hte = &(kc_a_ht->hashtable[kc_hashval][(int)kc_a_ht->mode]);
	if (kc_hte->nr >= kc_hte->ibound) kc_growindex(kc_hte, kc_a_ht);
	kc_x = (kc_hashnode_t)(*kc_a_ht->malloc)((kc_size_t)sizeof(struct kc_tag_kc_hashnode_t), kc_a_ht->malloc_private_data);
	kc_x->ptr = kc_s;
	kc_x->number = -1; /* IMPORTANT: some code depends on this -1 */
	kc_x->created = False;
	kc_x->prod_sel = (kc_enum_operators)0;
	kc_hte->index[kc_hte->nr++].yt_kc_hashnode_t = kc_x;
	return kc_x;
}
/*ARGSUSED*/
kc_hashnode_t kc_mknonsharinghashnode
#ifdef KC_USE_PROTOTYPES
(YYSTYPE kc_s, kc_hashtable_t kc_a_ht, kc_enum_phyla kc_phylum)
#else
(kc_s, kc_a_ht, kc_phylum) YYSTYPE kc_s; kc_hashtable_t kc_a_ht; kc_enum_phyla kc_phylum;
#endif
{	static struct kc_tag_kc_hashnode_t kc_x_struct;
	kc_x_struct.number = -1; /* IMPORTANT: some code depends on this -1 */
	kc_x_struct.created = False;
	return &kc_x_struct;
}

kc_dotedgenode_t kc_mkdotedgenode
#ifdef KC_USE_PROTOTYPES
(kc_hashtable_t kc_a_ht, YYSTYPE kc_s_from, kc_enum_phyla kc_phy_from, YYSTYPE kc_s_to, kc_enum_phyla kc_phy_to, int kc_son_nr)
#else
(kc_a_ht, kc_s_from, kc_phy_from, kc_s_to, kc_phy_to, kc_son_nr) kc_hashtable_t kc_a_ht; YYSTYPE kc_s_from; kc_enum_phyla kc_phy_from; YYSTYPE kc_s_to; kc_enum_phyla kc_phy_to; int kc_son_nr;
#endif
{
	register kc_dotedgenode_t kc_x;
	int kc_i;
	register kc_hashtableentry_t* kc_hte;
	unsigned kc_hashval = (unsigned)0;
	YYSTYPE *kc_ptr, *kc_beyond;

	OPERATORHASH((unsigned) kc_phy_from);
	switch(kc_phy_from) {
	case (int)kc_phylum_int: INTHASH(kc_s_from.yt_int); break;
	case (int)kc_phylum_float: FLOATHASH(kc_s_from.yt_float); break;
	default: HASH(kc_s_from.yt_voidptr); break;
	}
	OPERATORHASH((unsigned) kc_phy_to);
	switch(kc_phy_to) {
	case (int)kc_phylum_int: INTHASH(kc_s_to.yt_int); break;
	case (int)kc_phylum_float: FLOATHASH(kc_s_to.yt_float); break;
	default: HASH(kc_s_to.yt_voidptr); break;
	}
	INTHASH(kc_son_nr);
	kc_hashval = kc_hashval%kc_a_ht->size;
	for (kc_i=0; kc_i < (int)kc_last_storage_mode; kc_i++) {
		kc_hte = &(kc_a_ht->hashtable[kc_hashval][kc_i]);
		if (kc_hte->nr != 0) {
			kc_beyond = &kc_hte->index[kc_hte->nr];
			for (kc_ptr = &kc_hte->index[0]; kc_ptr < kc_beyond; kc_ptr++){
				kc_x= kc_ptr->yt_kc_dotedgenode_t;
				if ((kc_x->prod_sel == (kc_enum_operators)0) &&
				    (kc_x->phy_from == kc_phy_from) &&
				    (kc_x->phy_to == kc_phy_to) &&
				    (kc_x->son_nr == kc_son_nr) &&
				    (((kc_phy_from == kc_phylum_int) &&
				      (kc_x->ptr_from.yt_int == kc_s_from.yt_int)) ||
				     ((kc_phy_from == kc_phylum_float) &&
				      (kc_x->ptr_from.yt_float == kc_s_from.yt_float)) ||
				     (kc_x->ptr_from.yt_voidptr == kc_s_from.yt_voidptr)) &&
				    (((kc_phy_to == kc_phylum_int) &&
				      (kc_x->ptr_to.yt_int == kc_s_to.yt_int)) ||
				     ((kc_phy_to == kc_phylum_float) &&
				      (kc_x->ptr_to.yt_float == kc_s_to.yt_float)) ||
				     (kc_x->ptr_to.yt_voidptr == kc_s_to.yt_voidptr)) )
					return(kc_x);
	}	}	}
	kc_hte = &(kc_a_ht->hashtable[kc_hashval][(int)kc_a_ht->mode]);
	if (kc_hte->nr >= kc_hte->ibound) kc_growindex(kc_hte, kc_a_ht);
	kc_x = (kc_dotedgenode_t)(*kc_a_ht->malloc)((kc_size_t)sizeof(struct kc_tag_kc_dotedgenode_t), kc_a_ht->malloc_private_data);
	kc_x->ptr_to = kc_s_to;
	kc_x->ptr_from = kc_s_from;
	kc_x->phy_from = kc_phy_from;
	kc_x->phy_to = kc_phy_to;
	kc_x->son_nr = kc_son_nr;
	kc_x->label = 0;
	kc_x->lsize = 0;
	kc_x->next = 0;
	kc_x->prod_sel = (kc_enum_operators)0;
	kc_hte->index[kc_hte->nr++].yt_kc_dotedgenode_t = kc_x;
	return kc_x;
}

spec Spec
#ifdef KC_USE_PROTOTYPES
(decllist decllist_1, asslist asslist_1, expr expr_1)
#else
(decllist_1, asslist_1, expr_1) decllist decllist_1;  asslist asslist_1;  expr expr_1; 
#endif
{	register spec kc_x = (spec) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_spec));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Spec));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Spec));
	/*SUPPRESS 622*/
	assert_decllist( decllist_1, "decllist_1" );
	/*SUPPRESS 622*/
	assert_asslist( asslist_1, "asslist_1" );
	/*SUPPRESS 622*/
	assert_expr( expr_1, "expr_1" );
	kc_x->prod_sel = sel_Spec;
	kc_x->u.Spec.decllist_1 = decllist_1;
	kc_x->u.Spec.asslist_1 = asslist_1;
	kc_x->u.Spec.expr_1 = expr_1;
	return kc_x;
}

decllist Nildecllist
#ifdef KC_USE_PROTOTYPES
()
#else
()
#endif
{	static decllist kc_x = (decllist)0;
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Nildecllist));
	if (kc_x == (decllist)0) {
		KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Nildecllist ));
		kc_x = (decllist)(*kc_hashtables[(int)kc_uniq_nullary_operator]->malloc)((kc_size_t)sizeof(struct kc_tag_decllist), kc_hashtables[(int)kc_uniq_nullary_operator]->malloc_private_data);
		kc_x->prod_sel = sel_Nildecllist;
	}
	return kc_x;
}

decllist Consdecllist
#ifdef KC_USE_PROTOTYPES
(decl decl_1, decllist decllist_1)
#else
(decl_1, decllist_1) decl decl_1;  decllist decllist_1; 
#endif
{	register decllist kc_x = (decllist) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_decllist));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Consdecllist));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Consdecllist));
	/*SUPPRESS 622*/
	assert_decl( decl_1, "decl_1" );
	/*SUPPRESS 622*/
	assert_decllist( decllist_1, "decllist_1" );
	kc_x->prod_sel = sel_Consdecllist;
	kc_x->u.Consdecllist.decl_1 = decl_1;
	kc_x->u.Consdecllist.decllist_1 = decllist_1;
	return kc_x;
}

decl ASet
#ifdef KC_USE_PROTOTYPES
(id id_1, decllist decllist_1)
#else
(id_1, decllist_1) id id_1;  decllist decllist_1; 
#endif
{	register decl kc_x = (decl) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_decl));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_ASet));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_ASet));
	/*SUPPRESS 622*/
	assert_id( id_1, "id_1" );
	/*SUPPRESS 622*/
	assert_decllist( decllist_1, "decllist_1" );
	kc_x->prod_sel = sel_ASet;
	kc_x->u.ASet.id_1 = id_1;
	kc_x->u.ASet.decllist_1 = decllist_1;
	kc_x = kc_initialize_decl(kc_x);
	return kc_x;
}

decl Action
#ifdef KC_USE_PROTOTYPES
(id id_1, casestring casestring_1)
#else
(id_1, casestring_1) id id_1;  casestring casestring_1; 
#endif
{	register decl kc_x = (decl) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_decl));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Action));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Action));
	/*SUPPRESS 622*/
	assert_id( id_1, "id_1" );
	/*SUPPRESS 622*/
	assert_casestring( casestring_1, "casestring_1" );
	kc_x->prod_sel = sel_Action;
	kc_x->u.Action.id_1 = id_1;
	kc_x->u.Action.casestring_1 = casestring_1;
	kc_x = kc_initialize_decl(kc_x);
	return kc_x;
}

asslist Nilasslist
#ifdef KC_USE_PROTOTYPES
()
#else
()
#endif
{	static asslist kc_x = (asslist)0;
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Nilasslist));
	if (kc_x == (asslist)0) {
		KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Nilasslist ));
		kc_x = (asslist)(*kc_hashtables[(int)kc_uniq_nullary_operator]->malloc)((kc_size_t)sizeof(struct kc_tag_asslist), kc_hashtables[(int)kc_uniq_nullary_operator]->malloc_private_data);
		kc_x->prod_sel = sel_Nilasslist;
	}
	return kc_x;
}

asslist Consasslist
#ifdef KC_USE_PROTOTYPES
(assign assign_1, asslist asslist_1)
#else
(assign_1, asslist_1) assign assign_1;  asslist asslist_1; 
#endif
{	register asslist kc_x = (asslist) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_asslist));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Consasslist));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Consasslist));
	/*SUPPRESS 622*/
	assert_assign( assign_1, "assign_1" );
	/*SUPPRESS 622*/
	assert_asslist( asslist_1, "asslist_1" );
	kc_x->prod_sel = sel_Consasslist;
	kc_x->u.Consasslist.assign_1 = assign_1;
	kc_x->u.Consasslist.asslist_1 = asslist_1;
	return kc_x;
}

assign Assign
#ifdef KC_USE_PROTOTYPES
(id id_1, expr expr_1)
#else
(id_1, expr_1) id id_1;  expr expr_1; 
#endif
{	register assign kc_x = (assign) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_assign));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Assign));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Assign));
	/*SUPPRESS 622*/
	assert_id( id_1, "id_1" );
	/*SUPPRESS 622*/
	assert_expr( expr_1, "expr_1" );
	kc_x->prod_sel = sel_Assign;
	kc_x->u.Assign.id_1 = id_1;
	kc_x->u.Assign.expr_1 = expr_1;
	return kc_x;
}

expr Dconcat
#ifdef KC_USE_PROTOTYPES
(expr expr_1, expr expr_2)
#else
(expr_1, expr_2) expr expr_1;  expr expr_2; 
#endif
{	register expr kc_x = (expr) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_expr));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Dconcat));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Dconcat));
	/*SUPPRESS 622*/
	assert_expr( expr_1, "expr_1" );
	/*SUPPRESS 622*/
	assert_expr( expr_2, "expr_2" );
	kc_x->prod_sel = sel_Dconcat;
	kc_x->u.Dconcat.expr_1 = expr_1;
	kc_x->u.Dconcat.expr_2 = expr_2;
	kc_x = kc_initialize_expr(kc_x);
	return kc_x;
}

expr Nconcat
#ifdef KC_USE_PROTOTYPES
(expr expr_1, expr expr_2)
#else
(expr_1, expr_2) expr expr_1;  expr expr_2; 
#endif
{	register expr kc_x = (expr) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_expr));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Nconcat));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Nconcat));
	/*SUPPRESS 622*/
	assert_expr( expr_1, "expr_1" );
	/*SUPPRESS 622*/
	assert_expr( expr_2, "expr_2" );
	kc_x->prod_sel = sel_Nconcat;
	kc_x->u.Nconcat.expr_1 = expr_1;
	kc_x->u.Nconcat.expr_2 = expr_2;
	kc_x = kc_initialize_expr(kc_x);
	return kc_x;
}

expr Repl
#ifdef KC_USE_PROTOTYPES
(expr expr_1, freq freq_1)
#else
(expr_1, freq_1) expr expr_1;  freq freq_1; 
#endif
{	register expr kc_x = (expr) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_expr));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Repl));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Repl));
	/*SUPPRESS 622*/
	assert_expr( expr_1, "expr_1" );
	/*SUPPRESS 622*/
	assert_freq( freq_1, "freq_1" );
	kc_x->prod_sel = sel_Repl;
	kc_x->u.Repl.expr_1 = expr_1;
	kc_x->u.Repl.freq_1 = freq_1;
	kc_x = kc_initialize_expr(kc_x);
	return kc_x;
}

expr Choice
#ifdef KC_USE_PROTOTYPES
(expr expr_1, expr expr_2)
#else
(expr_1, expr_2) expr expr_1;  expr expr_2; 
#endif
{	register expr kc_x = (expr) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_expr));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Choice));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Choice));
	/*SUPPRESS 622*/
	assert_expr( expr_1, "expr_1" );
	/*SUPPRESS 622*/
	assert_expr( expr_2, "expr_2" );
	kc_x->prod_sel = sel_Choice;
	kc_x->u.Choice.expr_1 = expr_1;
	kc_x->u.Choice.expr_2 = expr_2;
	kc_x = kc_initialize_expr(kc_x);
	return kc_x;
}

expr Const
#ifdef KC_USE_PROTOTYPES
(id id_1)
#else
(id_1) id id_1; 
#endif
{	register expr kc_x = (expr) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_expr));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Const));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Const));
	/*SUPPRESS 622*/
	assert_id( id_1, "id_1" );
	kc_x->prod_sel = sel_Const;
	kc_x->u.Const.id_1 = id_1;
	kc_x = kc_initialize_expr(kc_x);
	return kc_x;
}

freq LFreq
#ifdef KC_USE_PROTOTYPES
(int int_1)
#else
(int_1) int int_1; 
#endif
{	register freq kc_x = (freq) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_freq));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_LFreq));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_LFreq));
	/*SUPPRESS 622*/
	assert_int( int_1, "int_1" );
	kc_x->prod_sel = sel_LFreq;
	kc_x->u.LFreq.int_1 = int_1;
	return kc_x;
}

freq UFreq
#ifdef KC_USE_PROTOTYPES
(int int_1)
#else
(int_1) int int_1; 
#endif
{	register freq kc_x = (freq) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_freq));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_UFreq));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_UFreq));
	/*SUPPRESS 622*/
	assert_int( int_1, "int_1" );
	kc_x->prod_sel = sel_UFreq;
	kc_x->u.UFreq.int_1 = int_1;
	return kc_x;
}

freq Freq
#ifdef KC_USE_PROTOTYPES
(int int_1, int int_2)
#else
(int_1, int_2) int int_1;  int int_2; 
#endif
{	register freq kc_x = (freq) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_freq));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Freq));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Freq));
	/*SUPPRESS 622*/
	assert_int( int_1, "int_1" );
	/*SUPPRESS 622*/
	assert_int( int_2, "int_2" );
	kc_x->prod_sel = sel_Freq;
	kc_x->u.Freq.int_1 = int_1;
	kc_x->u.Freq.int_2 = int_2;
	return kc_x;
}

freq IFreq
#ifdef KC_USE_PROTOTYPES
()
#else
()
#endif
{	static freq kc_x = (freq)0;
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_IFreq));
	if (kc_x == (freq)0) {
		KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_IFreq ));
		kc_x = (freq)(*kc_hashtables[(int)kc_uniq_nullary_operator]->malloc)((kc_size_t)sizeof(struct kc_tag_freq), kc_hashtables[(int)kc_uniq_nullary_operator]->malloc_private_data);
		kc_x->prod_sel = sel_IFreq;
	}
	return kc_x;
}

id Id
#ifdef KC_USE_PROTOTYPES
(uid uid_1)
#else
(uid_1) uid uid_1; 
#endif
{	register id kc_x = (id) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_id));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Id));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Id));
	/*SUPPRESS 622*/
	assert_uid( uid_1, "uid_1" );
	kc_x->prod_sel = sel_Id;
	kc_x->u.Id.uid_1 = uid_1;
	kc_x = kc_initialize_id(kc_x);
	return kc_x;
}

idtype IdTypeAssign
#ifdef KC_USE_PROTOTYPES
(assign assign_1)
#else
(assign_1) assign assign_1; 
#endif
{	register idtype kc_x = (idtype) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_idtype));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_IdTypeAssign));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_IdTypeAssign));
	/*SUPPRESS 622*/
	assert_assign( assign_1, "assign_1" );
	kc_x->prod_sel = sel_IdTypeAssign;
	kc_x->u.IdTypeAssign.assign_1 = assign_1;
	return kc_x;
}

idtype IdTypeDecl
#ifdef KC_USE_PROTOTYPES
(decl decl_1)
#else
(decl_1) decl decl_1; 
#endif
{	register idtype kc_x = (idtype) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_idtype));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_IdTypeDecl));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_IdTypeDecl));
	/*SUPPRESS 622*/
	assert_decl( decl_1, "decl_1" );
	kc_x->prod_sel = sel_IdTypeDecl;
	kc_x->u.IdTypeDecl.decl_1 = decl_1;
	return kc_x;
}

uid Uid
#ifdef KC_USE_PROTOTYPES
(casestring casestring_1)
#else
(casestring_1) casestring casestring_1; 
#endif
{	register uid kc_x;
	int kc_i;
	register kc_hashtableentry_t* kc_hte;
	unsigned kc_hashval = (unsigned)0;
	YYSTYPE *kc_ptr, *kc_beyond;
	kc_hashtable_t kc_a_ht = kc_hashtables[(int)uniq];

	/*SUPPRESS 622*/
	assert_casestring( casestring_1, "casestring_1" );
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Uid));
	OPERATORHASH((unsigned) sel_Uid);
	HASH(casestring_1);
	kc_hashval = kc_hashval%kc_a_ht->size;
	for (kc_i=0; kc_i < (int)kc_last_storage_mode; kc_i++) {
		kc_hte = &(kc_a_ht->hashtable[kc_hashval][kc_i]);
		if (kc_hte->nr != 0) {
			kc_beyond = &kc_hte->index[kc_hte->nr];
			for (kc_ptr = &kc_hte->index[0]; kc_ptr < kc_beyond; kc_ptr++){
				kc_x= kc_ptr->yt_uid;
				if ((kc_x->prod_sel == sel_Uid)  && (kc_x->u.Uid.casestring_1 == casestring_1) )
					return(kc_x);
	}	}	}
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Uid));
	kc_hte = &(kc_a_ht->hashtable[kc_hashval][(int)kc_a_ht->mode]);
	if (kc_hte->nr >= kc_hte->ibound) kc_growindex(kc_hte, kc_a_ht);
	kc_x = (uid)(*kc_a_ht->malloc)((kc_size_t)sizeof(struct kc_tag_uid), kc_a_ht->malloc_private_data);
	kc_x->prod_sel = sel_Uid;
	kc_x->u.Uid.casestring_1 = casestring_1;
	kc_hte->index[kc_hte->nr++].yt_uid = kc_x;
	kc_x = kc_initialize_uid(kc_x);
	return kc_x;
}

idx2event IndexMap
#ifdef KC_USE_PROTOTYPES
(int int_1)
#else
(int_1) int int_1; 
#endif
{	register idx2event kc_x;
	int kc_i;
	register kc_hashtableentry_t* kc_hte;
	unsigned kc_hashval = (unsigned)0;
	YYSTYPE *kc_ptr, *kc_beyond;
	kc_hashtable_t kc_a_ht = kc_hashtables[(int)uniq];

	/*SUPPRESS 622*/
	assert_int( int_1, "int_1" );
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_IndexMap));
	OPERATORHASH((unsigned) sel_IndexMap);
	INTHASH(int_1);
	kc_hashval = kc_hashval%kc_a_ht->size;
	for (kc_i=0; kc_i < (int)kc_last_storage_mode; kc_i++) {
		kc_hte = &(kc_a_ht->hashtable[kc_hashval][kc_i]);
		if (kc_hte->nr != 0) {
			kc_beyond = &kc_hte->index[kc_hte->nr];
			for (kc_ptr = &kc_hte->index[0]; kc_ptr < kc_beyond; kc_ptr++){
				kc_x= kc_ptr->yt_idx2event;
				if ((kc_x->prod_sel == sel_IndexMap)  && (kc_x->u.IndexMap.int_1 == int_1) )
					return(kc_x);
	}	}	}
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_IndexMap));
	kc_hte = &(kc_a_ht->hashtable[kc_hashval][(int)kc_a_ht->mode]);
	if (kc_hte->nr >= kc_hte->ibound) kc_growindex(kc_hte, kc_a_ht);
	kc_x = (idx2event)(*kc_a_ht->malloc)((kc_size_t)sizeof(struct kc_tag_idx2event), kc_a_ht->malloc_private_data);
	kc_x->prod_sel = sel_IndexMap;
	kc_x->u.IndexMap.int_1 = int_1;
	kc_hte->index[kc_hte->nr++].yt_idx2event = kc_x;
	kc_x = kc_initialize_idx2event(kc_x);
	return kc_x;
}

transitions Niltransitions
#ifdef KC_USE_PROTOTYPES
()
#else
()
#endif
{	static transitions kc_x = (transitions)0;
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Niltransitions));
	if (kc_x == (transitions)0) {
		KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Niltransitions ));
		kc_x = (transitions)(*kc_hashtables[(int)kc_uniq_nullary_operator]->malloc)((kc_size_t)sizeof(struct kc_tag_transitions), kc_hashtables[(int)kc_uniq_nullary_operator]->malloc_private_data);
		kc_x->prod_sel = sel_Niltransitions;
	}
	return kc_x;
}

transitions Constransitions
#ifdef KC_USE_PROTOTYPES
(transition transition_1, transitions transitions_1)
#else
(transition_1, transitions_1) transition transition_1;  transitions transitions_1; 
#endif
{	register transitions kc_x = (transitions) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_transitions));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Constransitions));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Constransitions));
	/*SUPPRESS 622*/
	assert_transition( transition_1, "transition_1" );
	/*SUPPRESS 622*/
	assert_transitions( transitions_1, "transitions_1" );
	kc_x->prod_sel = sel_Constransitions;
	kc_x->u.Constransitions.transition_1 = transition_1;
	kc_x->u.Constransitions.transitions_1 = transitions_1;
	return kc_x;
}

locations Nillocations
#ifdef KC_USE_PROTOTYPES
()
#else
()
#endif
{	static locations kc_x = (locations)0;
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Nillocations));
	if (kc_x == (locations)0) {
		KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Nillocations ));
		kc_x = (locations)(*kc_hashtables[(int)kc_uniq_nullary_operator]->malloc)((kc_size_t)sizeof(struct kc_tag_locations), kc_hashtables[(int)kc_uniq_nullary_operator]->malloc_private_data);
		kc_x->prod_sel = sel_Nillocations;
	}
	return kc_x;
}

locations Conslocations
#ifdef KC_USE_PROTOTYPES
(location location_1, locations locations_1)
#else
(location_1, locations_1) location location_1;  locations locations_1; 
#endif
{	register locations kc_x = (locations) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_locations));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Conslocations));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Conslocations));
	/*SUPPRESS 622*/
	assert_location( location_1, "location_1" );
	/*SUPPRESS 622*/
	assert_locations( locations_1, "locations_1" );
	kc_x->prod_sel = sel_Conslocations;
	kc_x->u.Conslocations.location_1 = location_1;
	kc_x->u.Conslocations.locations_1 = locations_1;
	return kc_x;
}

location Location
#ifdef KC_USE_PROTOTYPES
(int int_1)
#else
(int_1) int int_1; 
#endif
{	register location kc_x;
	int kc_i;
	register kc_hashtableentry_t* kc_hte;
	unsigned kc_hashval = (unsigned)0;
	YYSTYPE *kc_ptr, *kc_beyond;
	kc_hashtable_t kc_a_ht = kc_hashtables[(int)uniq];

	/*SUPPRESS 622*/
	assert_int( int_1, "int_1" );
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Location));
	OPERATORHASH((unsigned) sel_Location);
	INTHASH(int_1);
	kc_hashval = kc_hashval%kc_a_ht->size;
	for (kc_i=0; kc_i < (int)kc_last_storage_mode; kc_i++) {
		kc_hte = &(kc_a_ht->hashtable[kc_hashval][kc_i]);
		if (kc_hte->nr != 0) {
			kc_beyond = &kc_hte->index[kc_hte->nr];
			for (kc_ptr = &kc_hte->index[0]; kc_ptr < kc_beyond; kc_ptr++){
				kc_x= kc_ptr->yt_location;
				if ((kc_x->prod_sel == sel_Location)  && (kc_x->u.Location.int_1 == int_1) )
					return(kc_x);
	}	}	}
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Location));
	kc_hte = &(kc_a_ht->hashtable[kc_hashval][(int)kc_a_ht->mode]);
	if (kc_hte->nr >= kc_hte->ibound) kc_growindex(kc_hte, kc_a_ht);
	kc_x = (location)(*kc_a_ht->malloc)((kc_size_t)sizeof(struct kc_tag_location), kc_a_ht->malloc_private_data);
	kc_x->prod_sel = sel_Location;
	kc_x->u.Location.int_1 = int_1;
	kc_hte->index[kc_hte->nr++].yt_location = kc_x;
	kc_x = kc_initialize_location(kc_x);
	return kc_x;
}

transition TrExternal
#ifdef KC_USE_PROTOTYPES
()
#else
()
#endif
{	register transition kc_x = (transition) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_transition));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_TrExternal));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_TrExternal));
	kc_x->prod_sel = sel_TrExternal;
	kc_x = kc_initialize_transition(kc_x);
	return kc_x;
}

transition TrInternal
#ifdef KC_USE_PROTOTYPES
(action action_1)
#else
(action_1) action action_1; 
#endif
{	register transition kc_x = (transition) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_transition));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_TrInternal));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_TrInternal));
	/*SUPPRESS 622*/
	assert_action( action_1, "action_1" );
	kc_x->prod_sel = sel_TrInternal;
	kc_x->u.TrInternal.action_1 = action_1;
	kc_x = kc_initialize_transition(kc_x);
	return kc_x;
}

action GreaterEqual
#ifdef KC_USE_PROTOTYPES
(int int_1, int int_2)
#else
(int_1, int_2) int int_1;  int int_2; 
#endif
{	register action kc_x = (action) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_action));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_GreaterEqual));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_GreaterEqual));
	/*SUPPRESS 622*/
	assert_int( int_1, "int_1" );
	/*SUPPRESS 622*/
	assert_int( int_2, "int_2" );
	kc_x->prod_sel = sel_GreaterEqual;
	kc_x->u.GreaterEqual.int_1 = int_1;
	kc_x->u.GreaterEqual.int_2 = int_2;
	return kc_x;
}

action Epsilon
#ifdef KC_USE_PROTOTYPES
()
#else
()
#endif
{	static action kc_x = (action)0;
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Epsilon));
	if (kc_x == (action)0) {
		KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Epsilon ));
		kc_x = (action)(*kc_hashtables[(int)kc_uniq_nullary_operator]->malloc)((kc_size_t)sizeof(struct kc_tag_action), kc_hashtables[(int)kc_uniq_nullary_operator]->malloc_private_data);
		kc_x->prod_sel = sel_Epsilon;
	}
	return kc_x;
}

action Incr
#ifdef KC_USE_PROTOTYPES
(int int_1)
#else
(int_1) int int_1; 
#endif
{	register action kc_x = (action) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_action));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Incr));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Incr));
	/*SUPPRESS 622*/
	assert_int( int_1, "int_1" );
	kc_x->prod_sel = sel_Incr;
	kc_x->u.Incr.int_1 = int_1;
	return kc_x;
}

action LessThan
#ifdef KC_USE_PROTOTYPES
(int int_1, int int_2)
#else
(int_1, int_2) int int_1;  int int_2; 
#endif
{	register action kc_x = (action) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_action));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_LessThan));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_LessThan));
	/*SUPPRESS 622*/
	assert_int( int_1, "int_1" );
	/*SUPPRESS 622*/
	assert_int( int_2, "int_2" );
	kc_x->prod_sel = sel_LessThan;
	kc_x->u.LessThan.int_1 = int_1;
	kc_x->u.LessThan.int_2 = int_2;
	return kc_x;
}

action Reset
#ifdef KC_USE_PROTOTYPES
(int int_1)
#else
(int_1) int int_1; 
#endif
{	register action kc_x = (action) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_action));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Reset));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Reset));
	/*SUPPRESS 622*/
	assert_int( int_1, "int_1" );
	kc_x->prod_sel = sel_Reset;
	kc_x->u.Reset.int_1 = int_1;
	return kc_x;
}

map MapTransition
#ifdef KC_USE_PROTOTYPES
(int int_1)
#else
(int_1) int int_1; 
#endif
{	register map kc_x;
	int kc_i;
	register kc_hashtableentry_t* kc_hte;
	unsigned kc_hashval = (unsigned)0;
	YYSTYPE *kc_ptr, *kc_beyond;
	kc_hashtable_t kc_a_ht = kc_hashtables[(int)uniq];

	/*SUPPRESS 622*/
	assert_int( int_1, "int_1" );
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_MapTransition));
	OPERATORHASH((unsigned) sel_MapTransition);
	INTHASH(int_1);
	kc_hashval = kc_hashval%kc_a_ht->size;
	for (kc_i=0; kc_i < (int)kc_last_storage_mode; kc_i++) {
		kc_hte = &(kc_a_ht->hashtable[kc_hashval][kc_i]);
		if (kc_hte->nr != 0) {
			kc_beyond = &kc_hte->index[kc_hte->nr];
			for (kc_ptr = &kc_hte->index[0]; kc_ptr < kc_beyond; kc_ptr++){
				kc_x= kc_ptr->yt_map;
				if ((kc_x->prod_sel == sel_MapTransition)  && (kc_x->u.MapTransition.int_1 == int_1) )
					return(kc_x);
	}	}	}
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_MapTransition));
	kc_hte = &(kc_a_ht->hashtable[kc_hashval][(int)kc_a_ht->mode]);
	if (kc_hte->nr >= kc_hte->ibound) kc_growindex(kc_hte, kc_a_ht);
	kc_x = (map)(*kc_a_ht->malloc)((kc_size_t)sizeof(struct kc_tag_map), kc_a_ht->malloc_private_data);
	kc_x->prod_sel = sel_MapTransition;
	kc_x->u.MapTransition.int_1 = int_1;
	kc_hte->index[kc_hte->nr++].yt_map = kc_x;
	kc_x = kc_initialize_map(kc_x);
	return kc_x;
}

map MapEvent
#ifdef KC_USE_PROTOTYPES
(int int_1)
#else
(int_1) int int_1; 
#endif
{	register map kc_x;
	int kc_i;
	register kc_hashtableentry_t* kc_hte;
	unsigned kc_hashval = (unsigned)0;
	YYSTYPE *kc_ptr, *kc_beyond;
	kc_hashtable_t kc_a_ht = kc_hashtables[(int)uniq];

	/*SUPPRESS 622*/
	assert_int( int_1, "int_1" );
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_MapEvent));
	OPERATORHASH((unsigned) sel_MapEvent);
	INTHASH(int_1);
	kc_hashval = kc_hashval%kc_a_ht->size;
	for (kc_i=0; kc_i < (int)kc_last_storage_mode; kc_i++) {
		kc_hte = &(kc_a_ht->hashtable[kc_hashval][kc_i]);
		if (kc_hte->nr != 0) {
			kc_beyond = &kc_hte->index[kc_hte->nr];
			for (kc_ptr = &kc_hte->index[0]; kc_ptr < kc_beyond; kc_ptr++){
				kc_x= kc_ptr->yt_map;
				if ((kc_x->prod_sel == sel_MapEvent)  && (kc_x->u.MapEvent.int_1 == int_1) )
					return(kc_x);
	}	}	}
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_MapEvent));
	kc_hte = &(kc_a_ht->hashtable[kc_hashval][(int)kc_a_ht->mode]);
	if (kc_hte->nr >= kc_hte->ibound) kc_growindex(kc_hte, kc_a_ht);
	kc_x = (map)(*kc_a_ht->malloc)((kc_size_t)sizeof(struct kc_tag_map), kc_a_ht->malloc_private_data);
	kc_x->prod_sel = sel_MapEvent;
	kc_x->u.MapEvent.int_1 = int_1;
	kc_hte->index[kc_hte->nr++].yt_map = kc_x;
	kc_x = kc_initialize_map(kc_x);
	return kc_x;
}

event Event
#ifdef KC_USE_PROTOTYPES
(label label_1, visibility visibility_1, state state_1)
#else
(label_1, visibility_1, state_1) label label_1;  visibility visibility_1;  state state_1; 
#endif
{	register event kc_x = (event) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_event));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Event));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Event));
	/*SUPPRESS 622*/
	assert_label( label_1, "label_1" );
	/*SUPPRESS 622*/
	assert_visibility( visibility_1, "visibility_1" );
	/*SUPPRESS 622*/
	assert_state( state_1, "state_1" );
	kc_x->prod_sel = sel_Event;
	kc_x->u.Event.label_1 = label_1;
	kc_x->u.Event.visibility_1 = visibility_1;
	kc_x->u.Event.state_1 = state_1;
	kc_x = kc_initialize_event(kc_x);
	return kc_x;
}

event RootEvent
#ifdef KC_USE_PROTOTYPES
(state state_1)
#else
(state_1) state state_1; 
#endif
{	register event kc_x = (event) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_event));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_RootEvent));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_RootEvent));
	/*SUPPRESS 622*/
	assert_state( state_1, "state_1" );
	kc_x->prod_sel = sel_RootEvent;
	kc_x->u.RootEvent.state_1 = state_1;
	kc_x = kc_initialize_event(kc_x);
	return kc_x;
}

visibility Internal
#ifdef KC_USE_PROTOTYPES
()
#else
()
#endif
{	static visibility kc_x = (visibility)0;
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Internal));
	if (kc_x == (visibility)0) {
		KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Internal ));
		kc_x = (visibility)(*kc_hashtables[(int)kc_uniq_nullary_operator]->malloc)((kc_size_t)sizeof(struct kc_tag_visibility), kc_hashtables[(int)kc_uniq_nullary_operator]->malloc_private_data);
		kc_x->prod_sel = sel_Internal;
	}
	return kc_x;
}

visibility External
#ifdef KC_USE_PROTOTYPES
()
#else
()
#endif
{	static visibility kc_x = (visibility)0;
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_External));
	if (kc_x == (visibility)0) {
		KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_External ));
		kc_x = (visibility)(*kc_hashtables[(int)kc_uniq_nullary_operator]->malloc)((kc_size_t)sizeof(struct kc_tag_visibility), kc_hashtables[(int)kc_uniq_nullary_operator]->malloc_private_data);
		kc_x->prod_sel = sel_External;
	}
	return kc_x;
}

events Nilevents
#ifdef KC_USE_PROTOTYPES
()
#else
()
#endif
{	static events kc_x = (events)0;
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Nilevents));
	if (kc_x == (events)0) {
		KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Nilevents ));
		kc_x = (events)(*kc_hashtables[(int)kc_uniq_nullary_operator]->malloc)((kc_size_t)sizeof(struct kc_tag_events), kc_hashtables[(int)kc_uniq_nullary_operator]->malloc_private_data);
		kc_x->prod_sel = sel_Nilevents;
	}
	return kc_x;
}

events Consevents
#ifdef KC_USE_PROTOTYPES
(event event_1, events events_1)
#else
(event_1, events_1) event event_1;  events events_1; 
#endif
{	register events kc_x = (events) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_events));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Consevents));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Consevents));
	/*SUPPRESS 622*/
	assert_event( event_1, "event_1" );
	/*SUPPRESS 622*/
	assert_events( events_1, "events_1" );
	kc_x->prod_sel = sel_Consevents;
	kc_x->u.Consevents.event_1 = event_1;
	kc_x->u.Consevents.events_1 = events_1;
	return kc_x;
}

state State
#ifdef KC_USE_PROTOTYPES
(location location_1, intarray intarray_1)
#else
(location_1, intarray_1) location location_1;  intarray intarray_1; 
#endif
{	register state kc_x;
	int kc_i;
	register kc_hashtableentry_t* kc_hte;
	unsigned kc_hashval = (unsigned)0;
	YYSTYPE *kc_ptr, *kc_beyond;
	kc_hashtable_t kc_a_ht = kc_hashtables[(int)uniq];

	/*SUPPRESS 622*/
	assert_location( location_1, "location_1" );
	/*SUPPRESS 622*/
	assert_intarray( intarray_1, "intarray_1" );
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_State));
	OPERATORHASH((unsigned) sel_State);
	HASH(location_1);
	HASH(intarray_1);
	kc_hashval = kc_hashval%kc_a_ht->size;
	for (kc_i=0; kc_i < (int)kc_last_storage_mode; kc_i++) {
		kc_hte = &(kc_a_ht->hashtable[kc_hashval][kc_i]);
		if (kc_hte->nr != 0) {
			kc_beyond = &kc_hte->index[kc_hte->nr];
			for (kc_ptr = &kc_hte->index[0]; kc_ptr < kc_beyond; kc_ptr++){
				kc_x= kc_ptr->yt_state;
				if ((kc_x->prod_sel == sel_State)  && (kc_x->u.State.location_1 == location_1) && (kc_x->u.State.intarray_1 == intarray_1) )
					return(kc_x);
	}	}	}
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_State));
	kc_hte = &(kc_a_ht->hashtable[kc_hashval][(int)kc_a_ht->mode]);
	if (kc_hte->nr >= kc_hte->ibound) kc_growindex(kc_hte, kc_a_ht);
	kc_x = (state)(*kc_a_ht->malloc)((kc_size_t)sizeof(struct kc_tag_state), kc_a_ht->malloc_private_data);
	kc_x->prod_sel = sel_State;
	kc_x->u.State.location_1 = location_1;
	kc_x->u.State.intarray_1 = intarray_1;
	kc_hte->index[kc_hte->nr++].yt_state = kc_x;
	kc_x = kc_initialize_state(kc_x);
	return kc_x;
}

label Label
#ifdef KC_USE_PROTOTYPES
(action action_1)
#else
(action_1) action action_1; 
#endif
{	register label kc_x = (label) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_label));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Label));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Label));
	/*SUPPRESS 622*/
	assert_action( action_1, "action_1" );
	kc_x->prod_sel = sel_Label;
	kc_x->u.Label.action_1 = action_1;
	return kc_x;
}

label CounterLabel
#ifdef KC_USE_PROTOTYPES
(int int_1, action action_1)
#else
(int_1, action_1) int int_1;  action action_1; 
#endif
{	register label kc_x = (label) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_label));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_CounterLabel));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_CounterLabel));
	/*SUPPRESS 622*/
	assert_int( int_1, "int_1" );
	/*SUPPRESS 622*/
	assert_action( action_1, "action_1" );
	kc_x->prod_sel = sel_CounterLabel;
	kc_x->u.CounterLabel.int_1 = int_1;
	kc_x->u.CounterLabel.action_1 = action_1;
	return kc_x;
}

label DeclLabel
#ifdef KC_USE_PROTOTYPES
(decl decl_1)
#else
(decl_1) decl decl_1; 
#endif
{	register label kc_x = (label) NONUNIQMALLOC((kc_size_t)sizeof(struct kc_tag_label));
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_DeclLabel));
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_DeclLabel));
	/*SUPPRESS 622*/
	assert_decl( decl_1, "decl_1" );
	kc_x->prod_sel = sel_DeclLabel;
	kc_x->u.DeclLabel.decl_1 = decl_1;
	return kc_x;
}

intarray Nilintarray
#ifdef KC_USE_PROTOTYPES
()
#else
()
#endif
{	static intarray kc_x = (intarray)0;
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Nilintarray));
	if (kc_x == (intarray)0) {
		KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Nilintarray ));
		kc_x = (intarray)(*kc_hashtables[(int)kc_uniq_nullary_operator]->malloc)((kc_size_t)sizeof(struct kc_tag_intarray), kc_hashtables[(int)kc_uniq_nullary_operator]->malloc_private_data);
		kc_x->prod_sel = sel_Nilintarray;
	}
	return kc_x;
}

intarray Consintarray
#ifdef KC_USE_PROTOTYPES
(int int_1, intarray intarray_1)
#else
(int_1, intarray_1) int int_1;  intarray intarray_1; 
#endif
{	register intarray kc_x;
	int kc_i;
	register kc_hashtableentry_t* kc_hte;
	unsigned kc_hashval = (unsigned)0;
	YYSTYPE *kc_ptr, *kc_beyond;
	kc_hashtable_t kc_a_ht = kc_hashtables[(int)uniq];

	/*SUPPRESS 622*/
	assert_int( int_1, "int_1" );
	/*SUPPRESS 622*/
	assert_intarray( intarray_1, "intarray_1" );
	KC_COLLECT_STATS0(KC_CREATE_STATS(sel_Consintarray));
	OPERATORHASH((unsigned) sel_Consintarray);
	INTHASH(int_1);
	HASH(intarray_1);
	kc_hashval = kc_hashval%kc_a_ht->size;
	for (kc_i=0; kc_i < (int)kc_last_storage_mode; kc_i++) {
		kc_hte = &(kc_a_ht->hashtable[kc_hashval][kc_i]);
		if (kc_hte->nr != 0) {
			kc_beyond = &kc_hte->index[kc_hte->nr];
			for (kc_ptr = &kc_hte->index[0]; kc_ptr < kc_beyond; kc_ptr++){
				kc_x= kc_ptr->yt_intarray;
				if ((kc_x->prod_sel == sel_Consintarray)  && (kc_x->u.Consintarray.int_1 == int_1) && (kc_x->u.Consintarray.intarray_1 == intarray_1) )
					return(kc_x);
	}	}	}
	KC_COLLECT_STATS0(KC_EXISTINGNOTFOUND_STATS(sel_Consintarray));
	kc_hte = &(kc_a_ht->hashtable[kc_hashval][(int)kc_a_ht->mode]);
	if (kc_hte->nr >= kc_hte->ibound) kc_growindex(kc_hte, kc_a_ht);
	kc_x = (intarray)(*kc_a_ht->malloc)((kc_size_t)sizeof(struct kc_tag_intarray), kc_a_ht->malloc_private_data);
	kc_x->prod_sel = sel_Consintarray;
	kc_x->u.Consintarray.int_1 = int_1;
	kc_x->u.Consintarray.intarray_1 = intarray_1;
	kc_hte->index[kc_hte->nr++].yt_intarray = kc_x;
	return kc_x;
}

char *kc_phylumname_or_error
#ifdef KC_USE_PROTOTYPES
(int kc_phylum)
#else
(kc_phylum) int kc_phylum;
#endif
{	if ((kc_phylum <= (int)kc_one_before_first_phylum) || (kc_phylum >= (int)kc_last_phylum)) {
		char *kc_strof_error;
		(void)sprintf((kc_strof_error=(char*)MALLOC(69)), "Internal Error: unknown phylum number: %d", kc_phylum);
		return kc_strof_error;
	} else {
		return kc_PhylumInfo[kc_phylum].name;
}	}


char *kc_operatorname_or_error
#ifdef KC_USE_PROTOTYPES
(int kc_operator)
#else
(kc_operator) int kc_operator;
#endif
{	if ((kc_operator <= (int)kc_one_before_first_operator) || (kc_operator >= (int)kc_last_operator)) {
		char *kc_strof_error;
		(void)sprintf((kc_strof_error=(char*)MALLOC(71)), "Internal Error: unknown operator number: %d", kc_operator);
		return kc_strof_error;
	} else {
		return kc_OperatorInfo[kc_operator].name;
}	}

/*ARGSUSED*/ static void kc_do_free_phylum
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_p, boolean kc_rec, kc_enum_phyla kc_phylum)
#else
(kc_p, kc_rec, kc_phylum) kc_voidptr_t kc_p; boolean kc_rec; kc_enum_phyla kc_phylum;
#endif
{	kc_enum_operators kc_prodsel;
	KC_OPERATOR_INFO *kc_op_info;
	/*SUPPRESS 622*/
	assertPhylum(((casestring)kc_p),"kc_p",kc_phylum);
	kc_prodsel = (kc_phylum == kc_phylum_int ? sel__Int :
                     (kc_phylum == kc_phylum_float ? sel__Real :
                     (kc_phylum == kc_phylum_voidptr ? sel__VoidPtr :
                     ((casestring)kc_p)->prod_sel)));
	kc_op_info = &kc_OperatorInfo[(int)kc_prodsel];
	KC_COLLECT_STATS0(KC_FREE_CALLED_STATS((int)kc_prodsel, kc_rec));
	if (! kc_op_info->uniq_stored) {
		if (kc_rec) {
			int kc_i;
			for (kc_i=0; kc_i < kc_op_info->no_sons; kc_i++) {
				kc_do_free_phylum( (kc_voidptr_t)KC_SUBPHYLUM(kc_p, kc_op_info->suboffset[kc_i]), kc_rec, kc_op_info->subphylum[kc_i] );
		}	}
		KC_COLLECT_STATS0(KC_FREED_STATS((int)kc_prodsel, kc_rec));
		KC_BZERO((kc_voidptr_t)kc_p, kc_PhylumInfo[(int)kc_phylum].size);
		NONUNIQFREE((kc_voidptr_t)kc_p);
}	}	
/*ARGSUSED*/ void free_nocasestring
#ifdef KC_USE_PROTOTYPES
(nocasestring kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) nocasestring kc_p; boolean kc_rec;
#endif
{ KC_COLLECT_STATS0(KC_FREE_CALLED_STATS((int)sel_NoCaseStr, kc_rec)); }
/*ARGSUSED*/ void free_casestring
#ifdef KC_USE_PROTOTYPES
(casestring kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) casestring kc_p; boolean kc_rec;
#endif
{ KC_COLLECT_STATS0(KC_FREE_CALLED_STATS((int)sel__Str, kc_rec)); }
/*ARGSUSED*/ void free_float
#ifdef KC_USE_PROTOTYPES
(float kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) float kc_p; boolean kc_rec;
#endif
{ KC_COLLECT_STATS0(KC_FREE_CALLED_STATS((int)sel__Real, kc_rec)); }
/*ARGSUSED*/ void free_int
#ifdef KC_USE_PROTOTYPES
(int kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) int kc_p; boolean kc_rec;
#endif
{ KC_COLLECT_STATS0(KC_FREE_CALLED_STATS((int)sel__Int, kc_rec)); }
/*ARGSUSED*/ void free_voidptr
#ifdef KC_USE_PROTOTYPES
(voidptr kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) voidptr kc_p; boolean kc_rec;
#endif
{ KC_COLLECT_STATS0(KC_FREE_CALLED_STATS((int)sel__VoidPtr, kc_rec)); }
/*ARGSUSED*/ void free_spec
#ifdef KC_USE_PROTOTYPES
(spec kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) spec kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_spec);  }
/*ARGSUSED*/ void free_decllist
#ifdef KC_USE_PROTOTYPES
(decllist kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) decllist kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_decllist);  }
/*ARGSUSED*/ void free_decl
#ifdef KC_USE_PROTOTYPES
(decl kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) decl kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_decl);  }
/*ARGSUSED*/ void free_asslist
#ifdef KC_USE_PROTOTYPES
(asslist kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) asslist kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_asslist);  }
/*ARGSUSED*/ void free_assign
#ifdef KC_USE_PROTOTYPES
(assign kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) assign kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_assign);  }
/*ARGSUSED*/ void free_expr
#ifdef KC_USE_PROTOTYPES
(expr kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) expr kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_expr);  }
/*ARGSUSED*/ void free_freq
#ifdef KC_USE_PROTOTYPES
(freq kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) freq kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_freq);  }
/*ARGSUSED*/ void free_id
#ifdef KC_USE_PROTOTYPES
(id kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) id kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_id);  }
/*ARGSUSED*/ void free_idtype
#ifdef KC_USE_PROTOTYPES
(idtype kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) idtype kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_idtype);  }
/*ARGSUSED*/ void free_uid
#ifdef KC_USE_PROTOTYPES
(uid kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) uid kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_uid);  }
/*ARGSUSED*/ void free_idx2event
#ifdef KC_USE_PROTOTYPES
(idx2event kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) idx2event kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_idx2event);  }
/*ARGSUSED*/ void free_transitions
#ifdef KC_USE_PROTOTYPES
(transitions kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) transitions kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_transitions);  }
/*ARGSUSED*/ void free_locations
#ifdef KC_USE_PROTOTYPES
(locations kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) locations kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_locations);  }
/*ARGSUSED*/ void free_location
#ifdef KC_USE_PROTOTYPES
(location kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) location kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_location);  }
/*ARGSUSED*/ void free_transition
#ifdef KC_USE_PROTOTYPES
(transition kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) transition kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_transition);  }
/*ARGSUSED*/ void free_action
#ifdef KC_USE_PROTOTYPES
(action kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) action kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_action);  }
/*ARGSUSED*/ void free_map
#ifdef KC_USE_PROTOTYPES
(map kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) map kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_map);  }
/*ARGSUSED*/ void free_event
#ifdef KC_USE_PROTOTYPES
(event kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) event kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_event);  }
/*ARGSUSED*/ void free_visibility
#ifdef KC_USE_PROTOTYPES
(visibility kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) visibility kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_visibility);  }
/*ARGSUSED*/ void free_events
#ifdef KC_USE_PROTOTYPES
(events kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) events kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_events);  }
/*ARGSUSED*/ void free_state
#ifdef KC_USE_PROTOTYPES
(state kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) state kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_state);  }
/*ARGSUSED*/ void free_label
#ifdef KC_USE_PROTOTYPES
(label kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) label kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_label);  }
/*ARGSUSED*/ void free_intarray
#ifdef KC_USE_PROTOTYPES
(intarray kc_p, boolean kc_rec)
#else
(kc_p, kc_rec) intarray kc_p; boolean kc_rec;
#endif
{ kc_do_free_phylum( (kc_voidptr_t)kc_p, kc_rec, kc_phylum_intarray);  }
/*ARGSUSED*/ static boolean kc_do_eq_phylum
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_p1, kc_voidptr_t kc_p2, kc_enum_phyla kc_phylum)
#else
(kc_p1, kc_p2, kc_phylum) kc_voidptr_t kc_p1, kc_p2; kc_enum_phyla kc_phylum;
#endif
{	int kc_i;
	kc_enum_operators kc_prodsel;
	int kc_st;
	KC_OPERATOR_INFO *kc_op_info;
	kc_hashtable_t kc_a_ht;
	/*SUPPRESS 622*/
	assertReason(kc_phylum != kc_phylum_int, "kc_do_eq_phylum called with kc_phylum_int argument");
	/*SUPPRESS 622*/
	assertReason(kc_phylum != kc_phylum_float, "kc_do_eq_phylum called with kc_phylum_float argument");
	if (kc_p1 == kc_p2) return True;
	if (kc_phylum == kc_phylum_voidptr) return False;
	/*SUPPRESS 622*/
	assertPhylum(((casestring)kc_p1),"kc_p1",kc_phylum);
	/*SUPPRESS 622*/
	assertPhylum(((casestring)kc_p2),"kc_p2",kc_phylum);
	if ((kc_prodsel = ((casestring)kc_p1)->prod_sel) != ((casestring)kc_p2)->prod_sel) return False;
	kc_op_info = &kc_OperatorInfo[(int)kc_prodsel];
	kc_st = (int)kc_op_info->uniq_stored;
	kc_a_ht = kc_hashtables[kc_st];
	if (kc_st
	   && (kc_storageclass_still_uniq[kc_st]
	       || ((kc_a_ht->in_block != 0)
		  && (*kc_a_ht->in_block)((kc_voidptr_t)kc_p1, kc_a_ht->malloc_private_data)
		  && (*kc_a_ht->in_block)((kc_voidptr_t)kc_p2, kc_a_ht->malloc_private_data)))) return False;
	switch(kc_prodsel) {
	case (int)sel_LFreq:
		return ((eq_int(((freq)kc_p1)->u.LFreq.int_1, ((freq)kc_p2)->u.LFreq.int_1)) ? True : False);
	case (int)sel_UFreq:
		return ((eq_int(((freq)kc_p1)->u.UFreq.int_1, ((freq)kc_p2)->u.UFreq.int_1)) ? True : False);
	case (int)sel_Freq:
		return ((eq_int(((freq)kc_p1)->u.Freq.int_1, ((freq)kc_p2)->u.Freq.int_1) &&
			eq_int(((freq)kc_p1)->u.Freq.int_2, ((freq)kc_p2)->u.Freq.int_2)) ? True : False);
	case (int)sel_IndexMap:
		return ((eq_int(((idx2event)kc_p1)->u.IndexMap.int_1, ((idx2event)kc_p2)->u.IndexMap.int_1)) ? True : False);
	case (int)sel_Location:
		return ((eq_int(((location)kc_p1)->u.Location.int_1, ((location)kc_p2)->u.Location.int_1)) ? True : False);
	case (int)sel_GreaterEqual:
		return ((eq_int(((action)kc_p1)->u.GreaterEqual.int_1, ((action)kc_p2)->u.GreaterEqual.int_1) &&
			eq_int(((action)kc_p1)->u.GreaterEqual.int_2, ((action)kc_p2)->u.GreaterEqual.int_2)) ? True : False);
	case (int)sel_Incr:
		return ((eq_int(((action)kc_p1)->u.Incr.int_1, ((action)kc_p2)->u.Incr.int_1)) ? True : False);
	case (int)sel_LessThan:
		return ((eq_int(((action)kc_p1)->u.LessThan.int_1, ((action)kc_p2)->u.LessThan.int_1) &&
			eq_int(((action)kc_p1)->u.LessThan.int_2, ((action)kc_p2)->u.LessThan.int_2)) ? True : False);
	case (int)sel_Reset:
		return ((eq_int(((action)kc_p1)->u.Reset.int_1, ((action)kc_p2)->u.Reset.int_1)) ? True : False);
	case (int)sel_MapTransition:
		return ((eq_int(((map)kc_p1)->u.MapTransition.int_1, ((map)kc_p2)->u.MapTransition.int_1)) ? True : False);
	case (int)sel_MapEvent:
		return ((eq_int(((map)kc_p1)->u.MapEvent.int_1, ((map)kc_p2)->u.MapEvent.int_1)) ? True : False);
	case (int)sel_CounterLabel:
		return ((eq_int(((label)kc_p1)->u.CounterLabel.int_1, ((label)kc_p2)->u.CounterLabel.int_1) &&
			kc_do_eq_phylum((kc_voidptr_t)((label)kc_p1)->u.CounterLabel.action_1, (kc_voidptr_t)((label)kc_p2)->u.CounterLabel.action_1, kc_phylum_action)) ? True : False);
	case (int)sel_Consintarray:
		return ((eq_int(((intarray)kc_p1)->u.Consintarray.int_1, ((intarray)kc_p2)->u.Consintarray.int_1) &&
			kc_do_eq_phylum((kc_voidptr_t)((intarray)kc_p1)->u.Consintarray.intarray_1, (kc_voidptr_t)((intarray)kc_p2)->u.Consintarray.intarray_1, kc_phylum_intarray)) ? True : False);
	default:
	for (kc_i=0; kc_i < kc_op_info->no_sons; kc_i++) {
		if (! kc_do_eq_phylum( (kc_voidptr_t)KC_SUBPHYLUM(kc_p1, kc_op_info->suboffset[kc_i]), (kc_voidptr_t)KC_SUBPHYLUM(kc_p2, kc_op_info->suboffset[kc_i]), kc_op_info->subphylum[kc_i] )) {
			return False;
	}	}
	return True;
	}
}
/*ARGSUSED*/ boolean eq_nocasestring
#ifdef KC_USE_PROTOTYPES
(nocasestring kc_p1, nocasestring kc_p2)
#else
(kc_p1, kc_p2) nocasestring kc_p1, kc_p2;
#endif
{ return (boolean)(kc_p1 == kc_p2); }
/*ARGSUSED*/ boolean eq_casestring
#ifdef KC_USE_PROTOTYPES
(casestring kc_p1, casestring kc_p2)
#else
(kc_p1, kc_p2) casestring kc_p1, kc_p2;
#endif
{ return (boolean)(kc_p1 == kc_p2); }
/*ARGSUSED*/ boolean eq_float
#ifdef KC_USE_PROTOTYPES
(float kc_p1, float kc_p2)
#else
(kc_p1, kc_p2) float kc_p1, kc_p2;
#endif
{ return (boolean)(kc_p1 == kc_p2); }
/*ARGSUSED*/ boolean eq_int
#ifdef KC_USE_PROTOTYPES
(int kc_p1, int kc_p2)
#else
(kc_p1, kc_p2) int kc_p1, kc_p2;
#endif
{ return (boolean)(kc_p1 == kc_p2); }
/*ARGSUSED*/ boolean eq_voidptr
#ifdef KC_USE_PROTOTYPES
(voidptr kc_p1, voidptr kc_p2)
#else
(kc_p1, kc_p2) voidptr kc_p1, kc_p2;
#endif
{ return (boolean)(kc_p1 == kc_p2); }
/*ARGSUSED*/ boolean eq_spec
#ifdef KC_USE_PROTOTYPES
(spec kc_p1, spec  kc_p2)
#else
(kc_p1, kc_p2) spec kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_spec);  }
/*ARGSUSED*/ boolean eq_decllist
#ifdef KC_USE_PROTOTYPES
(decllist kc_p1, decllist  kc_p2)
#else
(kc_p1, kc_p2) decllist kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_decllist);  }
/*ARGSUSED*/ boolean eq_decl
#ifdef KC_USE_PROTOTYPES
(decl kc_p1, decl  kc_p2)
#else
(kc_p1, kc_p2) decl kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_decl);  }
/*ARGSUSED*/ boolean eq_asslist
#ifdef KC_USE_PROTOTYPES
(asslist kc_p1, asslist  kc_p2)
#else
(kc_p1, kc_p2) asslist kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_asslist);  }
/*ARGSUSED*/ boolean eq_assign
#ifdef KC_USE_PROTOTYPES
(assign kc_p1, assign  kc_p2)
#else
(kc_p1, kc_p2) assign kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_assign);  }
/*ARGSUSED*/ boolean eq_expr
#ifdef KC_USE_PROTOTYPES
(expr kc_p1, expr  kc_p2)
#else
(kc_p1, kc_p2) expr kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_expr);  }
/*ARGSUSED*/ boolean eq_freq
#ifdef KC_USE_PROTOTYPES
(freq kc_p1, freq  kc_p2)
#else
(kc_p1, kc_p2) freq kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_freq);  }
/*ARGSUSED*/ boolean eq_id
#ifdef KC_USE_PROTOTYPES
(id kc_p1, id  kc_p2)
#else
(kc_p1, kc_p2) id kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_id);  }
/*ARGSUSED*/ boolean eq_idtype
#ifdef KC_USE_PROTOTYPES
(idtype kc_p1, idtype  kc_p2)
#else
(kc_p1, kc_p2) idtype kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_idtype);  }
/*ARGSUSED*/ boolean eq_uid
#ifdef KC_USE_PROTOTYPES
(uid kc_p1, uid  kc_p2)
#else
(kc_p1, kc_p2) uid kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_uid);  }
/*ARGSUSED*/ boolean eq_idx2event
#ifdef KC_USE_PROTOTYPES
(idx2event kc_p1, idx2event  kc_p2)
#else
(kc_p1, kc_p2) idx2event kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_idx2event);  }
/*ARGSUSED*/ boolean eq_transitions
#ifdef KC_USE_PROTOTYPES
(transitions kc_p1, transitions  kc_p2)
#else
(kc_p1, kc_p2) transitions kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_transitions);  }
/*ARGSUSED*/ boolean eq_locations
#ifdef KC_USE_PROTOTYPES
(locations kc_p1, locations  kc_p2)
#else
(kc_p1, kc_p2) locations kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_locations);  }
/*ARGSUSED*/ boolean eq_location
#ifdef KC_USE_PROTOTYPES
(location kc_p1, location  kc_p2)
#else
(kc_p1, kc_p2) location kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_location);  }
/*ARGSUSED*/ boolean eq_transition
#ifdef KC_USE_PROTOTYPES
(transition kc_p1, transition  kc_p2)
#else
(kc_p1, kc_p2) transition kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_transition);  }
/*ARGSUSED*/ boolean eq_action
#ifdef KC_USE_PROTOTYPES
(action kc_p1, action  kc_p2)
#else
(kc_p1, kc_p2) action kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_action);  }
/*ARGSUSED*/ boolean eq_map
#ifdef KC_USE_PROTOTYPES
(map kc_p1, map  kc_p2)
#else
(kc_p1, kc_p2) map kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_map);  }
/*ARGSUSED*/ boolean eq_event
#ifdef KC_USE_PROTOTYPES
(event kc_p1, event  kc_p2)
#else
(kc_p1, kc_p2) event kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_event);  }
/*ARGSUSED*/ boolean eq_visibility
#ifdef KC_USE_PROTOTYPES
(visibility kc_p1, visibility  kc_p2)
#else
(kc_p1, kc_p2) visibility kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_visibility);  }
/*ARGSUSED*/ boolean eq_events
#ifdef KC_USE_PROTOTYPES
(events kc_p1, events  kc_p2)
#else
(kc_p1, kc_p2) events kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_events);  }
/*ARGSUSED*/ boolean eq_state
#ifdef KC_USE_PROTOTYPES
(state kc_p1, state  kc_p2)
#else
(kc_p1, kc_p2) state kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_state);  }
/*ARGSUSED*/ boolean eq_label
#ifdef KC_USE_PROTOTYPES
(label kc_p1, label  kc_p2)
#else
(kc_p1, kc_p2) label kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_label);  }
/*ARGSUSED*/ boolean eq_intarray
#ifdef KC_USE_PROTOTYPES
(intarray kc_p1, intarray  kc_p2)
#else
(kc_p1, kc_p2) intarray kc_p1, kc_p2;
#endif
{ return kc_do_eq_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_intarray);  }
static int kc_indentation = 0;
static char *kc_printformat_not_nullair_open = "%*s%s(\n";
static char *kc_printformat_not_nullair_close = "%*s)\n";
static char *kc_printformat_nullair = "%*s%s()\n";

static void kc_do_print_phylum
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, kc_voidptr_t kc_p, kc_enum_phyla kc_phylum)
#else
(kc_f, kc_p, kc_phylum) FILE *kc_f; kc_voidptr_t kc_p; kc_enum_phyla kc_phylum;
#endif
{	int kc_i;

	/*SUPPRESS 622*/
	assertReason(kc_phylum != kc_phylum_int, "kc_do_print_phylum called with kc_phylum_int argument");
	/*SUPPRESS 622*/
	assertReason(kc_phylum != kc_phylum_float, "kc_do_print_phylum called with kc_phylum_float argument");
	/*SUPPRESS 622*/
	assertPhylum(((casestring)kc_p),"kc_p",kc_phylum);
	if (!kc_f) kc_f = stdout;
	if (kc_phylum == kc_phylum_voidptr) {
		(void)fprintf(kc_f, "%*s%p\n", kc_indentation, "", kc_p);
	} else if ((kc_phylum == kc_phylum_casestring) || (kc_phylum == kc_phylum_nocasestring)) {
		(void)fprintf(kc_f, "%*s%s\n", kc_indentation, "", ((casestring)kc_p)->name);
	} else {
		kc_enum_operators kc_prodsel = ((casestring)kc_p)->prod_sel;
		KC_OPERATOR_INFO *kc_op_info = &kc_OperatorInfo[(int)kc_prodsel];
		if (! kc_op_info->no_sons) {
			(void)fprintf(kc_f, kc_printformat_nullair, kc_indentation, "", kc_op_info->name);
		} else {
			(void)fprintf(kc_f, kc_printformat_not_nullair_open, kc_indentation, "", kc_op_info->name);
			kc_indentation++;
			switch(kc_prodsel) {
			case (int)sel_LFreq: {
				fprint_int(kc_f, ((freq)kc_p)->u.LFreq.int_1);
			break; }
			case (int)sel_UFreq: {
				fprint_int(kc_f, ((freq)kc_p)->u.UFreq.int_1);
			break; }
			case (int)sel_Freq: {
				fprint_int(kc_f, ((freq)kc_p)->u.Freq.int_1);
				fprint_int(kc_f, ((freq)kc_p)->u.Freq.int_2);
			break; }
			case (int)sel_IndexMap: {
				fprint_int(kc_f, ((idx2event)kc_p)->u.IndexMap.int_1);
			break; }
			case (int)sel_Location: {
				fprint_int(kc_f, ((location)kc_p)->u.Location.int_1);
			break; }
			case (int)sel_GreaterEqual: {
				fprint_int(kc_f, ((action)kc_p)->u.GreaterEqual.int_1);
				fprint_int(kc_f, ((action)kc_p)->u.GreaterEqual.int_2);
			break; }
			case (int)sel_Incr: {
				fprint_int(kc_f, ((action)kc_p)->u.Incr.int_1);
			break; }
			case (int)sel_LessThan: {
				fprint_int(kc_f, ((action)kc_p)->u.LessThan.int_1);
				fprint_int(kc_f, ((action)kc_p)->u.LessThan.int_2);
			break; }
			case (int)sel_Reset: {
				fprint_int(kc_f, ((action)kc_p)->u.Reset.int_1);
			break; }
			case (int)sel_MapTransition: {
				fprint_int(kc_f, ((map)kc_p)->u.MapTransition.int_1);
			break; }
			case (int)sel_MapEvent: {
				fprint_int(kc_f, ((map)kc_p)->u.MapEvent.int_1);
			break; }
			case (int)sel_CounterLabel: {
				fprint_int(kc_f, ((label)kc_p)->u.CounterLabel.int_1);
				kc_do_print_phylum(kc_f, (kc_voidptr_t)((label)kc_p)->u.CounterLabel.action_1, kc_phylum_action );
			break; }
			case (int)sel_Consintarray: {
				fprint_int(kc_f, ((intarray)kc_p)->u.Consintarray.int_1);
				kc_do_print_phylum(kc_f, (kc_voidptr_t)((intarray)kc_p)->u.Consintarray.intarray_1, kc_phylum_intarray );
			break; }
			default:
			for (kc_i=0; kc_i < kc_op_info->no_sons; kc_i++) {
				kc_do_print_phylum(kc_f, (kc_voidptr_t)KC_SUBPHYLUM(kc_p, kc_op_info->suboffset[kc_i]), kc_op_info->subphylum[kc_i] );
			}
			}
			kc_indentation--;
			(void)fprintf(kc_f, kc_printformat_not_nullair_close, kc_indentation, "");
}	}	}	
void print_nocasestring
#ifdef KC_USE_PROTOTYPES
(nocasestring kc_p)
#else
(kc_p) nocasestring kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_nocasestring);  }
void fprint_nocasestring
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, nocasestring kc_p)
#else
(kc_f, kc_p) FILE *kc_f; nocasestring kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_nocasestring);  }
void print_casestring
#ifdef KC_USE_PROTOTYPES
(casestring kc_p)
#else
(kc_p) casestring kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_casestring);  }
void fprint_casestring
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, casestring kc_p)
#else
(kc_f, kc_p) FILE *kc_f; casestring kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_casestring);  }
void print_float
#ifdef KC_USE_PROTOTYPES
(float kc_p)
#else
(kc_p) float kc_p;
#endif
{ (void)fprintf(stdout, "%*s%f\n", kc_indentation, "", kc_p);  }
void fprint_float
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, float kc_p)
#else
(kc_f, kc_p) FILE *kc_f; float kc_p;
#endif
{	if (!kc_f) kc_f = stdout;
	(void)fprintf(kc_f, "%*s%f\n", kc_indentation, "", kc_p);
}
void print_int
#ifdef KC_USE_PROTOTYPES
(int kc_p)
#else
(kc_p) int kc_p;
#endif
{ (void)fprintf(stdout, "%*s%d\n", kc_indentation, "", kc_p);  }
void fprint_int
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, int kc_p)
#else
(kc_f, kc_p) FILE *kc_f; int kc_p;
#endif
{	if (!kc_f) kc_f = stdout;
	(void)fprintf(kc_f, "%*s%d\n", kc_indentation, "", kc_p);
}
void print_voidptr
#ifdef KC_USE_PROTOTYPES
(voidptr kc_p)
#else
(kc_p) voidptr kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_voidptr);  }
void fprint_voidptr
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, voidptr kc_p)
#else
(kc_f, kc_p) FILE *kc_f; voidptr kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_voidptr);  }
void print_spec
#ifdef KC_USE_PROTOTYPES
(spec kc_p)
#else
(kc_p) spec kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_spec);  }
void fprint_spec
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, spec kc_p)
#else
(kc_f, kc_p) FILE *kc_f; spec kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_spec);  }
void print_decllist
#ifdef KC_USE_PROTOTYPES
(decllist kc_p)
#else
(kc_p) decllist kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_decllist);  }
void fprint_decllist
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, decllist kc_p)
#else
(kc_f, kc_p) FILE *kc_f; decllist kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_decllist);  }
void print_decl
#ifdef KC_USE_PROTOTYPES
(decl kc_p)
#else
(kc_p) decl kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_decl);  }
void fprint_decl
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, decl kc_p)
#else
(kc_f, kc_p) FILE *kc_f; decl kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_decl);  }
void print_asslist
#ifdef KC_USE_PROTOTYPES
(asslist kc_p)
#else
(kc_p) asslist kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_asslist);  }
void fprint_asslist
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, asslist kc_p)
#else
(kc_f, kc_p) FILE *kc_f; asslist kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_asslist);  }
void print_assign
#ifdef KC_USE_PROTOTYPES
(assign kc_p)
#else
(kc_p) assign kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_assign);  }
void fprint_assign
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, assign kc_p)
#else
(kc_f, kc_p) FILE *kc_f; assign kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_assign);  }
void print_expr
#ifdef KC_USE_PROTOTYPES
(expr kc_p)
#else
(kc_p) expr kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_expr);  }
void fprint_expr
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, expr kc_p)
#else
(kc_f, kc_p) FILE *kc_f; expr kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_expr);  }
void print_freq
#ifdef KC_USE_PROTOTYPES
(freq kc_p)
#else
(kc_p) freq kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_freq);  }
void fprint_freq
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, freq kc_p)
#else
(kc_f, kc_p) FILE *kc_f; freq kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_freq);  }
void print_id
#ifdef KC_USE_PROTOTYPES
(id kc_p)
#else
(kc_p) id kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_id);  }
void fprint_id
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, id kc_p)
#else
(kc_f, kc_p) FILE *kc_f; id kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_id);  }
void print_idtype
#ifdef KC_USE_PROTOTYPES
(idtype kc_p)
#else
(kc_p) idtype kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_idtype);  }
void fprint_idtype
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, idtype kc_p)
#else
(kc_f, kc_p) FILE *kc_f; idtype kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_idtype);  }
void print_uid
#ifdef KC_USE_PROTOTYPES
(uid kc_p)
#else
(kc_p) uid kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_uid);  }
void fprint_uid
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, uid kc_p)
#else
(kc_f, kc_p) FILE *kc_f; uid kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_uid);  }
void print_idx2event
#ifdef KC_USE_PROTOTYPES
(idx2event kc_p)
#else
(kc_p) idx2event kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_idx2event);  }
void fprint_idx2event
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, idx2event kc_p)
#else
(kc_f, kc_p) FILE *kc_f; idx2event kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_idx2event);  }
void print_transitions
#ifdef KC_USE_PROTOTYPES
(transitions kc_p)
#else
(kc_p) transitions kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_transitions);  }
void fprint_transitions
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, transitions kc_p)
#else
(kc_f, kc_p) FILE *kc_f; transitions kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_transitions);  }
void print_locations
#ifdef KC_USE_PROTOTYPES
(locations kc_p)
#else
(kc_p) locations kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_locations);  }
void fprint_locations
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, locations kc_p)
#else
(kc_f, kc_p) FILE *kc_f; locations kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_locations);  }
void print_location
#ifdef KC_USE_PROTOTYPES
(location kc_p)
#else
(kc_p) location kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_location);  }
void fprint_location
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, location kc_p)
#else
(kc_f, kc_p) FILE *kc_f; location kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_location);  }
void print_transition
#ifdef KC_USE_PROTOTYPES
(transition kc_p)
#else
(kc_p) transition kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_transition);  }
void fprint_transition
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, transition kc_p)
#else
(kc_f, kc_p) FILE *kc_f; transition kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_transition);  }
void print_action
#ifdef KC_USE_PROTOTYPES
(action kc_p)
#else
(kc_p) action kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_action);  }
void fprint_action
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, action kc_p)
#else
(kc_f, kc_p) FILE *kc_f; action kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_action);  }
void print_map
#ifdef KC_USE_PROTOTYPES
(map kc_p)
#else
(kc_p) map kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_map);  }
void fprint_map
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, map kc_p)
#else
(kc_f, kc_p) FILE *kc_f; map kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_map);  }
void print_event
#ifdef KC_USE_PROTOTYPES
(event kc_p)
#else
(kc_p) event kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_event);  }
void fprint_event
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, event kc_p)
#else
(kc_f, kc_p) FILE *kc_f; event kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_event);  }
void print_visibility
#ifdef KC_USE_PROTOTYPES
(visibility kc_p)
#else
(kc_p) visibility kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_visibility);  }
void fprint_visibility
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, visibility kc_p)
#else
(kc_f, kc_p) FILE *kc_f; visibility kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_visibility);  }
void print_events
#ifdef KC_USE_PROTOTYPES
(events kc_p)
#else
(kc_p) events kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_events);  }
void fprint_events
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, events kc_p)
#else
(kc_f, kc_p) FILE *kc_f; events kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_events);  }
void print_state
#ifdef KC_USE_PROTOTYPES
(state kc_p)
#else
(kc_p) state kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_state);  }
void fprint_state
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, state kc_p)
#else
(kc_f, kc_p) FILE *kc_f; state kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_state);  }
void print_label
#ifdef KC_USE_PROTOTYPES
(label kc_p)
#else
(kc_p) label kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_label);  }
void fprint_label
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, label kc_p)
#else
(kc_f, kc_p) FILE *kc_f; label kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_label);  }
void print_intarray
#ifdef KC_USE_PROTOTYPES
(intarray kc_p)
#else
(kc_p) intarray kc_p;
#endif
{ kc_do_print_phylum(stdout, (kc_voidptr_t)kc_p, kc_phylum_intarray);  }
void fprint_intarray
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, intarray kc_p)
#else
(kc_f, kc_p) FILE *kc_f; intarray kc_p;
#endif
{ kc_do_print_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_intarray);  }
static void kc_do_printdot_subgraph_header__nocasestring KC__P((FILE*, nocasestring, char*, char*, boolean, boolean));
static void kc_do_printdot_id_of__nocasestring KC__P((FILE*, nocasestring, boolean, kc_voidptr_t, int));
static void kc_do_printdot__nocasestring KC__P((FILE*, nocasestring, boolean, int*, kc_dotedgenode_t*, char*, boolean, boolean, kc_voidptr_t, int));
/* TERRIBLE HACK: declare non-static, to shut up gcc -Wall ... */
/*static*/ void kc_do_printdot_add_edge_nocasestring KC__P((kc_voidptr_t, kc_enum_phyla, nocasestring, int, int*, kc_dotedgenode_t*, char*));
static void kc_do_printdot_subgraph_header__casestring KC__P((FILE*, casestring, char*, char*, boolean, boolean));
static void kc_do_printdot_id_of__casestring KC__P((FILE*, casestring, boolean, kc_voidptr_t, int));
static void kc_do_printdot__casestring KC__P((FILE*, casestring, boolean, int*, kc_dotedgenode_t*, char*, boolean, boolean, kc_voidptr_t, int));
/* TERRIBLE HACK: declare non-static, to shut up gcc -Wall ... */
/*static*/ void kc_do_printdot_add_edge_casestring KC__P((kc_voidptr_t, kc_enum_phyla, casestring, int, int*, kc_dotedgenode_t*, char*));
static void kc_do_printdot_subgraph_header__float KC__P((FILE*, float, char*, char*, boolean, boolean));
static void kc_do_printdot_id_of__float KC__P((FILE*, float, boolean, kc_voidptr_t, int));
static void kc_do_printdot__float KC__P((FILE*, float, boolean, int*, kc_dotedgenode_t*, char*, boolean, boolean, kc_voidptr_t, int));
/* TERRIBLE HACK: declare non-static, to shut up gcc -Wall ... */
/*static*/ void kc_do_printdot_add_edge_float KC__P((kc_voidptr_t, kc_enum_phyla, float, int, int*, kc_dotedgenode_t*, char*));
static void kc_do_printdot_subgraph_header__int KC__P((FILE*, int, char*, char*, boolean, boolean));
static void kc_do_printdot_id_of__int KC__P((FILE*, int, boolean, kc_voidptr_t, int));
static void kc_do_printdot__int KC__P((FILE*, int, boolean, int*, kc_dotedgenode_t*, char*, boolean, boolean, kc_voidptr_t, int));
/* TERRIBLE HACK: declare non-static, to shut up gcc -Wall ... */
/*static*/ void kc_do_printdot_add_edge_int KC__P((kc_voidptr_t, kc_enum_phyla, int, int, int*, kc_dotedgenode_t*, char*));
static void kc_do_printdot_subgraph_header__voidptr KC__P((FILE*, voidptr, char*, char*, boolean, boolean));
static void kc_do_printdot_id_of__voidptr KC__P((FILE*, voidptr, boolean, kc_voidptr_t, int));
static void kc_do_printdot__voidptr KC__P((FILE*, voidptr, boolean, int*, kc_dotedgenode_t*, char*, boolean, boolean, kc_voidptr_t, int));
/* TERRIBLE HACK: declare non-static, to shut up gcc -Wall ... */
/*static*/ void kc_do_printdot_add_edge_voidptr KC__P((kc_voidptr_t, kc_enum_phyla, voidptr, int, int*, kc_dotedgenode_t*, char*));

static void kc_do_printdot_subgraph_header KC__P((FILE*, kc_voidptr_t, kc_enum_phyla, char*, char*, boolean, boolean));
static void kc_do_printdot_subgraph_footer KC__P((FILE*));
static void kc_do_printdot_genfields KC__P((FILE*, int, kc_enum_phyla, boolean));
static void kc_do_printdot_id_of_phylum KC__P((FILE*, kc_voidptr_t, kc_enum_phyla, boolean, kc_voidptr_t, int));
static void kc_do_printdot_do_add_edge KC__P((YYSTYPE, kc_enum_phyla, YYSTYPE, kc_enum_phyla, int, int*, kc_dotedgenode_t*, char*));
static void kc_do_printdot_add_edge KC__P((kc_voidptr_t, kc_enum_phyla, kc_voidptr_t, kc_enum_phyla, int, int*, kc_dotedgenode_t*, char*));
static void kc_do_printdot_edges KC__P((FILE*, kc_dotedgenode_t, char*, boolean));
static void kc_do_printdot_phylum KC__P((FILE*, kc_voidptr_t, kc_enum_phyla, boolean, int*, kc_dotedgenode_t*, char*, boolean, boolean, kc_voidptr_t, int));

static kc_hashtable_t kc_fprintdot_hashtable;
static int kc_fprintdot_hashtablesize = 5000;
int kc_set_fprintdot_hashtablesize
#ifdef KC_USE_PROTOTYPES
(int kc_i)
#else
(kc_i) int kc_i;
#endif
{	int kc_tmp = kc_fprintdot_hashtablesize;
	kc_fprintdot_hashtablesize =  kc_i;
	return kc_tmp;
}

static void kc_do_printdot_subgraph_header
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, kc_voidptr_t kc_p, kc_enum_phyla kc_phylum, char *kc_root, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt)
#else
(kc_f, kc_p, kc_phylum, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt) FILE *kc_f; kc_voidptr_t kc_p; kc_enum_phyla kc_phylum; char *kc_root; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;
#endif
{	if (!kc_f) kc_f = stdout;
	(void)fprintf(kc_f, "/*subgraph*/ {\n");
	if (kc_root) {
		(void)fprintf(kc_f, "\"%s\" [shape=ellipse", kc_root);
		if (kc_edge_attributes && (strlen(kc_edge_attributes) > 0)) {
			(void)fprintf(kc_f, ", %s", kc_edge_attributes);
		}
		if (kc_phy_labels) {
			(void)fprintf(kc_f, ", label=\"%s\\n%s\"", kc_root, kc_PhylumInfo[kc_phylum].name);
		}
		(void)fprintf(kc_f, "];\n");
		(void)fprintf(kc_f, "\"%s\" ->", kc_root);
		kc_do_printdot_id_of_phylum(kc_f, kc_p, kc_phylum, kc_use_ctxt, 0, 0);
		if (kc_edge_attributes && (strlen(kc_edge_attributes) > 0)) {
			(void)fprintf(kc_f, "[%s]", kc_edge_attributes);
		}
		(void)fprintf(kc_f, ";\n");
	}
}	

static void kc_do_printdot_subgraph_footer
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f)
#else
(kc_f) FILE *kc_f;
#endif
{	if (!kc_f) kc_f = stdout;
	(void)fprintf(kc_f, "}\n");
}
	
void fprintdotheader
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f)
#else
(kc_f) FILE *kc_f;
#endif
{	if (!kc_f) kc_f = stdout;
	(void)fprintf(kc_f, "digraph kc_output{\n");
	(void)fprintf(kc_f, "node [shape=record, height=.1, fontname=Helvetica];\n");
}	

void fprintdotfooter
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f)
#else
(kc_f) FILE *kc_f;
#endif
{	if (!kc_f) kc_f = stdout;
	(void)fprintf(kc_f, "}\n");
}
	
static void kc_do_printdot_genfields
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, int kc_prodsel, kc_enum_phyla kc_phylum, boolean kc_phy_labels)
#else
(kc_f, kc_prodsel, kc_phylum, kc_phy_labels) FILE *kc_f; int kc_prodsel; kc_enum_phyla kc_phylum; boolean kc_phy_labels;
#endif
{	int kc_i = 1;
	KC_OPERATOR_INFO *kc_op_info = &kc_OperatorInfo[(int)kc_prodsel];
	if (kc_op_info->no_sons <= 0) return;
	if (!kc_f) kc_f = stdout;
	while(kc_i < kc_op_info->no_sons) {
		(void)fprintf(kc_f, "<f%d>", kc_i);
		if (kc_phy_labels) {
			(void)fprintf(kc_f, "%s", kc_PhylumInfo[(int)kc_op_info->subphylum[kc_i-1]].name);

		}
		(void)fprintf(kc_f, "|");
		kc_i++;
	}
	(void)fprintf(kc_f, "<f%d>", kc_i);
	if (kc_phy_labels) {
		(void)fprintf(kc_f, "%s", kc_PhylumInfo[(int)kc_op_info->subphylum[kc_i-1]].name);
	}
}	

static void kc_do_printdot_id_of_phylum
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, kc_voidptr_t kc_p, kc_enum_phyla kc_phylum, boolean kc_use_ctxt, kc_voidptr_t kc_ctxt, int kc_son_nr)
#else
(kc_f, kc_p, kc_phylum, kc_use_ctxt, kc_ctxt, kc_son_nr) FILE *kc_f; kc_voidptr_t kc_p; kc_enum_phyla kc_phylum; boolean kc_use_ctxt; kc_voidptr_t kc_ctxt; int kc_son_nr;
#endif
{
	/*SUPPRESS 622*/
	assertReason(kc_phylum != kc_phylum_int, "kc_do_printdot_phylum called with kc_phylum_int argument");
	/*SUPPRESS 622*/
	assertReason(kc_phylum != kc_phylum_float, "kc_do_printdot_phylum called with kc_phylum_float argument");
	/*SUPPRESS 622*/
	assertPhylum(((casestring)kc_p),"kc_p",kc_phylum);
	if (!kc_f) kc_f = stdout;
	if (kc_phylum == kc_phylum_voidptr) {
		(void)fprintf(kc_f, "kcidp%p", kc_p);
		if (kc_use_ctxt) {
			(void)fprintf(kc_f, "_%p_%d", kc_ctxt, kc_son_nr);
		}
	} else if ((kc_phylum == kc_phylum_casestring) || (kc_phylum == kc_phylum_nocasestring)) {
		(void)fprintf(kc_f, "kcids%p", ((casestring)kc_p));
		if (kc_use_ctxt) {
			(void)fprintf(kc_f, "_%p_%d", kc_ctxt, kc_son_nr);
		}
	} else {
		(void)fprintf(kc_f, "kcidx%p", kc_p);
}	}	

static void kc_do_printdot_do_add_edge
#ifdef KC_USE_PROTOTYPES
(YYSTYPE kc_p, kc_enum_phyla kc_phylum, YYSTYPE kc_sub_p, kc_enum_phyla kc_sub_phylum, int kc_son_nr, int *kc_edge_nr, kc_dotedgenode_t *kc_edges, char *kc_edge_prefix)
#else
(kc_p, kc_phylum, kc_sub_p, kc_sub_phylum, kc_son_nr, kc_edge_nr, kc_edges, kc_edge_prefix) kc_voidptr_t kc_p; kc_enum_phyla kc_phylum; kc_voidptr_t kc_sub_p; kc_enum_phyla kc_sub_phylum; int kc_son_nr; int *kc_edge_nr; kc_dotedgenode_t *kc_edges; char *kc_edge_prefix;
#endif
{	kc_dotedgenode_t kc_hn;
	char kc_buf[30];
	kc_hn = kc_mkdotedgenode(kc_fprintdot_hashtable, kc_p, kc_phylum, kc_sub_p, kc_sub_phylum, kc_son_nr);
	if (! kc_hn->label) {
		kc_hn->label = (char*)(*kc_fprintdot_hashtable->malloc)((kc_size_t)(KC_PRINTDOT_LABELSIZE+1)*sizeof(char), kc_fprintdot_hashtable->malloc_private_data);
		kc_hn->lsize = KC_PRINTDOT_LABELSIZE;
		(void)strcpy(kc_hn->label, "");
		kc_hn->next = *kc_edges;
		*kc_edges = kc_hn;
	} else {
		char kc_buf2[30];
		(void)sprintf(kc_buf2, ", ");
		(void)strncat(kc_hn->label, kc_buf2, kc_hn->lsize - strlen(kc_hn->label));
	}
	if (kc_edge_prefix) {
		(void)strncat(kc_hn->label, kc_edge_prefix, kc_hn->lsize - strlen(kc_hn->label));
	}
	(void)sprintf(kc_buf, "%d", *kc_edge_nr);
	(void)strncat(kc_hn->label, kc_buf, kc_hn->lsize - strlen(kc_hn->label));
	(*kc_edge_nr)++;
}

static void kc_do_printdot_add_edge
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_p, kc_enum_phyla kc_phylum, kc_voidptr_t kc_sub_p, kc_enum_phyla kc_sub_phylum, int kc_son_nr, int *kc_edge_nr, kc_dotedgenode_t *kc_edges, char *kc_edge_prefix)
#else
(kc_p, kc_phylum, kc_sub_p, kc_sub_phylum, kc_son_nr, kc_edge_nr, kc_edges, kc_edge_prefix) kc_voidptr_t kc_p; kc_enum_phyla kc_phylum; kc_voidptr_t kc_sub_p; kc_enum_phyla kc_sub_phylum; int kc_son_nr; int *kc_edge_nr; kc_dotedgenode_t *kc_edges; char *kc_edge_prefix;
#endif
{	YYSTYPE kc_n, kc_sub_n;
	/*SUPPRESS 622*/
	assertReason(kc_phylum != kc_phylum_int, "kc_do_printdot_phylum called with kc_phylum_int argument");
	/*SUPPRESS 622*/
	assertReason(kc_phylum != kc_phylum_float, "kc_do_printdot_phylum called with kc_phylum_float argument");
	/*SUPPRESS 622*/
	assertPhylum(((casestring)kc_p),"kc_p",kc_phylum);
	kc_n.yt_voidptr = kc_p;
	kc_sub_n.yt_voidptr = kc_sub_p;
	kc_do_printdot_do_add_edge(kc_n, kc_phylum, kc_sub_n, kc_sub_phylum, kc_son_nr, kc_edge_nr, kc_edges, kc_edge_prefix);
}

static void kc_do_printdot_edges
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, kc_dotedgenode_t kc_edges, char *kc_edge_attributes, boolean kc_use_ctxt)
#else
(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt) FILE *kc_f; kc_dotedgenode_t kc_edges; char *kc_edge_attributes; boolean kc_use_ctxt;
#endif
{	kc_dotedgenode_t kc_p = kc_edges;
	if (!kc_f) kc_f = stdout;
	while(kc_p) {
		kc_do_printdot_id_of_phylum(kc_f, kc_p->ptr_from.yt_voidptr, kc_p->phy_from, kc_use_ctxt, 0, 0);
		(void)fprintf(kc_f, ":f%d -> ", kc_p->son_nr);
		switch(kc_p->phy_to) {
		case (int)kc_phylum_int: {
			kc_do_printdot_id_of__int(kc_f, kc_p->ptr_to.yt_int, kc_use_ctxt, kc_p->ptr_from.yt_voidptr, kc_p->son_nr);
		break; }
		case (int)kc_phylum_float: {
			kc_do_printdot_id_of__float(kc_f, kc_p->ptr_to.yt_float, kc_use_ctxt, kc_p->ptr_from.yt_voidptr, kc_p->son_nr);
		break; }
		default:
		kc_do_printdot_id_of_phylum(kc_f, kc_p->ptr_to.yt_voidptr, kc_p->phy_to, kc_use_ctxt, kc_p->ptr_from.yt_voidptr, kc_p->son_nr);
		}
		(void)fprintf(kc_f, " [label=\"%s\"", kc_p->label);
		if (kc_edge_attributes && (strlen(kc_edge_attributes) > 0)) {
			(void)fprintf(kc_f, ", %s", kc_edge_attributes);
		}
		(void)fprintf(kc_f, "];\n");
		kc_p = kc_p->next;
}	}	

static void kc_do_printdot_phylum
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, kc_voidptr_t kc_p, kc_enum_phyla kc_phylum, boolean kc_outmost, int *kc_edge_nr, kc_dotedgenode_t *kc_edges, char *kc_edge_prefix, boolean kc_phy_labels, boolean kc_use_ctxt, kc_voidptr_t kc_ctxt, int kc_son_nr)
#else
(kc_f, kc_p, kc_phylum, kc_outmost, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_ctxt, kc_son_nr) FILE *kc_f; kc_voidptr_t kc_p; kc_enum_phyla kc_phylum; boolean kc_outmost; int *kc_edge_nr; kc_dotedgenode_t *kc_edges; char *kc_edge_prefix; boolean kc_phy_labels; boolean kc_use_ctxt; kc_voidptr_t kc_ctxt; int kc_son_nr;
#endif
{	int kc_i;

	/*SUPPRESS 622*/
	assertReason(kc_phylum != kc_phylum_int, "kc_do_printdot_phylum called with kc_phylum_int argument");
	/*SUPPRESS 622*/
	assertReason(kc_phylum != kc_phylum_float, "kc_do_printdot_phylum called with kc_phylum_float argument");
	/*SUPPRESS 622*/
	assertPhylum(((casestring)kc_p),"kc_p",kc_phylum);
	if (!kc_f) kc_f = stdout;
	if (kc_phylum == kc_phylum_voidptr) {
		kc_do_printdot_id_of_phylum(kc_f, kc_p, kc_phylum, kc_use_ctxt, kc_ctxt, kc_son_nr);
		(void)fprintf(kc_f, " [label=\"%p\", shape=ellipse];\n", kc_p);
	} else if ((kc_phylum == kc_phylum_casestring) || (kc_phylum == kc_phylum_nocasestring)) {
		kc_do_printdot_id_of_phylum(kc_f, kc_p, kc_phylum, kc_use_ctxt, kc_ctxt, kc_son_nr);
		(void)fprintf(kc_f, " [label=\"%s\", shape=ellipse];\n", ((casestring)kc_p)->name);
	} else {
		kc_enum_operators kc_prodsel = ((casestring)kc_p)->prod_sel;
		KC_OPERATOR_INFO *kc_op_info = &kc_OperatorInfo[(int)kc_prodsel];
		if (! kc_op_info->no_sons) {
			kc_do_printdot_id_of_phylum(kc_f, kc_p, kc_phylum, kc_use_ctxt, kc_ctxt, kc_son_nr);
			(void)fprintf(kc_f, " [label=\"<f0>%s\"];\n", kc_op_info->name);
		} else {
			kc_do_printdot_id_of_phylum(kc_f, kc_p, kc_phylum, kc_use_ctxt, kc_ctxt, kc_son_nr);
			(void)fprintf(kc_f, " [label=\"{<f0>%s|{", kc_op_info->name);
			kc_do_printdot_genfields(kc_f, kc_prodsel, kc_phylum, kc_phy_labels);
			(void)fprintf(kc_f, "}}\"];\n");
			switch(kc_prodsel) {
			case (int)sel_LFreq: {
				kc_i = 0;
				kc_do_printdot_add_edge_int(kc_p, kc_phylum, ((freq)kc_p)->u.LFreq.int_1,  kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot__int(kc_f, ((freq)kc_p)->u.LFreq.int_1, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
			break; }
			case (int)sel_UFreq: {
				kc_i = 0;
				kc_do_printdot_add_edge_int(kc_p, kc_phylum, ((freq)kc_p)->u.UFreq.int_1,  kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot__int(kc_f, ((freq)kc_p)->u.UFreq.int_1, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
			break; }
			case (int)sel_Freq: {
				kc_i = 0;
				kc_do_printdot_add_edge_int(kc_p, kc_phylum, ((freq)kc_p)->u.Freq.int_1,  kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot__int(kc_f, ((freq)kc_p)->u.Freq.int_1, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
				kc_do_printdot_add_edge_int(kc_p, kc_phylum, ((freq)kc_p)->u.Freq.int_2,  kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot__int(kc_f, ((freq)kc_p)->u.Freq.int_2, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
			break; }
			case (int)sel_IndexMap: {
				kc_i = 0;
				kc_do_printdot_add_edge_int(kc_p, kc_phylum, ((idx2event)kc_p)->u.IndexMap.int_1,  kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot__int(kc_f, ((idx2event)kc_p)->u.IndexMap.int_1, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
			break; }
			case (int)sel_Location: {
				kc_i = 0;
				kc_do_printdot_add_edge_int(kc_p, kc_phylum, ((location)kc_p)->u.Location.int_1,  kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot__int(kc_f, ((location)kc_p)->u.Location.int_1, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
			break; }
			case (int)sel_GreaterEqual: {
				kc_i = 0;
				kc_do_printdot_add_edge_int(kc_p, kc_phylum, ((action)kc_p)->u.GreaterEqual.int_1,  kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot__int(kc_f, ((action)kc_p)->u.GreaterEqual.int_1, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
				kc_do_printdot_add_edge_int(kc_p, kc_phylum, ((action)kc_p)->u.GreaterEqual.int_2,  kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot__int(kc_f, ((action)kc_p)->u.GreaterEqual.int_2, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
			break; }
			case (int)sel_Incr: {
				kc_i = 0;
				kc_do_printdot_add_edge_int(kc_p, kc_phylum, ((action)kc_p)->u.Incr.int_1,  kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot__int(kc_f, ((action)kc_p)->u.Incr.int_1, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
			break; }
			case (int)sel_LessThan: {
				kc_i = 0;
				kc_do_printdot_add_edge_int(kc_p, kc_phylum, ((action)kc_p)->u.LessThan.int_1,  kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot__int(kc_f, ((action)kc_p)->u.LessThan.int_1, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
				kc_do_printdot_add_edge_int(kc_p, kc_phylum, ((action)kc_p)->u.LessThan.int_2,  kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot__int(kc_f, ((action)kc_p)->u.LessThan.int_2, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
			break; }
			case (int)sel_Reset: {
				kc_i = 0;
				kc_do_printdot_add_edge_int(kc_p, kc_phylum, ((action)kc_p)->u.Reset.int_1,  kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot__int(kc_f, ((action)kc_p)->u.Reset.int_1, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
			break; }
			case (int)sel_MapTransition: {
				kc_i = 0;
				kc_do_printdot_add_edge_int(kc_p, kc_phylum, ((map)kc_p)->u.MapTransition.int_1,  kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot__int(kc_f, ((map)kc_p)->u.MapTransition.int_1, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
			break; }
			case (int)sel_MapEvent: {
				kc_i = 0;
				kc_do_printdot_add_edge_int(kc_p, kc_phylum, ((map)kc_p)->u.MapEvent.int_1,  kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot__int(kc_f, ((map)kc_p)->u.MapEvent.int_1, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
			break; }
			case (int)sel_CounterLabel: {
				kc_i = 0;
				kc_do_printdot_add_edge_int(kc_p, kc_phylum, ((label)kc_p)->u.CounterLabel.int_1,  kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot__int(kc_f, ((label)kc_p)->u.CounterLabel.int_1, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
				kc_do_printdot_add_edge(kc_f, kc_phylum, (kc_voidptr_t)((label)kc_p)->u.CounterLabel.action_1, kc_phylum_action, kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot_phylum(kc_f, (kc_voidptr_t)((label)kc_p)->u.CounterLabel.action_1, kc_phylum_action, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
			break; }
			case (int)sel_Consintarray: {
				kc_i = 0;
				kc_do_printdot_add_edge_int(kc_p, kc_phylum, ((intarray)kc_p)->u.Consintarray.int_1,  kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot__int(kc_f, ((intarray)kc_p)->u.Consintarray.int_1, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
				kc_do_printdot_add_edge(kc_f, kc_phylum, (kc_voidptr_t)((intarray)kc_p)->u.Consintarray.intarray_1, kc_phylum_intarray, kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix);
				kc_do_printdot_phylum(kc_f, (kc_voidptr_t)((intarray)kc_p)->u.Consintarray.intarray_1, kc_phylum_intarray, False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1);
				kc_i++;
			break; }
			default:
			for (kc_i=0; kc_i < kc_op_info->no_sons; kc_i++) {
				kc_do_printdot_add_edge( kc_p, kc_phylum, (kc_voidptr_t)KC_SUBPHYLUM(kc_p, kc_op_info->suboffset[kc_i]), kc_op_info->subphylum[kc_i], kc_i+1, kc_edge_nr, kc_edges, kc_edge_prefix );
				kc_do_printdot_phylum( kc_f, (kc_voidptr_t)KC_SUBPHYLUM(kc_p, kc_op_info->suboffset[kc_i]), kc_op_info->subphylum[kc_i], False, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_p, kc_i+1 );
			}
			}
	}	}	
}
static void kc_do_printdot_subgraph_header__nocasestring
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, nocasestring kc_p, char *kc_root, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt)
#else
(kc_f, kc_p, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt) FILE *kc_f; nocasestring kc_p; char *kc_root; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;
#endif
{	if (!kc_f) kc_f = stdout;
	(void)fprintf(kc_f, "/*subgraph*/ {\n");
	if (kc_root) {
		(void)fprintf(kc_f, "\"%s\" [shape=ellipse", kc_root);
		if (kc_edge_attributes && (strlen(kc_edge_attributes) > 0)) {
			(void)fprintf(kc_f, ", %s", kc_edge_attributes);
		}
		if (kc_phy_labels) {
			(void)fprintf(kc_f, ", label=\"%s\\n%s\"", kc_root, kc_PhylumInfo[kc_phylum_nocasestring].name);
		}
		(void)fprintf(kc_f, "];\n");
		(void)fprintf(kc_f, "\"%s\" ->", kc_root);
		kc_do_printdot_id_of__nocasestring(kc_f, kc_p, kc_use_ctxt, 0, 0);
		if (kc_edge_attributes && (strlen(kc_edge_attributes) > 0)) {
			(void)fprintf(kc_f, "[%s]", kc_edge_attributes);
		}
		(void)fprintf(kc_f, ";\n");
	}
}
static void kc_do_printdot_id_of__nocasestring
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, nocasestring kc_p, boolean kc_use_ctxt, kc_voidptr_t kc_ctxt, int kc_son_nr)
#else
(kc_f, kc_p, kc_use_ctxt, kc_ctxt, kc_son_nr) FILE *kc_f; nocasestring kc_p; boolean kc_use_ctxt; kc_voidptr_t kc_ctxt; int kc_son_nr;
#endif
{ kc_do_printdot_id_of_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_nocasestring, kc_use_ctxt, kc_ctxt, kc_son_nr);  }
static void kc_do_printdot__nocasestring
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, nocasestring kc_p, boolean kc_outmost, int *kc_edge_nr, kc_dotedgenode_t *kc_edges, char *kc_edge_prefix, boolean kc_phy_labels, boolean kc_use_ctxt, kc_voidptr_t kc_ctxt, int kc_son_nr)
#else
(kc_f, kc_p, kc_outmost, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_ctxt, kc_son_nr) FILE *kc_f; nocasestring kc_p; boolean kc_outmost; int *kc_edge_nr; kc_dotedgenode_t *kc_edges; char *kc_edge_prefix; boolean kc_phy_labels; boolean kc_use_ctxt; kc_voidptr_t kc_ctxt; int kc_son_nr;
#endif
{ kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_nocasestring, kc_outmost, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_ctxt, kc_son_nr); }
/* TERRIBLE HACK: declare non-static, to shut up gcc -Wall ... */
/*static*/ void kc_do_printdot_add_edge_nocasestring
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_p, kc_enum_phyla kc_phylum, nocasestring kc_sub_p, int kc_son_nr, int *kc_edge_nr, kc_dotedgenode_t *kc_edges, char *kc_edge_prefix)
#else
(kc_p, kc_phylum, kc_sub_p, kc_son_nr, kc_edge_nr, kc_edges, kc_edge_prefix) kc_voidptr_t kc_p; kc_enum_phyla kc_phylum; nocasestring kc_sub_p; int kc_son_nr; int *kc_edge_nr; kc_dotedgenode_t *kc_edges; char *kc_edge_prefix;
#endif
{ kc_do_printdot_add_edge(kc_p, kc_phylum, kc_sub_p, kc_phylum_nocasestring, kc_son_nr, kc_edge_nr, kc_edges, kc_edge_prefix); }
void fprintdot_nocasestring
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, nocasestring kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; nocasestring kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header__nocasestring(kc_f, kc_p, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot__nocasestring(kc_f, kc_p, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
static void kc_do_printdot_subgraph_header__casestring
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, casestring kc_p, char *kc_root, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt)
#else
(kc_f, kc_p, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt) FILE *kc_f; casestring kc_p; char *kc_root; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;
#endif
{	if (!kc_f) kc_f = stdout;
	(void)fprintf(kc_f, "/*subgraph*/ {\n");
	if (kc_root) {
		(void)fprintf(kc_f, "\"%s\" [shape=ellipse", kc_root);
		if (kc_edge_attributes && (strlen(kc_edge_attributes) > 0)) {
			(void)fprintf(kc_f, ", %s", kc_edge_attributes);
		}
		if (kc_phy_labels) {
			(void)fprintf(kc_f, ", label=\"%s\\n%s\"", kc_root, kc_PhylumInfo[kc_phylum_casestring].name);
		}
		(void)fprintf(kc_f, "];\n");
		(void)fprintf(kc_f, "\"%s\" ->", kc_root);
		kc_do_printdot_id_of__casestring(kc_f, kc_p, kc_use_ctxt, 0, 0);
		if (kc_edge_attributes && (strlen(kc_edge_attributes) > 0)) {
			(void)fprintf(kc_f, "[%s]", kc_edge_attributes);
		}
		(void)fprintf(kc_f, ";\n");
	}
}
static void kc_do_printdot_id_of__casestring
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, casestring kc_p, boolean kc_use_ctxt, kc_voidptr_t kc_ctxt, int kc_son_nr)
#else
(kc_f, kc_p, kc_use_ctxt, kc_ctxt, kc_son_nr) FILE *kc_f; casestring kc_p; boolean kc_use_ctxt; kc_voidptr_t kc_ctxt; int kc_son_nr;
#endif
{ kc_do_printdot_id_of_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_casestring, kc_use_ctxt, kc_ctxt, kc_son_nr);  }
static void kc_do_printdot__casestring
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, casestring kc_p, boolean kc_outmost, int *kc_edge_nr, kc_dotedgenode_t *kc_edges, char *kc_edge_prefix, boolean kc_phy_labels, boolean kc_use_ctxt, kc_voidptr_t kc_ctxt, int kc_son_nr)
#else
(kc_f, kc_p, kc_outmost, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_ctxt, kc_son_nr) FILE *kc_f; casestring kc_p; boolean kc_outmost; int *kc_edge_nr; kc_dotedgenode_t *kc_edges; char *kc_edge_prefix; boolean kc_phy_labels; boolean kc_use_ctxt; kc_voidptr_t kc_ctxt; int kc_son_nr;
#endif
{ kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_casestring, kc_outmost, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_ctxt, kc_son_nr); }
/* TERRIBLE HACK: declare non-static, to shut up gcc -Wall ... */
/*static*/ void kc_do_printdot_add_edge_casestring
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_p, kc_enum_phyla kc_phylum, casestring kc_sub_p, int kc_son_nr, int *kc_edge_nr, kc_dotedgenode_t *kc_edges, char *kc_edge_prefix)
#else
(kc_p, kc_phylum, kc_sub_p, kc_son_nr, kc_edge_nr, kc_edges, kc_edge_prefix) kc_voidptr_t kc_p; kc_enum_phyla kc_phylum; casestring kc_sub_p; int kc_son_nr; int *kc_edge_nr; kc_dotedgenode_t *kc_edges; char *kc_edge_prefix;
#endif
{ kc_do_printdot_add_edge(kc_p, kc_phylum, kc_sub_p, kc_phylum_casestring, kc_son_nr, kc_edge_nr, kc_edges, kc_edge_prefix); }
void fprintdot_casestring
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, casestring kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; casestring kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header__casestring(kc_f, kc_p, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot__casestring(kc_f, kc_p, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
static void kc_do_printdot_subgraph_header__float
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, float kc_p, char *kc_root, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt)
#else
(kc_f, kc_p, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt) FILE *kc_f; float kc_p; char *kc_root; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;
#endif
{	if (!kc_f) kc_f = stdout;
	(void)fprintf(kc_f, "/*subgraph*/ {\n");
	if (kc_root) {
		(void)fprintf(kc_f, "\"%s\" [shape=ellipse", kc_root);
		if (kc_edge_attributes && (strlen(kc_edge_attributes) > 0)) {
			(void)fprintf(kc_f, ", %s", kc_edge_attributes);
		}
		if (kc_phy_labels) {
			(void)fprintf(kc_f, ", label=\"%s\\n%s\"", kc_root, kc_PhylumInfo[kc_phylum_float].name);
		}
		(void)fprintf(kc_f, "];\n");
		(void)fprintf(kc_f, "\"%s\" ->", kc_root);
		kc_do_printdot_id_of__float(kc_f, kc_p, kc_use_ctxt, 0, 0);
		if (kc_edge_attributes && (strlen(kc_edge_attributes) > 0)) {
			(void)fprintf(kc_f, "[%s]", kc_edge_attributes);
		}
		(void)fprintf(kc_f, ";\n");
	}
}
static void kc_do_printdot_id_of__float
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, float kc_p, boolean kc_use_ctxt, kc_voidptr_t kc_ctxt, int kc_son_nr)
#else
(kc_f, kc_p, kc_use_ctxt, kc_ctxt, kc_son_nr) FILE *kc_f; float kc_p; boolean kc_use_ctxt; kc_voidptr_t kc_ctxt; int kc_son_nr;
#endif
{	if (kc_use_ctxt) {
		(void)fprintf(kc_f, "\"kcidf%f_%p_%d\"", kc_p, kc_ctxt, kc_son_nr);
	} else {
		(void)fprintf(kc_f, "\"kcidf%f\"", kc_p);
}	}
static void kc_do_printdot__float
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, float kc_p, boolean kc_outmost, int *kc_edge_nr, kc_dotedgenode_t *kc_edges, char *kc_edge_prefix, boolean kc_phy_labels, boolean kc_use_ctxt, kc_voidptr_t kc_ctxt, int kc_son_nr)
#else
(kc_f, kc_p, kc_outmost, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_ctxt, kc_son_nr) FILE *kc_f; float kc_p; boolean kc_outmost; int *kc_edge_nr; kc_dotedgenode_t *kc_edges; char *kc_edge_prefix; boolean kc_phy_labels; boolean kc_use_ctxt; kc_voidptr_t kc_ctxt; int kc_son_nr;
#endif
{	if (!kc_f) kc_f = stdout;
	kc_do_printdot_id_of__float(kc_f, kc_p, kc_use_ctxt, kc_ctxt, kc_son_nr);
	(void)fprintf(kc_f, " [label=\"%f\", shape=ellipse];\n", kc_p);
}
/* TERRIBLE HACK: declare non-static, to shut up gcc -Wall ... */
/*static*/ void kc_do_printdot_add_edge_float
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_p, kc_enum_phyla kc_phylum, float kc_sub_p, int kc_son_nr, int *kc_edge_nr, kc_dotedgenode_t *kc_edges, char *kc_edge_prefix)
#else
(kc_p, kc_phylum, kc_sub_p, kc_son_nr, kc_edge_nr, kc_edges, kc_edge_prefix) kc_voidptr_t kc_p; kc_enum_phyla kc_phylum; float kc_sub_p; int kc_son_nr; int *kc_edge_nr; kc_dotedgenode_t *kc_edges; char *kc_edge_prefix;
#endif
{	YYSTYPE kc_n, kc_sub_n;
	kc_n.yt_voidptr = kc_p;
	kc_sub_n.yt_float = kc_sub_p;
	kc_do_printdot_do_add_edge(kc_n, kc_phylum, kc_sub_n, kc_phylum_float, kc_son_nr, kc_edge_nr, kc_edges, kc_edge_prefix);
}
void fprintdot_float
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, float kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; float kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header__float(kc_f, kc_p, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot__float(kc_f, kc_p, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
static void kc_do_printdot_subgraph_header__int
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, int kc_p, char *kc_root, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt)
#else
(kc_f, kc_p, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt) FILE *kc_f; int kc_p; char *kc_root; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;
#endif
{	if (!kc_f) kc_f = stdout;
	(void)fprintf(kc_f, "/*subgraph*/ {\n");
	if (kc_root) {
		(void)fprintf(kc_f, "\"%s\" [shape=ellipse", kc_root);
		if (kc_edge_attributes && (strlen(kc_edge_attributes) > 0)) {
			(void)fprintf(kc_f, ", %s", kc_edge_attributes);
		}
		if (kc_phy_labels) {
			(void)fprintf(kc_f, ", label=\"%s\\n%s\"", kc_root, kc_PhylumInfo[kc_phylum_int].name);
		}
		(void)fprintf(kc_f, "];\n");
		(void)fprintf(kc_f, "\"%s\" ->", kc_root);
		kc_do_printdot_id_of__int(kc_f, kc_p, kc_use_ctxt, 0, 0);
		if (kc_edge_attributes && (strlen(kc_edge_attributes) > 0)) {
			(void)fprintf(kc_f, "[%s]", kc_edge_attributes);
		}
		(void)fprintf(kc_f, ";\n");
	}
}
static void kc_do_printdot_id_of__int
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, int kc_p, boolean kc_use_ctxt, kc_voidptr_t kc_ctxt, int kc_son_nr)
#else
(kc_f, kc_p, kc_use_ctxt, kc_ctxt, kc_son_nr) FILE *kc_f; int kc_p; boolean kc_use_ctxt; kc_voidptr_t kc_ctxt; int kc_son_nr;
#endif
{	if (kc_use_ctxt) {
		(void)fprintf(kc_f, "\"kcidi%d_%p_%d\"", kc_p, kc_ctxt, kc_son_nr);
	} else {
		(void)fprintf(kc_f, "\"kcidi%d\"", kc_p);
}	}
static void kc_do_printdot__int
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, int kc_p, boolean kc_outmost, int *kc_edge_nr, kc_dotedgenode_t *kc_edges, char *kc_edge_prefix, boolean kc_phy_labels, boolean kc_use_ctxt, kc_voidptr_t kc_ctxt, int kc_son_nr)
#else
(kc_f, kc_p, kc_outmost, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_ctxt, kc_son_nr) FILE *kc_f; int kc_p; boolean kc_outmost; int *kc_edge_nr; kc_dotedgenode_t *kc_edges; char *kc_edge_prefix; boolean kc_phy_labels; boolean kc_use_ctxt; kc_voidptr_t kc_ctxt; int kc_son_nr;
#endif
{	if (!kc_f) kc_f = stdout;
	kc_do_printdot_id_of__int(kc_f, kc_p, kc_use_ctxt, kc_ctxt, kc_son_nr);
	(void)fprintf(kc_f, " [label=\"%d\", shape=ellipse];\n", kc_p);
}
/* TERRIBLE HACK: declare non-static, to shut up gcc -Wall ... */
/*static*/ void kc_do_printdot_add_edge_int
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_p, kc_enum_phyla kc_phylum, int kc_sub_p, int kc_son_nr, int *kc_edge_nr, kc_dotedgenode_t *kc_edges, char *kc_edge_prefix)
#else
(kc_p, kc_phylum, kc_sub_p, kc_son_nr, kc_edge_nr, kc_edges, kc_edge_prefix) kc_voidptr_t kc_p; kc_enum_phyla kc_phylum; int kc_sub_p; int kc_son_nr; int *kc_edge_nr; kc_dotedgenode_t *kc_edges; char *kc_edge_prefix;
#endif
{	YYSTYPE kc_n, kc_sub_n;
	kc_n.yt_voidptr = kc_p;
	kc_sub_n.yt_int = kc_sub_p;
	kc_do_printdot_do_add_edge(kc_n, kc_phylum, kc_sub_n, kc_phylum_int, kc_son_nr, kc_edge_nr, kc_edges, kc_edge_prefix);
}
void fprintdot_int
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, int kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; int kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header__int(kc_f, kc_p, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot__int(kc_f, kc_p, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
static void kc_do_printdot_subgraph_header__voidptr
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, voidptr kc_p, char *kc_root, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt)
#else
(kc_f, kc_p, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt) FILE *kc_f; voidptr kc_p; char *kc_root; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;
#endif
{	if (!kc_f) kc_f = stdout;
	(void)fprintf(kc_f, "/*subgraph*/ {\n");
	if (kc_root) {
		(void)fprintf(kc_f, "\"%s\" [shape=ellipse", kc_root);
		if (kc_edge_attributes && (strlen(kc_edge_attributes) > 0)) {
			(void)fprintf(kc_f, ", %s", kc_edge_attributes);
		}
		if (kc_phy_labels) {
			(void)fprintf(kc_f, ", label=\"%s\\n%s\"", kc_root, kc_PhylumInfo[kc_phylum_voidptr].name);
		}
		(void)fprintf(kc_f, "];\n");
		(void)fprintf(kc_f, "\"%s\" ->", kc_root);
		kc_do_printdot_id_of__voidptr(kc_f, kc_p, kc_use_ctxt, 0, 0);
		if (kc_edge_attributes && (strlen(kc_edge_attributes) > 0)) {
			(void)fprintf(kc_f, "[%s]", kc_edge_attributes);
		}
		(void)fprintf(kc_f, ";\n");
	}
}
static void kc_do_printdot_id_of__voidptr
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, voidptr kc_p, boolean kc_use_ctxt, kc_voidptr_t kc_ctxt, int kc_son_nr)
#else
(kc_f, kc_p, kc_use_ctxt, kc_ctxt, kc_son_nr) FILE *kc_f; voidptr kc_p; boolean kc_use_ctxt; kc_voidptr_t kc_ctxt; int kc_son_nr;
#endif
{ kc_do_printdot_id_of_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_voidptr, kc_use_ctxt, kc_ctxt, kc_son_nr);  }
static void kc_do_printdot__voidptr
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, voidptr kc_p, boolean kc_outmost, int *kc_edge_nr, kc_dotedgenode_t *kc_edges, char *kc_edge_prefix, boolean kc_phy_labels, boolean kc_use_ctxt, kc_voidptr_t kc_ctxt, int kc_son_nr)
#else
(kc_f, kc_p, kc_outmost, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_ctxt, kc_son_nr) FILE *kc_f; voidptr kc_p; boolean kc_outmost; int *kc_edge_nr; kc_dotedgenode_t *kc_edges; char *kc_edge_prefix; boolean kc_phy_labels; boolean kc_use_ctxt; kc_voidptr_t kc_ctxt; int kc_son_nr;
#endif
{ kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_voidptr, kc_outmost, kc_edge_nr, kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, kc_ctxt, kc_son_nr); }
/* TERRIBLE HACK: declare non-static, to shut up gcc -Wall ... */
/*static*/ void kc_do_printdot_add_edge_voidptr
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_p, kc_enum_phyla kc_phylum, voidptr kc_sub_p, int kc_son_nr, int *kc_edge_nr, kc_dotedgenode_t *kc_edges, char *kc_edge_prefix)
#else
(kc_p, kc_phylum, kc_sub_p, kc_son_nr, kc_edge_nr, kc_edges, kc_edge_prefix) kc_voidptr_t kc_p; kc_enum_phyla kc_phylum; voidptr kc_sub_p; int kc_son_nr; int *kc_edge_nr; kc_dotedgenode_t *kc_edges; char *kc_edge_prefix;
#endif
{ kc_do_printdot_add_edge(kc_p, kc_phylum, kc_sub_p, kc_phylum_voidptr, kc_son_nr, kc_edge_nr, kc_edges, kc_edge_prefix); }
void fprintdot_voidptr
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, voidptr kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; voidptr kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header__voidptr(kc_f, kc_p, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot__voidptr(kc_f, kc_p, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_spec
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, spec kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; spec kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_spec, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_spec, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_decllist
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, decllist kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; decllist kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_decllist, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_decllist, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_decl
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, decl kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; decl kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_decl, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_decl, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_asslist
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, asslist kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; asslist kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_asslist, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_asslist, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_assign
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, assign kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; assign kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_assign, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_assign, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_expr
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, expr kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; expr kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_expr, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_expr, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_freq
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, freq kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; freq kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_freq, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_freq, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_id
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, id kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; id kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_id, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_id, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_idtype
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, idtype kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; idtype kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_idtype, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_idtype, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_uid
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, uid kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; uid kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_uid, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_uid, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_idx2event
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, idx2event kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; idx2event kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_idx2event, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_idx2event, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_transitions
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, transitions kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; transitions kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_transitions, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_transitions, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_locations
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, locations kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; locations kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_locations, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_locations, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_location
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, location kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; location kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_location, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_location, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_transition
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, transition kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; transition kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_transition, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_transition, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_action
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, action kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; action kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_action, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_action, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_map
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, map kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; map kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_map, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_map, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_event
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, event kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; event kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_event, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_event, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_visibility
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, visibility kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; visibility kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_visibility, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_visibility, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_events
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, events kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; events kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_events, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_events, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_state
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, state kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; state kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_state, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_state, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_label
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, label kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; label kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_label, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_label, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
void fprintdot_intarray
#ifdef KC_USE_PROTOTYPES
(FILE *kc_f, intarray kc_p, char *kc_root, char *kc_edge_prefix, char *kc_edge_attributes, boolean kc_phy_labels, boolean kc_use_ctxt, boolean kc_prt_head_foot)
#else
(kc_f, kc_p, kc_root, kc_edge_prefix, kc_edge_attributes, kc_phy_labels, kc_use_ctxt, kc_prt_head_foot) FILE *kc_f; intarray kc_p; char *kc_root; char *kc_edge_prefix; char *kc_edge_attributes; boolean kc_phy_labels; boolean kc_use_ctxt;; boolean kc_prt_head_foot;
#endif
{	int kc_edge_nr = 1;
	kc_dotedgenode_t kc_edges = 0;
	if (kc_prt_head_foot) fprintdotheader(kc_f);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_header(kc_f, kc_p, kc_phylum_intarray, kc_root, kc_edge_attributes, kc_phy_labels, kc_use_ctxt);
	kc_fprintdot_hashtable = kc_ht_create_simple(kc_fprintdot_hashtablesize);
	kc_do_printdot_phylum(kc_f, (kc_voidptr_t)kc_p, kc_phylum_intarray, True, &kc_edge_nr, &kc_edges, kc_edge_prefix, kc_phy_labels, kc_use_ctxt, 0, 0);
	kc_do_printdot_edges(kc_f, kc_edges, kc_edge_attributes, kc_use_ctxt);
	kc_ht_delete(kc_fprintdot_hashtable);
	/*if (kc_outmost)*/ kc_do_printdot_subgraph_footer(kc_f);
	if (kc_prt_head_foot) fprintdotfooter(kc_f);
}
static char *kc_error_concat = "concat_";
static char *kc_error_reverse = "reverse_";
static char *kc_error_length = "length_";
static char *kc_error_last = "last_";
static char *kc_error_last_with_nil_argument = "Internal Error: last_%s was called with argument Nil%s\n";
static char *kc_error_map = "map_";
static char *kc_error_filter = "filter_";
static char *kc_error_freelist = "freelist_";

static int kc_do_length_phylum
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_p, kc_enum_phyla kc_phylum )
#else
(kc_p, kc_phylum) kc_voidptr_t kc_p; kc_enum_phyla kc_phylum;
#endif
{	boolean kc_not_ready = True;
	int kc_length = 0;
	kc_enum_operators kc_prodsel;
	while(kc_not_ready) {
		/*SUPPRESS 622*/
		assertPhylum(((casestring)kc_p),"kc_p",kc_phylum);
		kc_prodsel = ((casestring)kc_p)->prod_sel;
		if (kc_prodsel == kc_PhylumInfo[(int)kc_phylum].first_operator) {
			kc_not_ready=False;
		} else if (kc_prodsel == kc_PhylumInfo[(int)kc_phylum].last_operator) {
			kc_length++;
			kc_p = (kc_voidptr_t)KC_SUBPHYLUM(kc_p, kc_OperatorInfo[(int)kc_prodsel].suboffset[1]);
		} else {
			kc_invalid_operator(kc_error_length, kc_phylum, __LINE__, __FILE__, (int)kc_prodsel);/*NOTREACHED*/
	}	}
	return kc_length;
}

static void kc_do_freelist_phylum
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_p, kc_enum_phyla kc_phylum )
#else
(kc_p, kc_phylum) kc_voidptr_t kc_p; kc_enum_phyla kc_phylum;
#endif
{	boolean kc_not_ready = True;
	kc_enum_operators kc_prodsel;
	kc_voidptr_t kc_tmp_p;
	while(kc_not_ready) {
		/*SUPPRESS 622*/
		assertPhylum(((casestring)kc_p),"kc_p",kc_phylum);
		kc_prodsel = ((casestring)kc_p)->prod_sel;
		if (kc_prodsel == kc_PhylumInfo[(int)kc_phylum].first_operator) {
			kc_do_free_phylum(kc_p, False, kc_phylum);
			kc_not_ready=False;
		} else if (kc_prodsel == kc_PhylumInfo[(int)kc_phylum].last_operator) {
			kc_tmp_p = kc_p;
			kc_p = (kc_voidptr_t)KC_SUBPHYLUM(kc_p, kc_OperatorInfo[(int)kc_prodsel].suboffset[1]);
			kc_do_free_phylum(kc_tmp_p, False, kc_phylum);
		} else {
			kc_invalid_operator(kc_error_freelist, kc_phylum, __LINE__, __FILE__, (int)kc_prodsel);/*NOTREACHED*/
}	}	}

static kc_voidptr_t kc_do_concat_phylum
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_p1, kc_voidptr_t kc_p2, kc_enum_phyla kc_phylum)
#else
(kc_p1, kc_p2, kc_phylum) kc_voidptr_t kc_p1, kc_p2; kc_enum_phyla kc_phylum;
#endif
{	kc_enum_operators kc_prodsel;
	/*SUPPRESS 622*/
	assertPhylum(((casestring)kc_p1),"kc_p1",kc_phylum);
	kc_prodsel = ((casestring)kc_p1)->prod_sel;
	if (kc_prodsel == kc_PhylumInfo[(int)kc_phylum].first_operator) {
		return kc_p2;
	} else if (kc_prodsel == kc_PhylumInfo[(int)kc_phylum].last_operator) {
		return (kc_voidptr_t)(*kc_OperatorInfo[(int)kc_prodsel].create_routine)(
			kc_prodsel,
			(kc_voidptr_t)KC_SUBPHYLUM(kc_p1, kc_OperatorInfo[(int)kc_prodsel].suboffset[0]),
			 kc_do_concat_phylum( (kc_voidptr_t)KC_SUBPHYLUM(kc_p1, kc_OperatorInfo[(int)kc_prodsel].suboffset[1]), kc_p2, kc_phylum ) );
	} else {
		kc_invalid_operator(kc_error_concat, kc_phylum, __LINE__, __FILE__, (int)kc_prodsel);/*NOTREACHED*/return (kc_voidptr_t)0;
}	}

static kc_voidptr_t kc_do_reverse_phylum
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_p, kc_enum_phyla kc_phylum)
#else
(kc_p, kc_phylum) kc_voidptr_t kc_p; kc_enum_phyla kc_phylum;
#endif
{	boolean kc_not_ready = True;
	kc_enum_operators kc_prodsel;
	KC_PHYLUM_INFO *kc_phy_info = &kc_PhylumInfo[(int)kc_phylum];
	KC_OPERATOR_INFO *kc_firstop_info = &kc_OperatorInfo[(int)kc_phy_info->first_operator];
	KC_OPERATOR_INFO *kc_lastop_info = &kc_OperatorInfo[(int)kc_phy_info->last_operator];
	kc_voidptr_t kc_tmp = (*kc_firstop_info->create_routine)(kc_phy_info->first_operator);
	while(kc_not_ready) {
		/*SUPPRESS 622*/
		assertPhylum(((casestring)kc_p),"kc_p",kc_phylum);
		kc_prodsel = ((casestring)kc_p)->prod_sel;
		if (kc_prodsel == kc_phy_info->first_operator) {
			kc_not_ready=False;
		} else if (kc_prodsel == kc_phy_info->last_operator) {
			kc_tmp = (kc_voidptr_t)(*kc_lastop_info->create_routine)(kc_prodsel, (kc_voidptr_t)KC_SUBPHYLUM(kc_p, kc_lastop_info->suboffset[0]), kc_tmp);
			kc_p = (kc_voidptr_t)KC_SUBPHYLUM(kc_p, kc_lastop_info->suboffset[1]);
		} else {
			kc_invalid_operator(kc_error_reverse, kc_phylum, __LINE__, __FILE__, (int)kc_prodsel);/*NOTREACHED*/
	}	}
	return kc_tmp;
}

static kc_voidptr_t kc_do_last_phylum
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_p, kc_enum_phyla kc_phylum)
#else
(kc_p, kc_phylum) kc_voidptr_t kc_p; kc_enum_phyla kc_phylum;
#endif
{	boolean kc_not_ready = True;
	kc_voidptr_t kc_tmp = (kc_voidptr_t)0;
	kc_enum_operators kc_prodsel;
	KC_PHYLUM_INFO *kc_phy_info = &kc_PhylumInfo[(int)kc_phylum];
	KC_OPERATOR_INFO *kc_lastop_info = &kc_OperatorInfo[(int)kc_phy_info->last_operator];
	/*SUPPRESS 622*/
	assertPhylum(((casestring)kc_p),"kc_p",kc_phylum);
	if (((casestring)kc_p)->prod_sel == kc_phy_info->first_operator) {
		(void)fflush(stdout); (void)fprintf(stderr, kc_error_last_with_nil_argument, kc_phy_info->name,  kc_phy_info->name); exit( 1 ); /*NOTREACHED*/
	}
	while(kc_not_ready) {
		/*SUPPRESS 622*/
		assertPhylum(((casestring)kc_p),"kc_p",kc_phylum);
		kc_prodsel = ((casestring)kc_p)->prod_sel;
		if (kc_prodsel == kc_phy_info->first_operator) {
			kc_not_ready=False;
		} else if (kc_prodsel == kc_phy_info->last_operator) {
			kc_tmp = (kc_voidptr_t)KC_SUBPHYLUM(kc_p, kc_lastop_info->suboffset[0]);
			kc_p = (kc_voidptr_t)KC_SUBPHYLUM(kc_p, kc_lastop_info->suboffset[1]);
		} else {
			kc_invalid_operator(kc_error_last, kc_phylum, __LINE__, __FILE__, (int)kc_prodsel);/*NOTREACHED*/
	}	}
	return kc_tmp;
}

static kc_voidptr_t kc_do_map_phylum
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_p, kc_voidptr_t (*kc_fp)(kc_voidptr_t), kc_enum_phyla kc_phylum)
#else
(kc_p, kc_fp, kc_phylum) kc_voidptr_t kc_p; kc_voidptr_t (*kc_fp)KC__P((kc_voidptr_t)); kc_enum_phyla kc_phylum;
#endif
{	kc_enum_operators kc_prodsel;
	/*SUPPRESS 622*/
	assertPhylum(((casestring)kc_p),"kc_p",kc_phylum);
	kc_prodsel = ((casestring)kc_p)->prod_sel;
	if (kc_prodsel == kc_PhylumInfo[(int)kc_phylum].first_operator) {
		return kc_p;
	} else if (kc_prodsel == kc_PhylumInfo[(int)kc_phylum].last_operator) {
		return (kc_voidptr_t)(*kc_OperatorInfo[(int)kc_prodsel].create_routine)(
			kc_prodsel,
			(*kc_fp)((kc_voidptr_t)KC_SUBPHYLUM(kc_p, kc_OperatorInfo[(int)kc_prodsel].suboffset[0])),
			kc_do_map_phylum((kc_voidptr_t)KC_SUBPHYLUM(kc_p, kc_OperatorInfo[(int)kc_prodsel].suboffset[1]), kc_fp, kc_phylum));
	} else {
		kc_invalid_operator(kc_error_map, kc_phylum, __LINE__, __FILE__, (int)kc_prodsel);/*NOTREACHED*/return (kc_voidptr_t)0;
}	}

static kc_voidptr_t kc_do_filter_phylum
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_p,  boolean (*kc_fp)(kc_voidptr_t), kc_enum_phyla kc_phylum)
#else
(kc_p, kc_fp, kc_phylum) kc_voidptr_t kc_p; boolean (*kc_fp)KC__P((kc_voidptr_t)); kc_enum_phyla kc_phylum;
#endif
{	kc_enum_operators kc_prodsel;
	/*SUPPRESS 622*/
	assertPhylum(((casestring)kc_p),"kc_p",kc_phylum);
	kc_prodsel = ((casestring)kc_p)->prod_sel;
	if (kc_prodsel == kc_PhylumInfo[(int)kc_phylum].first_operator) {
		return kc_p;
	} else if (kc_prodsel == kc_PhylumInfo[(int)kc_phylum].last_operator) {
		if ((*kc_fp)((kc_voidptr_t)KC_SUBPHYLUM(kc_p, kc_OperatorInfo[(int)kc_prodsel].suboffset[0]))) {
			return (kc_voidptr_t)(*kc_OperatorInfo[(int)kc_prodsel].create_routine)(
				kc_prodsel,
				(kc_voidptr_t)KC_SUBPHYLUM(kc_p, kc_OperatorInfo[(int)kc_prodsel].suboffset[0]),
				kc_do_filter_phylum((kc_voidptr_t)KC_SUBPHYLUM(kc_p, kc_OperatorInfo[(int)kc_prodsel].suboffset[1]), kc_fp, kc_phylum));
		} else {
			return kc_do_filter_phylum((kc_voidptr_t)KC_SUBPHYLUM(kc_p, kc_OperatorInfo[(int)kc_prodsel].suboffset[1]), kc_fp, kc_phylum);
		}
	} else {
		kc_invalid_operator(kc_error_filter, kc_phylum, __LINE__, __FILE__, (int)kc_prodsel);/*NOTREACHED*/return (kc_voidptr_t)0;
}	}

decllist concat_decllist
#ifdef KC_USE_PROTOTYPES
(decllist kc_p1, decllist kc_p2)
#else
(kc_p1, kc_p2) decllist kc_p1, kc_p2;
#endif
{ return (decllist)kc_do_concat_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_decllist ); }
decllist reverse_decllist
#ifdef KC_USE_PROTOTYPES
(decllist kc_p)
#else
(kc_p) decllist kc_p;
#endif
{ return (decllist)kc_do_reverse_phylum( (kc_voidptr_t)kc_p, kc_phylum_decllist ); }
int length_decllist
#ifdef KC_USE_PROTOTYPES
(decllist kc_p)
#else
(kc_p) decllist kc_p;
#endif
{ return kc_do_length_phylum( (kc_voidptr_t)kc_p, kc_phylum_decllist ); }
decl last_decllist
#ifdef KC_USE_PROTOTYPES
(decllist kc_p)
#else
(kc_p) decllist kc_p;
#endif
{ return (decl)kc_do_last_phylum( (kc_voidptr_t)kc_p, kc_phylum_decllist ); }
decllist map_decllist
#ifdef KC_USE_PROTOTYPES
(decllist kc_p, decl (*kc_fp)(decl))
#else
(kc_p, kc_fp) decllist kc_p; decl (*kc_fp)KC__P((decl));
#endif
{ return (decllist)kc_do_map_phylum( (kc_voidptr_t)kc_p, (kc_voidptr_t (*)KC__P((kc_voidptr_t)))kc_fp, kc_phylum_decllist ); }
decllist filter_decllist
#ifdef KC_USE_PROTOTYPES
(decllist kc_p, boolean (*kc_fp)(decl))
#else
(kc_p, kc_fp) decllist kc_p; boolean (*kc_fp)KC__P((decl));
#endif
{ return (decllist)kc_do_filter_phylum( (kc_voidptr_t)kc_p, (boolean (*)KC__P((kc_voidptr_t)))kc_fp, kc_phylum_decllist ); }
void freelist_decllist
#ifdef KC_USE_PROTOTYPES
(decllist kc_p)
#else
(kc_p) decllist kc_p;
#endif
{ kc_do_freelist_phylum( (kc_voidptr_t)kc_p, kc_phylum_decllist ); }
asslist concat_asslist
#ifdef KC_USE_PROTOTYPES
(asslist kc_p1, asslist kc_p2)
#else
(kc_p1, kc_p2) asslist kc_p1, kc_p2;
#endif
{ return (asslist)kc_do_concat_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_asslist ); }
asslist reverse_asslist
#ifdef KC_USE_PROTOTYPES
(asslist kc_p)
#else
(kc_p) asslist kc_p;
#endif
{ return (asslist)kc_do_reverse_phylum( (kc_voidptr_t)kc_p, kc_phylum_asslist ); }
int length_asslist
#ifdef KC_USE_PROTOTYPES
(asslist kc_p)
#else
(kc_p) asslist kc_p;
#endif
{ return kc_do_length_phylum( (kc_voidptr_t)kc_p, kc_phylum_asslist ); }
assign last_asslist
#ifdef KC_USE_PROTOTYPES
(asslist kc_p)
#else
(kc_p) asslist kc_p;
#endif
{ return (assign)kc_do_last_phylum( (kc_voidptr_t)kc_p, kc_phylum_asslist ); }
asslist map_asslist
#ifdef KC_USE_PROTOTYPES
(asslist kc_p, assign (*kc_fp)(assign))
#else
(kc_p, kc_fp) asslist kc_p; assign (*kc_fp)KC__P((assign));
#endif
{ return (asslist)kc_do_map_phylum( (kc_voidptr_t)kc_p, (kc_voidptr_t (*)KC__P((kc_voidptr_t)))kc_fp, kc_phylum_asslist ); }
asslist filter_asslist
#ifdef KC_USE_PROTOTYPES
(asslist kc_p, boolean (*kc_fp)(assign))
#else
(kc_p, kc_fp) asslist kc_p; boolean (*kc_fp)KC__P((assign));
#endif
{ return (asslist)kc_do_filter_phylum( (kc_voidptr_t)kc_p, (boolean (*)KC__P((kc_voidptr_t)))kc_fp, kc_phylum_asslist ); }
void freelist_asslist
#ifdef KC_USE_PROTOTYPES
(asslist kc_p)
#else
(kc_p) asslist kc_p;
#endif
{ kc_do_freelist_phylum( (kc_voidptr_t)kc_p, kc_phylum_asslist ); }
transitions concat_transitions
#ifdef KC_USE_PROTOTYPES
(transitions kc_p1, transitions kc_p2)
#else
(kc_p1, kc_p2) transitions kc_p1, kc_p2;
#endif
{ return (transitions)kc_do_concat_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_transitions ); }
transitions reverse_transitions
#ifdef KC_USE_PROTOTYPES
(transitions kc_p)
#else
(kc_p) transitions kc_p;
#endif
{ return (transitions)kc_do_reverse_phylum( (kc_voidptr_t)kc_p, kc_phylum_transitions ); }
int length_transitions
#ifdef KC_USE_PROTOTYPES
(transitions kc_p)
#else
(kc_p) transitions kc_p;
#endif
{ return kc_do_length_phylum( (kc_voidptr_t)kc_p, kc_phylum_transitions ); }
transition last_transitions
#ifdef KC_USE_PROTOTYPES
(transitions kc_p)
#else
(kc_p) transitions kc_p;
#endif
{ return (transition)kc_do_last_phylum( (kc_voidptr_t)kc_p, kc_phylum_transitions ); }
transitions map_transitions
#ifdef KC_USE_PROTOTYPES
(transitions kc_p, transition (*kc_fp)(transition))
#else
(kc_p, kc_fp) transitions kc_p; transition (*kc_fp)KC__P((transition));
#endif
{ return (transitions)kc_do_map_phylum( (kc_voidptr_t)kc_p, (kc_voidptr_t (*)KC__P((kc_voidptr_t)))kc_fp, kc_phylum_transitions ); }
transitions filter_transitions
#ifdef KC_USE_PROTOTYPES
(transitions kc_p, boolean (*kc_fp)(transition))
#else
(kc_p, kc_fp) transitions kc_p; boolean (*kc_fp)KC__P((transition));
#endif
{ return (transitions)kc_do_filter_phylum( (kc_voidptr_t)kc_p, (boolean (*)KC__P((kc_voidptr_t)))kc_fp, kc_phylum_transitions ); }
void freelist_transitions
#ifdef KC_USE_PROTOTYPES
(transitions kc_p)
#else
(kc_p) transitions kc_p;
#endif
{ kc_do_freelist_phylum( (kc_voidptr_t)kc_p, kc_phylum_transitions ); }
locations concat_locations
#ifdef KC_USE_PROTOTYPES
(locations kc_p1, locations kc_p2)
#else
(kc_p1, kc_p2) locations kc_p1, kc_p2;
#endif
{ return (locations)kc_do_concat_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_locations ); }
locations reverse_locations
#ifdef KC_USE_PROTOTYPES
(locations kc_p)
#else
(kc_p) locations kc_p;
#endif
{ return (locations)kc_do_reverse_phylum( (kc_voidptr_t)kc_p, kc_phylum_locations ); }
int length_locations
#ifdef KC_USE_PROTOTYPES
(locations kc_p)
#else
(kc_p) locations kc_p;
#endif
{ return kc_do_length_phylum( (kc_voidptr_t)kc_p, kc_phylum_locations ); }
location last_locations
#ifdef KC_USE_PROTOTYPES
(locations kc_p)
#else
(kc_p) locations kc_p;
#endif
{ return (location)kc_do_last_phylum( (kc_voidptr_t)kc_p, kc_phylum_locations ); }
locations map_locations
#ifdef KC_USE_PROTOTYPES
(locations kc_p, location (*kc_fp)(location))
#else
(kc_p, kc_fp) locations kc_p; location (*kc_fp)KC__P((location));
#endif
{ return (locations)kc_do_map_phylum( (kc_voidptr_t)kc_p, (kc_voidptr_t (*)KC__P((kc_voidptr_t)))kc_fp, kc_phylum_locations ); }
locations filter_locations
#ifdef KC_USE_PROTOTYPES
(locations kc_p, boolean (*kc_fp)(location))
#else
(kc_p, kc_fp) locations kc_p; boolean (*kc_fp)KC__P((location));
#endif
{ return (locations)kc_do_filter_phylum( (kc_voidptr_t)kc_p, (boolean (*)KC__P((kc_voidptr_t)))kc_fp, kc_phylum_locations ); }
void freelist_locations
#ifdef KC_USE_PROTOTYPES
(locations kc_p)
#else
(kc_p) locations kc_p;
#endif
{ kc_do_freelist_phylum( (kc_voidptr_t)kc_p, kc_phylum_locations ); }
events concat_events
#ifdef KC_USE_PROTOTYPES
(events kc_p1, events kc_p2)
#else
(kc_p1, kc_p2) events kc_p1, kc_p2;
#endif
{ return (events)kc_do_concat_phylum( (kc_voidptr_t)kc_p1, (kc_voidptr_t)kc_p2, kc_phylum_events ); }
events reverse_events
#ifdef KC_USE_PROTOTYPES
(events kc_p)
#else
(kc_p) events kc_p;
#endif
{ return (events)kc_do_reverse_phylum( (kc_voidptr_t)kc_p, kc_phylum_events ); }
int length_events
#ifdef KC_USE_PROTOTYPES
(events kc_p)
#else
(kc_p) events kc_p;
#endif
{ return kc_do_length_phylum( (kc_voidptr_t)kc_p, kc_phylum_events ); }
event last_events
#ifdef KC_USE_PROTOTYPES
(events kc_p)
#else
(kc_p) events kc_p;
#endif
{ return (event)kc_do_last_phylum( (kc_voidptr_t)kc_p, kc_phylum_events ); }
events map_events
#ifdef KC_USE_PROTOTYPES
(events kc_p, event (*kc_fp)(event))
#else
(kc_p, kc_fp) events kc_p; event (*kc_fp)KC__P((event));
#endif
{ return (events)kc_do_map_phylum( (kc_voidptr_t)kc_p, (kc_voidptr_t (*)KC__P((kc_voidptr_t)))kc_fp, kc_phylum_events ); }
events filter_events
#ifdef KC_USE_PROTOTYPES
(events kc_p, boolean (*kc_fp)(event))
#else
(kc_p, kc_fp) events kc_p; boolean (*kc_fp)KC__P((event));
#endif
{ return (events)kc_do_filter_phylum( (kc_voidptr_t)kc_p, (boolean (*)KC__P((kc_voidptr_t)))kc_fp, kc_phylum_events ); }
void freelist_events
#ifdef KC_USE_PROTOTYPES
(events kc_p)
#else
(kc_p) events kc_p;
#endif
{ kc_do_freelist_phylum( (kc_voidptr_t)kc_p, kc_phylum_events ); }
intarray concat_intarray
#ifdef KC_USE_PROTOTYPES
(intarray kc_p1, intarray kc_p2)
#else
(kc_p1, kc_p2) intarray kc_p1, kc_p2;
#endif
{	/*SUPPRESS 622*/
	assert_intarray(kc_p1,"kc_p1");
	if (kc_p1->prod_sel == sel_Nilintarray) {
		return kc_p2;
	} else if (kc_p1->prod_sel ==  sel_Consintarray) {
		return Consintarray(
			kc_p1->u.Consintarray.int_1,
			concat_intarray(kc_p1->u.Consintarray.intarray_1, kc_p2) );
	} else {
		kc_invalid_operator(kc_error_concat, kc_phylum_intarray, __LINE__, __FILE__, (int)kc_p1->prod_sel);/*NOTREACHED*/return (intarray)0;
}	}
intarray reverse_intarray
#ifdef KC_USE_PROTOTYPES
(intarray kc_p)
#else
(kc_p) intarray kc_p;
#endif
{	boolean kc_not_ready = True;
	intarray kc_tmp = Nilintarray();
	while(kc_not_ready) {
		/*SUPPRESS 622*/
		assert_intarray(((casestring)kc_p),"kc_p");
		if (kc_p->prod_sel == sel_Nilintarray) {
			kc_not_ready=False;
		} else if (kc_p->prod_sel == sel_Consintarray) {
			kc_tmp = Consintarray(kc_p->u.Consintarray.int_1, kc_tmp);
			kc_p = kc_p->u.Consintarray.intarray_1;
		} else {
			kc_invalid_operator(kc_error_reverse, kc_phylum_intarray, __LINE__, __FILE__, (int)kc_p->prod_sel);/*NOTREACHED*/
	}	}
	return kc_tmp;
}
int length_intarray
#ifdef KC_USE_PROTOTYPES
(intarray kc_p)
#else
(kc_p) intarray kc_p;
#endif
{ return kc_do_length_phylum( (kc_voidptr_t)kc_p, kc_phylum_intarray ); }
int last_intarray
#ifdef KC_USE_PROTOTYPES
(intarray kc_p)
#else
(kc_p) intarray kc_p;
#endif
{	boolean kc_not_ready = True;
	int kc_tmp = (int)0;
	/*SUPPRESS 622*/
	assert_intarray(kc_p,"kc_p");
	if (kc_p->prod_sel == sel_Nilintarray) {
		(void)fflush(stdout); (void)fprintf(stderr, kc_error_last_with_nil_argument, "intarray",  "intarray"); exit( 1 ); /*NOTREACHED*/
	}
	while(kc_not_ready) {
		/*SUPPRESS 622*/
		assert_intarray(kc_p,"kc_p");
		if (kc_p->prod_sel == sel_Nilintarray) {
			kc_not_ready=False;
		} else if (kc_p->prod_sel == sel_Consintarray) {
			kc_tmp = kc_p->u.Consintarray.int_1;
			kc_p = kc_p->u.Consintarray.intarray_1;
		} else {
			kc_invalid_operator(kc_error_last, kc_phylum_intarray, __LINE__, __FILE__, (int)kc_p->prod_sel);/*NOTREACHED*/
	}	}
	return kc_tmp;
}
intarray map_intarray
#ifdef KC_USE_PROTOTYPES
(intarray kc_p, int (*kc_fp)(int))
#else
(kc_p, kc_fp) intarray kc_p; int (*kc_fp)KC__P((int));
#endif
{	/*SUPPRESS 622*/
	assert_intarray(kc_p,"kc_p");
	if (kc_p->prod_sel == sel_Nilintarray) {
		return kc_p;
	} else if (kc_p->prod_sel == sel_Consintarray) {
		return Consintarray(
			(*kc_fp)(kc_p->u.Consintarray.int_1),
			map_intarray(kc_p->u.Consintarray.intarray_1, kc_fp));
	} else {
		kc_invalid_operator(kc_error_map, kc_phylum_intarray, __LINE__, __FILE__, (int)kc_p->prod_sel);/*NOTREACHED*/return (intarray)0;
}	}
intarray filter_intarray
#ifdef KC_USE_PROTOTYPES
(intarray kc_p, boolean (*kc_fp)(int))
#else
(kc_p, kc_fp) intarray kc_p; boolean (*kc_fp)KC__P((int));
#endif
{	/*SUPPRESS 622*/
	assert_intarray(kc_p,"kc_p");
	if (kc_p->prod_sel == sel_Nilintarray) {
		return kc_p;
	} else if (kc_p->prod_sel == sel_Consintarray) {
		if ((*kc_fp)(kc_p->u.Consintarray.int_1)) {
			return Consintarray(
				kc_p->u.Consintarray.int_1,
				filter_intarray(kc_p->u.Consintarray.intarray_1, kc_fp));
		} else {
			return filter_intarray(kc_p->u.Consintarray.intarray_1, kc_fp);
		}
	} else {
		kc_invalid_operator(kc_error_filter, kc_phylum_intarray, __LINE__, __FILE__, (int)kc_p->prod_sel);/*NOTREACHED*/return (intarray)0;
}	}
void freelist_intarray
#ifdef KC_USE_PROTOTYPES
(intarray kc_p)
#else
(kc_p) intarray kc_p;
#endif
{ kc_do_freelist_phylum( (kc_voidptr_t)kc_p, kc_phylum_intarray ); }
/*ARGSUSED*/ kc_voidptr_t kc_do_copy_phylum
#ifdef KC_USE_PROTOTYPES
(kc_voidptr_t kc_p, boolean kc_copy_attributes, kc_enum_phyla kc_phylum)
#else
(kc_p, kc_copy_attributes, kc_phylum) kc_voidptr_t kc_p; boolean kc_copy_attributes; kc_enum_phyla kc_phylum;
#endif
{	kc_voidptr_t kc_subtmp[3];
	kc_voidptr_t kc_answer = 0;
	int kc_i;
	kc_enum_operators kc_prodsel;
	KC_OPERATOR_INFO *kc_op_info;
	int kc_st;
	kc_hashtable_t kc_a_ht;
	/* SHOULD be done using bigatoms? */
	/*SUPPRESS 622*/
	assertReason(kc_phylum != kc_phylum_int, "kc_do_copy_phylum called with kc_phylum_int argument");
	/*SUPPRESS 622*/
	assertReason(kc_phylum != kc_phylum_float, "kc_do_copy_phylum called with kc_phylum_float argument");
	/*SUPPRESS 622*/
	assertPhylum(((casestring)kc_p),"kc_p",kc_phylum);
	if ((kc_phylum == kc_phylum_voidptr)) {
		return kc_p;
	}
	kc_prodsel = ((casestring)kc_p)->prod_sel;
	kc_op_info = &kc_OperatorInfo[(int)kc_prodsel];
	kc_st = (int)kc_op_info->uniq_stored;
	kc_a_ht = kc_hashtables[kc_st];
	if (kc_st
	   && (/* kc_storageclass_still_uniq[kc_st]
	       || */ ((kc_a_ht->in_block != 0)
		  && (*kc_a_ht->in_block)((kc_voidptr_t)kc_p, kc_a_ht->malloc_private_data)))) {
		return kc_p;
	} else if (kc_phylum == kc_phylum_casestring) {
		return (kc_voidptr_t)mkcasestring(((casestring)kc_p)->name);
	} else if (kc_phylum == kc_phylum_nocasestring) {
		return (kc_voidptr_t)mknocasestring(((nocasestring)kc_p)->name);
	}
	switch(kc_prodsel) {
	case (int)sel_LFreq: {
		int kc_sub_int_1;
		kc_sub_int_1 = copy_int(((freq)kc_p)->u.LFreq.int_1, kc_copy_attributes);
		kc_answer = (kc_voidptr_t) LFreq( kc_sub_int_1);
	break; }
	case (int)sel_UFreq: {
		int kc_sub_int_1;
		kc_sub_int_1 = copy_int(((freq)kc_p)->u.UFreq.int_1, kc_copy_attributes);
		kc_answer = (kc_voidptr_t) UFreq( kc_sub_int_1);
	break; }
	case (int)sel_Freq: {
		int kc_sub_int_1;
		int kc_sub_int_2;
		kc_sub_int_1 = copy_int(((freq)kc_p)->u.Freq.int_1, kc_copy_attributes);
		kc_sub_int_2 = copy_int(((freq)kc_p)->u.Freq.int_2, kc_copy_attributes);
		kc_answer = (kc_voidptr_t) Freq( kc_sub_int_1, kc_sub_int_2);
	break; }
	case (int)sel_IndexMap: {
		int kc_sub_int_1;
		kc_sub_int_1 = copy_int(((idx2event)kc_p)->u.IndexMap.int_1, kc_copy_attributes);
		kc_answer = (kc_voidptr_t) IndexMap( kc_sub_int_1);
	break; }
	case (int)sel_Location: {
		int kc_sub_int_1;
		kc_sub_int_1 = copy_int(((location)kc_p)->u.Location.int_1, kc_copy_attributes);
		kc_answer = (kc_voidptr_t) Location( kc_sub_int_1);
	break; }
	case (int)sel_GreaterEqual: {
		int kc_sub_int_1;
		int kc_sub_int_2;
		kc_sub_int_1 = copy_int(((action)kc_p)->u.GreaterEqual.int_1, kc_copy_attributes);
		kc_sub_int_2 = copy_int(((action)kc_p)->u.GreaterEqual.int_2, kc_copy_attributes);
		kc_answer = (kc_voidptr_t) GreaterEqual( kc_sub_int_1, kc_sub_int_2);
	break; }
	case (int)sel_Incr: {
		int kc_sub_int_1;
		kc_sub_int_1 = copy_int(((action)kc_p)->u.Incr.int_1, kc_copy_attributes);
		kc_answer = (kc_voidptr_t) Incr( kc_sub_int_1);
	break; }
	case (int)sel_LessThan: {
		int kc_sub_int_1;
		int kc_sub_int_2;
		kc_sub_int_1 = copy_int(((action)kc_p)->u.LessThan.int_1, kc_copy_attributes);
		kc_sub_int_2 = copy_int(((action)kc_p)->u.LessThan.int_2, kc_copy_attributes);
		kc_answer = (kc_voidptr_t) LessThan( kc_sub_int_1, kc_sub_int_2);
	break; }
	case (int)sel_Reset: {
		int kc_sub_int_1;
		kc_sub_int_1 = copy_int(((action)kc_p)->u.Reset.int_1, kc_copy_attributes);
		kc_answer = (kc_voidptr_t) Reset( kc_sub_int_1);
	break; }
	case (int)sel_MapTransition: {
		int kc_sub_int_1;
		kc_sub_int_1 = copy_int(((map)kc_p)->u.MapTransition.int_1, kc_copy_attributes);
		kc_answer = (kc_voidptr_t) MapTransition( kc_sub_int_1);
	break; }
	case (int)sel_MapEvent: {
		int kc_sub_int_1;
		kc_sub_int_1 = copy_int(((map)kc_p)->u.MapEvent.int_1, kc_copy_attributes);
		kc_answer = (kc_voidptr_t) MapEvent( kc_sub_int_1);
	break; }
	case (int)sel_CounterLabel: {
		int kc_sub_int_1;
		kc_sub_int_1 = copy_int(((label)kc_p)->u.CounterLabel.int_1, kc_copy_attributes);
		kc_subtmp[1] = kc_do_copy_phylum((kc_voidptr_t)((label)kc_p)->u.CounterLabel.action_1, kc_copy_attributes, kc_phylum_action);
		kc_answer = (kc_voidptr_t) CounterLabel( kc_sub_int_1, (action)kc_subtmp[1]);
	break; }
	case (int)sel_Consintarray: {
		int kc_sub_int_1;
		kc_sub_int_1 = copy_int(((intarray)kc_p)->u.Consintarray.int_1, kc_copy_attributes);
		kc_subtmp[1] = kc_do_copy_phylum((kc_voidptr_t)((intarray)kc_p)->u.Consintarray.intarray_1, kc_copy_attributes, kc_phylum_intarray);
		kc_answer = (kc_voidptr_t) Consintarray( kc_sub_int_1, (intarray)kc_subtmp[1]);
	break; }
	default:
	for (kc_i = 0; kc_i < kc_op_info->no_sons; kc_i++) {
		kc_subtmp[kc_i] = kc_do_copy_phylum((kc_voidptr_t)KC_SUBPHYLUM(kc_p, kc_op_info->suboffset[kc_i]), kc_copy_attributes, kc_op_info->subphylum[kc_i] );
	}
	switch(kc_op_info->no_sons) {
	case 0: kc_answer = (kc_voidptr_t) (*kc_op_info->create_routine)( kc_prodsel); break;
	case 1: kc_answer = (kc_voidptr_t) (*kc_op_info->create_routine)( kc_prodsel, kc_subtmp[0] ); break;
	case 2: kc_answer = (kc_voidptr_t) (*kc_op_info->create_routine)( kc_prodsel, kc_subtmp[0], kc_subtmp[1] ); break;
	case 3: kc_answer = (kc_voidptr_t) (*kc_op_info->create_routine)( kc_prodsel, kc_subtmp[0], kc_subtmp[1], kc_subtmp[2] ); break;
	default:
		/*SUPPRESS 622*/
		assertReason(kc_zero_constant, "unexpected number of sub-phyla");/*NOTREACHED*/
	}
	break;
	}
	if (kc_copy_attributes && (kc_PhylumInfo[(int)kc_phylum].copy_attributes != 0)) {
		(*kc_PhylumInfo[(int)kc_phylum].copy_attributes)(kc_p, kc_answer);
	}
	return kc_answer;
}

/*ARGSUSED*/
nocasestring copy_nocasestring
#ifdef KC_USE_PROTOTYPES
(nocasestring kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) nocasestring kc_p; boolean kc_copy_attributes;
#endif
{	return (nocasestring)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_nocasestring); }
/*ARGSUSED*/
casestring copy_casestring
#ifdef KC_USE_PROTOTYPES
(casestring kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) casestring kc_p; boolean kc_copy_attributes;
#endif
{	return (casestring)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_casestring); }
/*ARGSUSED*/
float copy_float
#ifdef KC_USE_PROTOTYPES
(float kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) float kc_p; boolean kc_copy_attributes;
#endif
{	return kc_p; }
/*ARGSUSED*/
int copy_int
#ifdef KC_USE_PROTOTYPES
(int kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) int kc_p; boolean kc_copy_attributes;
#endif
{	return kc_p; }
/*ARGSUSED*/
voidptr copy_voidptr
#ifdef KC_USE_PROTOTYPES
(voidptr kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) voidptr kc_p; boolean kc_copy_attributes;
#endif
{	return (voidptr)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_voidptr); }
spec copy_spec
#ifdef KC_USE_PROTOTYPES
(spec kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) spec kc_p; boolean kc_copy_attributes;
#endif
{	return (spec)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_spec); }
decllist copy_decllist
#ifdef KC_USE_PROTOTYPES
(decllist kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) decllist kc_p; boolean kc_copy_attributes;
#endif
{	return (decllist)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_decllist); }
decl copy_decl
#ifdef KC_USE_PROTOTYPES
(decl kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) decl kc_p; boolean kc_copy_attributes;
#endif
{	return (decl)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_decl); }
asslist copy_asslist
#ifdef KC_USE_PROTOTYPES
(asslist kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) asslist kc_p; boolean kc_copy_attributes;
#endif
{	return (asslist)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_asslist); }
assign copy_assign
#ifdef KC_USE_PROTOTYPES
(assign kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) assign kc_p; boolean kc_copy_attributes;
#endif
{	return (assign)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_assign); }
expr copy_expr
#ifdef KC_USE_PROTOTYPES
(expr kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) expr kc_p; boolean kc_copy_attributes;
#endif
{	return (expr)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_expr); }
freq copy_freq
#ifdef KC_USE_PROTOTYPES
(freq kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) freq kc_p; boolean kc_copy_attributes;
#endif
{	return (freq)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_freq); }
id copy_id
#ifdef KC_USE_PROTOTYPES
(id kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) id kc_p; boolean kc_copy_attributes;
#endif
{	return (id)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_id); }
idtype copy_idtype
#ifdef KC_USE_PROTOTYPES
(idtype kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) idtype kc_p; boolean kc_copy_attributes;
#endif
{	return (idtype)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_idtype); }
uid copy_uid
#ifdef KC_USE_PROTOTYPES
(uid kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) uid kc_p; boolean kc_copy_attributes;
#endif
{	return (uid)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_uid); }
idx2event copy_idx2event
#ifdef KC_USE_PROTOTYPES
(idx2event kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) idx2event kc_p; boolean kc_copy_attributes;
#endif
{	return (idx2event)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_idx2event); }
transitions copy_transitions
#ifdef KC_USE_PROTOTYPES
(transitions kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) transitions kc_p; boolean kc_copy_attributes;
#endif
{	return (transitions)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_transitions); }
locations copy_locations
#ifdef KC_USE_PROTOTYPES
(locations kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) locations kc_p; boolean kc_copy_attributes;
#endif
{	return (locations)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_locations); }
location copy_location
#ifdef KC_USE_PROTOTYPES
(location kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) location kc_p; boolean kc_copy_attributes;
#endif
{	return (location)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_location); }
transition copy_transition
#ifdef KC_USE_PROTOTYPES
(transition kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) transition kc_p; boolean kc_copy_attributes;
#endif
{	return (transition)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_transition); }
action copy_action
#ifdef KC_USE_PROTOTYPES
(action kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) action kc_p; boolean kc_copy_attributes;
#endif
{	return (action)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_action); }
map copy_map
#ifdef KC_USE_PROTOTYPES
(map kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) map kc_p; boolean kc_copy_attributes;
#endif
{	return (map)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_map); }
event copy_event
#ifdef KC_USE_PROTOTYPES
(event kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) event kc_p; boolean kc_copy_attributes;
#endif
{	return (event)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_event); }
visibility copy_visibility
#ifdef KC_USE_PROTOTYPES
(visibility kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) visibility kc_p; boolean kc_copy_attributes;
#endif
{	return (visibility)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_visibility); }
events copy_events
#ifdef KC_USE_PROTOTYPES
(events kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) events kc_p; boolean kc_copy_attributes;
#endif
{	return (events)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_events); }
state copy_state
#ifdef KC_USE_PROTOTYPES
(state kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) state kc_p; boolean kc_copy_attributes;
#endif
{	return (state)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_state); }
label copy_label
#ifdef KC_USE_PROTOTYPES
(label kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) label kc_p; boolean kc_copy_attributes;
#endif
{	return (label)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_label); }
intarray copy_intarray
#ifdef KC_USE_PROTOTYPES
(intarray kc_p, boolean kc_copy_attributes)
#else
(kc_p, kc_copy_attributes) intarray kc_p; boolean kc_copy_attributes;
#endif
{	return (intarray)kc_do_copy_phylum( (kc_voidptr_t)kc_p, kc_copy_attributes, kc_phylum_intarray); }
